(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/common', '@angular/core'], factory) :
    (factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.badge = {}),global.ng.common,global.ng.core));
}(this, (function (exports,common,core) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtBadgeComponent = /** @class */ (function () {
        function NtBadgeComponent(platformId, _elementRef, _renderer) {
            this.platformId = platformId;
            this._elementRef = _elementRef;
            this._renderer = _renderer;
            this._type = 'static';
            this.color = '';
            /**
             * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
             *
             * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
             * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
             * @deprecated > 0.6.0
             */
            this.class = '';
        }
        Object.defineProperty(NtBadgeComponent.prototype, "type", {
            get: /**
             * @return {?}
             */
            function () { return this._type; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (value === 'float' || value === 'notify') {
                    this._resetPosition();
                }
                else {
                    this._clearPosition();
                }
                this._type = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NtBadgeComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            this._resetPosition();
        };
        /**
         * @return {?}
         */
        NtBadgeComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this._clearPosition();
        };
        // 重置容器的 position 属性
        // 重置容器的 position 属性
        /**
         * @private
         * @return {?}
         */
        NtBadgeComponent.prototype._resetPosition = 
        // 重置容器的 position 属性
        /**
         * @private
         * @return {?}
         */
        function () {
            if (common.isPlatformBrowser(this.platformId)) {
                /** @type {?} */
                var style = window.getComputedStyle(this._elementRef.nativeElement.parentElement);
                if (style.position !== 'absolute' || style.position !== 'absolute') {
                    this._originalPosition = style.position;
                    this._renderer.setStyle(this._elementRef.nativeElement.parentElement, 'position', 'relative');
                }
            }
        };
        // 清理 position 属性
        // 清理 position 属性
        /**
         * @private
         * @return {?}
         */
        NtBadgeComponent.prototype._clearPosition = 
        // 清理 position 属性
        /**
         * @private
         * @return {?}
         */
        function () {
            if (common.isPlatformBrowser(this.platformId)) {
                if (this._originalPosition) {
                    this._renderer.removeStyle(this._elementRef.nativeElement.parentElement, 'position');
                }
            }
        };
        NtBadgeComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-badge, [nt-badge]',
                        template: "<ng-content></ng-content>",
                        encapsulation: core.ViewEncapsulation.None,
                        host: {
                            '[class]': '["badge", color, class].join(" ")',
                            '[class.badge-float]': 'type === "float"',
                            '[class.badge-notify]': 'type === "notify"'
                        }
                    },] },
        ];
        /** @nocollapse */
        NtBadgeComponent.ctorParameters = function () { return [
            { type: Object, decorators: [{ type: core.Inject, args: [core.PLATFORM_ID,] }] },
            { type: core.ElementRef },
            { type: core.Renderer2 }
        ]; };
        NtBadgeComponent.propDecorators = {
            color: [{ type: core.Input }],
            class: [{ type: core.Input }],
            type: [{ type: core.Input }]
        };
        return NtBadgeComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtBadgeModule = /** @class */ (function () {
        function NtBadgeModule() {
        }
        NtBadgeModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        declarations: [NtBadgeComponent],
                        exports: [NtBadgeComponent]
                    },] },
        ];
        return NtBadgeModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NtBadgeModule = NtBadgeModule;
    exports.NtBadgeComponent = NtBadgeComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=badge.umd.js.map
