(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/coercion'), require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/cdk/coercion', '@angular/core', '@angular/common'], factory) :
    (factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.button = {}),global.ng.cdk.coercion,global.ng.core,global.ng.common));
}(this, (function (exports,coercion,core,common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtButtonGroupComponent = /** @class */ (function () {
        function NtButtonGroupComponent() {
            this._expanded = false;
            /**
             * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
             *
             * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
             * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
             * @deprecated > 0.6.0
             */
            this.class = '';
            this.color = '';
            this.size = '';
        }
        Object.defineProperty(NtButtonGroupComponent.prototype, "expanded", {
            get: /**
             * @return {?}
             */
            function () { return this._expanded; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._expanded = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        NtButtonGroupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-button-group, [nt-button-group]',
                        template: "<ng-content></ng-content>",
                        encapsulation: core.ViewEncapsulation.None,
                        host: {
                            '[class]': '["button-group", color, size, class].join(" ")',
                            '[class.expanded]': 'expanded'
                        }
                    },] },
        ];
        NtButtonGroupComponent.propDecorators = {
            class: [{ type: core.Input }],
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            expanded: [{ type: core.Input }]
        };
        return NtButtonGroupComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtButtonComponent = /** @class */ (function () {
        function NtButtonComponent() {
            this._style = '';
            this._expanded = false;
            /**
             * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
             *
             * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
             * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
             * @deprecated >= 0.6.0
             */
            this.class = '';
            this.color = '';
            this.size = '';
        }
        Object.defineProperty(NtButtonComponent.prototype, "button", {
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (this._validStyle(value)) {
                    this._style = value;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtButtonComponent.prototype, "style", {
            get: /**
             * @return {?}
             */
            function () { return this._style; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._style = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtButtonComponent.prototype, "expanded", {
            get: /**
             * @return {?}
             */
            function () { return this._expanded; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._expanded = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @param {?} value
         * @return {?}
         */
        NtButtonComponent.prototype._validStyle = /**
         * @private
         * @param {?} value
         * @return {?}
         */
        function (value) {
            return ['', 'hollow', 'clear'].indexOf(value) > -1;
        };
        NtButtonComponent.decorators = [
            { type: core.Component, args: [{
                        selector: '[nt-button]',
                        template: "<ng-content></ng-content>",
                        encapsulation: core.ViewEncapsulation.None,
                        host: {
                            '[class]': '["button", color, style, size, class].join(" ")',
                            '[class.expanded]': 'expanded'
                        }
                    },] },
        ];
        NtButtonComponent.propDecorators = {
            class: [{ type: core.Input }],
            color: [{ type: core.Input }],
            size: [{ type: core.Input }],
            button: [{ type: core.Input, args: ['nt-button',] }],
            style: [{ type: core.Input }],
            expanded: [{ type: core.Input }]
        };
        return NtButtonComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtButtonModule = /** @class */ (function () {
        function NtButtonModule() {
        }
        NtButtonModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        exports: [NtButtonComponent, NtButtonGroupComponent],
                        declarations: [NtButtonComponent, NtButtonGroupComponent],
                    },] },
        ];
        return NtButtonModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NtButtonModule = NtButtonModule;
    exports.NtButtonComponent = NtButtonComponent;
    exports.NtButtonGroupComponent = NtButtonGroupComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=button.umd.js.map
