(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/animations'), require('@angular/core'), require('rxjs'), require('@angular/cdk/platform'), require('@angular/cdk/coercion'), require('@angular/common'), require('rxjs/operators'), require('@angular/cdk/keycodes'), require('@angular/cdk/overlay'), require('@angular/common/http')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/animations', '@angular/core', 'rxjs', '@angular/cdk/platform', '@angular/cdk/coercion', '@angular/common', 'rxjs/operators', '@angular/cdk/keycodes', '@angular/cdk/overlay', '@angular/common/http'], factory) :
    (factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.core = {}),global.ng.animations,global.ng.core,global.Rx,global.ng.cdk.platform,global.ng.cdk.coercion,global.ng.common,global.Rx.operators,global.ng.cdk.keycodes,global.ng.cdk.overlay,global.ng.common.http));
}(this, (function (exports,animations,core,rxjs,platform,coercion,common,operators,keycodes,overlay,http) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} name
     * @param {?} axis
     * @param {?} letter
     * @return {?}
     */
    function transformAxis(name, axis, letter) {
        return axis === 'x'
            ? name + "(" + letter + ", 0, 0)"
            : name + "(0, " + letter + ", 0)";
    }
    /**
     * @param {?} axis
     * @param {?} letter
     * @return {?}
     */
    function translate3d(axis, letter) {
        return transformAxis('translate3d', axis, letter);
    }
    /** @type {?} */
    var DEFAULT_TIMING = .5;

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * 淡入淡出动画
     * @param {?} options 动画配置参数
     * @return {?}
     */
    function fade(options) {
        return animations.animation(animations.animate((options.timing || DEFAULT_TIMING) + "s " + (options.delay || 0) + "s", animations.keyframes([
            animations.style({ opacity: "" + options.fromOpacity, transform: translate3d(options.axis, options.steps.a), offset: 0 }),
            animations.style({ opacity: "" + options.toOpacity, transform: translate3d(options.axis, options.steps.b), offset: 1 }),
        ])));
    }
    /**
     * 带方向的淡入动画
     * @param {?} axis 动画方向
     * @param {?} steps 动画移动距离
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeInDirection(axis, steps, timing, delay) {
        return fade({ fromOpacity: 0, toOpacity: 1, axis: axis, steps: steps, timing: timing, delay: delay });
    }
    /**
     * 从 X 轴方向淡入
     * @param {?} steps 动画移动距离
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeInX(steps, timing, delay) {
        return fadeInDirection('x', steps, timing, delay);
    }
    /**
     * 从 Y 轴方向淡入
     * @param {?} steps 动画移动距离
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeInY(steps, timing, delay) {
        return fadeInDirection('y', steps, timing, delay);
    }
    /**
     * 静态淡入动画
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeIn(timing, delay) {
        return fadeInX({ a: 0, b: 0 }, timing, delay);
    }
    /**
     * 从下淡入的动画
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeInDown(timing, delay) {
        return fadeInY({ a: '-100%', b: 0 }, timing, delay);
    }
    /**
     * 从上淡入的动画
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeInUp(timing, delay) {
        return fadeInY({ a: '100%', b: 0 }, timing, delay);
    }
    /**
     * 从左淡入的动画
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeInLeft(timing, delay) {
        return fadeInX({ a: '-100%', b: 0 }, timing, delay);
    }
    /**
     * 从右淡入的动画
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeInRight(timing, delay) {
        return fadeInX({ a: '100%', b: 0 }, timing, delay);
    }
    /**
     * 带方向的淡出动画
     * @param {?} axis 动画方向
     * @param {?} steps 动画移动距离
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeOutDirection(axis, steps, timing, delay) {
        return fade({ fromOpacity: 1, toOpacity: 0, axis: axis, steps: steps, timing: timing, delay: delay });
    }
    /**
     * 从 X 轴方向淡出
     * @param {?} steps 动画移动距离
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeOutX(steps, timing, delay) {
        return fadeOutDirection('x', steps, timing, delay);
    }
    /**
     * 从 Y 轴方向淡出
     * @param {?} steps 动画移动距离
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeOutY(steps, timing, delay) {
        return fadeOutDirection('y', steps, timing, delay);
    }
    /**
     * 静态淡出动画
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeOut(timing, delay) {
        return fadeOutX({ a: 0, b: 0 }, timing, delay);
    }
    /**
     * 从下淡出的动画
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeOutDown(timing, delay) {
        return fadeOutY({ a: '-100%', b: 0 }, timing, delay);
    }
    /**
     * 从上淡出的动画
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeOutUp(timing, delay) {
        return fadeOutY({ a: '100%', b: 0 }, timing, delay);
    }
    /**
     * 从左淡出的动画
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeOutLeft(timing, delay) {
        return fadeOutX({ a: '-100%', b: 0 }, timing, delay);
    }
    /**
     * 从右淡出的动画
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function fadeOutRight(timing, delay) {
        return fadeOutX({ a: '100%', b: 0 }, timing, delay);
    }
    /**
     * 滑动动画
     * @param {?} axis 动画方向
     * @param {?} steps 动画移动距离
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function slideDirection(axis, steps, timing, delay) {
        return fade({ fromOpacity: 1, toOpacity: 1, axis: axis, steps: steps, timing: timing, delay: delay });
    }
    /**
     * 从 X 轴方向滑动
     * @param {?} steps 动画移动距离
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function slideX(steps, timing, delay) {
        return slideDirection('x', steps, timing, delay);
    }
    /**
     * 从 Y 轴方向滑动
     * @param {?} steps 动画移动距离
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function slideY(steps, timing, delay) {
        return slideDirection('y', steps, timing, delay);
    }
    /**
     * 从下开始滑动
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function slideInDown(timing, delay) {
        return slideY({ a: '100%', b: 0 }, timing, delay);
    }
    /**
     * 从上开始滑动
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function slideInUp(timing, delay) {
        return slideY({ a: '-100%', b: 0 }, timing, delay);
    }
    /**
     * 从左开始滑动
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function slideInLeft(timing, delay) {
        return slideX({ a: '-100%', b: 0 }, timing, delay);
    }
    /**
     * 从右开始滑动
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function slideInRight(timing, delay) {
        return slideX({ a: '100%', b: 0 }, timing, delay);
    }
    /**
     * 滑动到上面
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function slideOutUp(timing, delay) {
        return slideY({ a: 0, b: '-100%' }, timing, delay);
    }
    /**
     * 滑动到下面
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function slideOutDown(timing, delay) {
        return slideY({ a: 0, b: '100%' }, timing, delay);
    }
    /**
     * 滑动到左边
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function slideOutLeft(timing, delay) {
        return slideX({ a: 0, b: '-100%' }, timing, delay);
    }
    /**
     * 滑动到右边
     * @param {?=} timing 动画执行时间
     * @param {?=} delay 延迟执行时间
     * @return {?}
     */
    function slideOutRight(timing, delay) {
        return slideX({ a: 0, b: '100%' }, timing, delay);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * InjectionToken for datepicker that can be used to override default locale code.
     * @type {?}
     */
    var NT_DATE_LOCALE = new core.InjectionToken('nt-date-locale', {
        providedIn: 'root',
        factory: NT_DATE_LOCALE_FACTORY
    });
    /**
     * \@docs-private
     * @return {?}
     */
    function NT_DATE_LOCALE_FACTORY() {
        return core.inject(core.LOCALE_ID);
    }
    /**
     * Adapts type `D` to be usable as a date by cdk-based components that work with dates.
     * @abstract
     * @template D
     */
    var  /**
     * Adapts type `D` to be usable as a date by cdk-based components that work with dates.
     * @abstract
     * @template D
     */
    DateAdapter = /** @class */ (function () {
        function DateAdapter() {
            this._localeChanges = new rxjs.Subject();
        }
        Object.defineProperty(DateAdapter.prototype, "localeChanges", {
            /** A stream that emits when the locale changes. */
            get: /**
             * A stream that emits when the locale changes.
             * @return {?}
             */
            function () { return this._localeChanges; },
            enumerable: true,
            configurable: true
        });
        /**
         * Attempts to deserialize a value to a valid date object. This is different from parsing in that
         * deserialize should only accept non-ambiguous, locale-independent formats (e.g. a ISO 8601
         * string). The default implementation does not allow any deserialization, it simply checks that
         * the given value is already a valid date object or null. The `<nt-datepicker>` will call this
         * method on all of it's `@Input()` properties that accept dates. It is therefore possible to
         * support passing values from your backend directly to these properties by overriding this method
         * to also deserialize the format used by your backend.
         * @param value The value to be deserialized into a date object.
         * @returns The deserialized date object, either a valid date, null if the value can be
         *     deserialized into a null date (e.g. the empty string), or an invalid date.
         */
        /**
         * Attempts to deserialize a value to a valid date object. This is different from parsing in that
         * deserialize should only accept non-ambiguous, locale-independent formats (e.g. a ISO 8601
         * string). The default implementation does not allow any deserialization, it simply checks that
         * the given value is already a valid date object or null. The `<nt-datepicker>` will call this
         * method on all of it's `\@Input()` properties that accept dates. It is therefore possible to
         * support passing values from your backend directly to these properties by overriding this method
         * to also deserialize the format used by your backend.
         * @param {?} value The value to be deserialized into a date object.
         * @return {?} The deserialized date object, either a valid date, null if the value can be
         *     deserialized into a null date (e.g. the empty string), or an invalid date.
         */
        DateAdapter.prototype.deserialize = /**
         * Attempts to deserialize a value to a valid date object. This is different from parsing in that
         * deserialize should only accept non-ambiguous, locale-independent formats (e.g. a ISO 8601
         * string). The default implementation does not allow any deserialization, it simply checks that
         * the given value is already a valid date object or null. The `<nt-datepicker>` will call this
         * method on all of it's `\@Input()` properties that accept dates. It is therefore possible to
         * support passing values from your backend directly to these properties by overriding this method
         * to also deserialize the format used by your backend.
         * @param {?} value The value to be deserialized into a date object.
         * @return {?} The deserialized date object, either a valid date, null if the value can be
         *     deserialized into a null date (e.g. the empty string), or an invalid date.
         */
        function (value) {
            if (value == null || this.isDateInstance(value) && this.isValid(value)) {
                return value;
            }
            return this.invalid();
        };
        /**
         * Sets the locale used for all dates.
         * @param locale The new locale.
         */
        /**
         * Sets the locale used for all dates.
         * @param {?} locale The new locale.
         * @return {?}
         */
        DateAdapter.prototype.setLocale = /**
         * Sets the locale used for all dates.
         * @param {?} locale The new locale.
         * @return {?}
         */
        function (locale) {
            this.locale = locale;
            this._localeChanges.next();
        };
        /**
         * Compares two dates.
         * @param first The first date to compare.
         * @param second The second date to compare.
         * @returns 0 if the dates are equal, a number less than 0 if the first date is earlier,
         *     a number greater than 0 if the first date is later.
         */
        /**
         * Compares two dates.
         * @param {?} first The first date to compare.
         * @param {?} second The second date to compare.
         * @return {?} 0 if the dates are equal, a number less than 0 if the first date is earlier,
         *     a number greater than 0 if the first date is later.
         */
        DateAdapter.prototype.compareDate = /**
         * Compares two dates.
         * @param {?} first The first date to compare.
         * @param {?} second The second date to compare.
         * @return {?} 0 if the dates are equal, a number less than 0 if the first date is earlier,
         *     a number greater than 0 if the first date is later.
         */
        function (first, second) {
            return this.getYear(first) - this.getYear(second) ||
                this.getMonth(first) - this.getMonth(second) ||
                this.getDate(first) - this.getDate(second);
        };
        /**
         * Checks if two dates are equal.
         * @param first The first date to check.
         * @param second The second date to check.
         * @returns Whether the two dates are equal.
         *     Null dates are considered equal to other null dates.
         */
        /**
         * Checks if two dates are equal.
         * @param {?} first The first date to check.
         * @param {?} second The second date to check.
         * @return {?} Whether the two dates are equal.
         *     Null dates are considered equal to other null dates.
         */
        DateAdapter.prototype.sameDate = /**
         * Checks if two dates are equal.
         * @param {?} first The first date to check.
         * @param {?} second The second date to check.
         * @return {?} Whether the two dates are equal.
         *     Null dates are considered equal to other null dates.
         */
        function (first, second) {
            if (first && second) {
                /** @type {?} */
                var firstValid = this.isValid(first);
                /** @type {?} */
                var secondValid = this.isValid(second);
                if (firstValid && secondValid) {
                    return !this.compareDate(first, second);
                }
                return firstValid === secondValid;
            }
            return first === second;
        };
        /**
         * Clamp the given date between min and max dates.
         * @param date The date to clamp.
         * @param min The minimum value to allow. If null or omitted no min is enforced.
         * @param max The maximum value to allow. If null or omitted no max is enforced.
         * @returns `min` if `date` is less than `min`, `max` if date is greater than `max`,
         *     otherwise `date`.
         */
        /**
         * Clamp the given date between min and max dates.
         * @param {?} date The date to clamp.
         * @param {?=} min The minimum value to allow. If null or omitted no min is enforced.
         * @param {?=} max The maximum value to allow. If null or omitted no max is enforced.
         * @return {?} `min` if `date` is less than `min`, `max` if date is greater than `max`,
         *     otherwise `date`.
         */
        DateAdapter.prototype.clampDate = /**
         * Clamp the given date between min and max dates.
         * @param {?} date The date to clamp.
         * @param {?=} min The minimum value to allow. If null or omitted no min is enforced.
         * @param {?=} max The maximum value to allow. If null or omitted no max is enforced.
         * @return {?} `min` if `date` is less than `min`, `max` if date is greater than `max`,
         *     otherwise `date`.
         */
        function (date, min, max) {
            if (min && this.compareDate(date, min) < 0) {
                return min;
            }
            if (max && this.compareDate(date, max) > 0) {
                return max;
            }
            return date;
        };
        return DateAdapter;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var NT_DATE_FORMATS = new core.InjectionToken('nt-date-formats');

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // TODO(mmalerba): Remove when we no longer support safari 9.
    /**
     * Whether the browser supports the Intl API.
     * @type {?}
     */
    var SUPPORTS_INTL_API = typeof Intl !== 'undefined';
    /**
     * The default month names to use if Intl API is not available.
     * @type {?}
     */
    var DEFAULT_MONTH_NAMES = {
        'long': [
            '一月', '二月', '三月', '四月', '五月', '六月', '七月', '八月', '九月',
            '十月', '十一月', '十二月'
        ],
        'short': ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
        'narrow': ['1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12']
    };
    var ɵ0 = /**
     * @param {?} i
     * @return {?}
     */
    function (i) { return String(i + 1); };
    /**
     * The default date names to use if Intl API is not available.
     * @type {?}
     */
    var DEFAULT_DATE_NAMES = range(31, (ɵ0));
    /**
     * The default day of the week names to use if Intl API is not available.
     * @type {?}
     */
    var DEFAULT_DAY_OF_WEEK_NAMES = {
        'long': ['星期日', '星期一', '星期二', '星期三', '星期四', '星期五', '星期六'],
        'short': ['周日', '周一', '周二', '周三', '周四', '周五', '周六'],
        'narrow': ['日', '一', '二', '三', '四', '五', '六']
    };
    /**
     * Matches strings that have the form of a valid RFC 3339 string
     * (https://tools.ietf.org/html/rfc3339). Note that the string may not actually be a valid date
     * because the regex will match strings an with out of bounds month, date, etc.
     * @type {?}
     */
    var ISO_8601_REGEX = /^\d{4}-\d{2}-\d{2}(?:T\d{2}:\d{2}:\d{2}(?:\.\d+)?(?:Z|(?:(?:\+|-)\d{2}:\d{2}))?)?$/;
    // like ISO 8601
    /** @type {?} */
    var LIKE_ISO_8601_REGEX = /^\d{4}-\d{2}-\d{2}(?:T\d{2}:\d{2}:\d{2}(?:\.\d+)?(?:(?:\+|-)\d{4})?)?$/;
    /**
     * Creates an array and fills it with values.
     * @template T
     * @param {?} length
     * @param {?} valueFunction
     * @return {?}
     */
    function range(length, valueFunction) {
        /** @type {?} */
        var valuesArray = Array(length);
        for (var i = 0; i < length; i++) {
            valuesArray[i] = valueFunction(i);
        }
        return valuesArray;
    }
    /**
     * Adapts the native JS Date for use with cdk-based components that work with dates.
     */
    var NativeDateAdapter = /** @class */ (function (_super) {
        __extends(NativeDateAdapter, _super);
        function NativeDateAdapter(ntDateLocale, platform$$1) {
            var _this = _super.call(this) || this;
            /**
             * Whether to use `timeZone: 'utc'` with `Intl.DateTimeFormat` when formatting dates.
             * Without this `Intl.DateTimeFormat` sometimes chooses the wrong timeZone, which can throw off
             * the result. (e.g. in the en-US locale `new Date(1800, 7, 14).toLocaleDateString()`
             * will produce `'8/13/1800'`.
             *
             * TODO(mmalerba): drop this variable. It's not being used in the code right now. We're now
             * getting the string representation of a Date object from it's utc representation. We're keeping
             * it here for sometime, just for precaution, in case we decide to revert some of these changes
             * though.
             */
            _this.useUtcForDisplay = true;
            _super.prototype.setLocale.call(_this, ntDateLocale);
            // IE does its own time zone correction, so we disable this on IE.
            _this.useUtcForDisplay = !platform$$1.TRIDENT;
            _this._clampDate = platform$$1.TRIDENT || platform$$1.EDGE;
            return _this;
        }
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.getYear = /**
         * @param {?} date
         * @return {?}
         */
        function (date) {
            return date.getFullYear();
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.getMonth = /**
         * @param {?} date
         * @return {?}
         */
        function (date) {
            return date.getMonth();
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.getDate = /**
         * @param {?} date
         * @return {?}
         */
        function (date) {
            return date.getDate();
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.getMilliseconds = /**
         * @param {?} date
         * @return {?}
         */
        function (date) {
            return date.getTime();
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.getDayOfWeek = /**
         * @param {?} date
         * @return {?}
         */
        function (date) {
            return date.getDay();
        };
        /**
         * @param {?} style
         * @param {?=} locale
         * @return {?}
         */
        NativeDateAdapter.prototype.getMonthNames = /**
         * @param {?} style
         * @param {?=} locale
         * @return {?}
         */
        function (style, locale) {
            var _this = this;
            if (locale === void 0) { locale = this.locale; }
            if (SUPPORTS_INTL_API) {
                /** @type {?} */
                var dtf_1 = new Intl.DateTimeFormat(locale, { month: style, timeZone: 'utc' });
                return range(12, (/**
                 * @param {?} i
                 * @return {?}
                 */
                function (i) {
                    return _this._stripDirectionalityCharacters(_this._format(dtf_1, new Date(2017, i, 1)));
                }));
            }
            return DEFAULT_MONTH_NAMES[style];
        };
        /** 因为暂时不清楚在中文语言环境下设定纯数字日期名称，故先强制使用 英文日期  */
        /**
         * 因为暂时不清楚在中文语言环境下设定纯数字日期名称，故先强制使用 英文日期
         * @param {?=} locale
         * @return {?}
         */
        NativeDateAdapter.prototype.getDateNames = /**
         * 因为暂时不清楚在中文语言环境下设定纯数字日期名称，故先强制使用 英文日期
         * @param {?=} locale
         * @return {?}
         */
        function (locale) {
            var _this = this;
            if (locale === void 0) { locale = 'en-US'; }
            if (SUPPORTS_INTL_API) {
                /** @type {?} */
                var dtf_2 = new Intl.DateTimeFormat(locale, { day: 'numeric', timeZone: 'utc' });
                return range(31, (/**
                 * @param {?} i
                 * @return {?}
                 */
                function (i) { return _this._stripDirectionalityCharacters(_this._format(dtf_2, new Date(2017, 0, i + 1))); }));
            }
            return DEFAULT_DATE_NAMES;
        };
        /**
         * @param {?} style
         * @param {?=} locale
         * @return {?}
         */
        NativeDateAdapter.prototype.getDayOfWeekNames = /**
         * @param {?} style
         * @param {?=} locale
         * @return {?}
         */
        function (style, locale) {
            var _this = this;
            if (locale === void 0) { locale = this.locale; }
            if (SUPPORTS_INTL_API) {
                /** @type {?} */
                var dtf_3 = new Intl.DateTimeFormat(locale, { weekday: style, timeZone: 'utc' });
                return range(7, (/**
                 * @param {?} i
                 * @return {?}
                 */
                function (i) { return _this._stripDirectionalityCharacters(_this._format(dtf_3, new Date(2017, 0, i + 1))); }));
            }
            return DEFAULT_DAY_OF_WEEK_NAMES[style];
        };
        /**
         * @param {?} date
         * @param {?=} locale
         * @return {?}
         */
        NativeDateAdapter.prototype.getYearName = /**
         * @param {?} date
         * @param {?=} locale
         * @return {?}
         */
        function (date, locale) {
            if (locale === void 0) { locale = this.locale; }
            if (SUPPORTS_INTL_API) {
                /** @type {?} */
                var dtf = new Intl.DateTimeFormat(locale, { year: 'numeric', timeZone: 'utc' });
                return this._stripDirectionalityCharacters(this._format(dtf, date));
            }
            return String(this.getYear(date));
        };
        /**
         * @return {?}
         */
        NativeDateAdapter.prototype.getFirstDayOfWeek = /**
         * @return {?}
         */
        function () {
            // We can't tell using native JS Date what the first day of the week is, we default to Sunday.
            return 0;
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.getNumDaysInMonth = /**
         * @param {?} date
         * @return {?}
         */
        function (date) {
            return this.getDate(this._createDateWithOverflow(this.getYear(date), this.getMonth(date) + 1, 0));
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.clone = /**
         * @param {?} date
         * @return {?}
         */
        function (date) {
            return this.createDate(this.getYear(date), this.getMonth(date), this.getDate(date));
        };
        /**
         * @param {?} year
         * @param {?} month
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.createDate = /**
         * @param {?} year
         * @param {?} month
         * @param {?} date
         * @return {?}
         */
        function (year, month, date) {
            // Check for invalid month and date (except upper bound on date which we have to check after
            // creating the Date).
            if (month < 0 || month > 11) {
                throw Error("Invalid month index \"" + month + "\". Month index has to be between 0 and 11.");
            }
            if (date < 1) {
                throw Error("Invalid date \"" + date + "\". Date has to be greater than 0.");
            }
            /** @type {?} */
            var result = this._createDateWithOverflow(year, month, date);
            // Check that the date wasn't above the upper bound for the month, causing the month to overflow
            if (result.getMonth() !== month) {
                throw Error("Invalid date \"" + date + "\" for month with index \"" + month + "\".");
            }
            return result;
        };
        /**
         * @return {?}
         */
        NativeDateAdapter.prototype.today = /**
         * @return {?}
         */
        function () {
            return new Date();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        NativeDateAdapter.prototype.parse = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            // We have no way using the native JS Date to set the parse format or locale, so we ignore these
            // parameters.
            if (typeof value === 'number') {
                return new Date(value);
            }
            return value ? new Date(Date.parse(value)) : null;
        };
        /**
         * @param {?} date
         * @param {?} displayFormat
         * @param {?=} locale
         * @return {?}
         */
        NativeDateAdapter.prototype.format = /**
         * @param {?} date
         * @param {?} displayFormat
         * @param {?=} locale
         * @return {?}
         */
        function (date, displayFormat, locale) {
            if (locale === void 0) { locale = this.locale; }
            if (!this.isValid(date)) {
                throw Error('NativeDateAdapter: Cannot format invalid date.');
            }
            if (SUPPORTS_INTL_API) {
                // On IE and Edge the i18n API will throw a hard error that can crash the entire app
                // if we attempt to format a date whose year is less than 1 or greater than 9999.
                if (this._clampDate && (date.getFullYear() < 1 || date.getFullYear() > 9999)) {
                    date = this.clone(date);
                    date.setFullYear(Math.max(1, Math.min(9999, date.getFullYear())));
                }
                displayFormat = __assign({}, displayFormat, { timeZone: 'utc' });
                /** @type {?} */
                var dtf = new Intl.DateTimeFormat(locale, displayFormat);
                return this._stripDirectionalityCharacters(this._format(dtf, date));
            }
            return this._stripDirectionalityCharacters(date.toDateString());
        };
        /**
         * @param {?} date
         * @param {?} years
         * @return {?}
         */
        NativeDateAdapter.prototype.addCalendarYears = /**
         * @param {?} date
         * @param {?} years
         * @return {?}
         */
        function (date, years) {
            return this.addCalendarMonths(date, years * 12);
        };
        /**
         * @param {?} date
         * @param {?} months
         * @return {?}
         */
        NativeDateAdapter.prototype.addCalendarMonths = /**
         * @param {?} date
         * @param {?} months
         * @return {?}
         */
        function (date, months) {
            /** @type {?} */
            var newDate = this._createDateWithOverflow(this.getYear(date), this.getMonth(date) + months, this.getDate(date));
            // It's possible to wind up in the wrong month if the original month has more days than the new
            // month. In this case we want to go to the last day of the desired month.
            // Note: the additional + 12 % 12 ensures we end up with a positive number, since JS % doesn't
            // guarantee this.
            if (this.getMonth(newDate) !== ((this.getMonth(date) + months) % 12 + 12) % 12) {
                newDate = this._createDateWithOverflow(this.getYear(newDate), this.getMonth(newDate), 0);
            }
            return newDate;
        };
        /**
         * @param {?} date
         * @param {?} days
         * @return {?}
         */
        NativeDateAdapter.prototype.addCalendarDays = /**
         * @param {?} date
         * @param {?} days
         * @return {?}
         */
        function (date, days) {
            return this._createDateWithOverflow(this.getYear(date), this.getMonth(date), this.getDate(date) + days);
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.toIso8601 = /**
         * @param {?} date
         * @return {?}
         */
        function (date) {
            return [
                date.getUTCFullYear(),
                this._2digit(date.getUTCMonth() + 1),
                this._2digit(date.getUTCDate())
            ].join('-');
        };
        /**
         * Returns the given value if given a valid Date or null. Deserializes valid ISO 8601 strings
         * (https://www.ietf.org/rfc/rfc3339.txt) into valid Dates and empty string into null. Returns an
         * invalid date for all other values.
         */
        /**
         * Returns the given value if given a valid Date or null. Deserializes valid ISO 8601 strings
         * (https://www.ietf.org/rfc/rfc3339.txt) into valid Dates and empty string into null. Returns an
         * invalid date for all other values.
         * @param {?} value
         * @return {?}
         */
        NativeDateAdapter.prototype.deserialize = /**
         * Returns the given value if given a valid Date or null. Deserializes valid ISO 8601 strings
         * (https://www.ietf.org/rfc/rfc3339.txt) into valid Dates and empty string into null. Returns an
         * invalid date for all other values.
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (typeof value === 'string') {
                if (!value) {
                    return null;
                }
                // like ISO 8601 value, 2018-05-30T12:00:00.000+0000 -> 2018-05-30T12:00:00.000+00:00
                if (LIKE_ISO_8601_REGEX.test(value)) {
                    value = value.slice(0, value.length - 2) + ":" + value.slice(value.length - 2);
                }
                // The `Date` constructor accepts formats other than ISO 8601, so we need to make sure the
                // string is the right format first.
                if (ISO_8601_REGEX.test(value)) {
                    /** @type {?} */
                    var date = new Date(value);
                    if (this.isValid(date)) {
                        return date;
                    }
                }
            }
            return _super.prototype.deserialize.call(this, value);
        };
        /**
         * @param {?} obj
         * @return {?}
         */
        NativeDateAdapter.prototype.isDateInstance = /**
         * @param {?} obj
         * @return {?}
         */
        function (obj) {
            return obj instanceof Date;
        };
        /**
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype.isValid = /**
         * @param {?} date
         * @return {?}
         */
        function (date) {
            return !isNaN(date.getTime());
        };
        /**
         * @return {?}
         */
        NativeDateAdapter.prototype.invalid = /**
         * @return {?}
         */
        function () {
            return new Date(NaN);
        };
        /** Creates a date but allows the month and date to overflow. */
        /**
         * Creates a date but allows the month and date to overflow.
         * @private
         * @param {?} year
         * @param {?} month
         * @param {?} date
         * @return {?}
         */
        NativeDateAdapter.prototype._createDateWithOverflow = /**
         * Creates a date but allows the month and date to overflow.
         * @private
         * @param {?} year
         * @param {?} month
         * @param {?} date
         * @return {?}
         */
        function (year, month, date) {
            /** @type {?} */
            var result = new Date(year, month, date);
            // We need to correct for the fact that JS native Date treats years in range [0, 99] as
            // abbreviations for 19xx.
            if (year >= 0 && year < 100) {
                result.setFullYear(this.getYear(result) - 1900);
            }
            return result;
        };
        /**
         * Pads a number to make it two digits.
         * @param n The number to pad.
         * @returns The padded number.
         */
        /**
         * Pads a number to make it two digits.
         * @private
         * @param {?} n The number to pad.
         * @return {?} The padded number.
         */
        NativeDateAdapter.prototype._2digit = /**
         * Pads a number to make it two digits.
         * @private
         * @param {?} n The number to pad.
         * @return {?} The padded number.
         */
        function (n) {
            return ('00' + n).slice(-2);
        };
        /**
         * Strip out unicode LTR and RTL characters. Edge and IE insert these into formatted dates while
         * other browsers do not. We remove them to make output consistent and because they interfere with
         * date parsing.
         * @param str The string to strip direction characters from.
         * @returns The stripped string.
         */
        /**
         * Strip out unicode LTR and RTL characters. Edge and IE insert these into formatted dates while
         * other browsers do not. We remove them to make output consistent and because they interfere with
         * date parsing.
         * @private
         * @param {?} str The string to strip direction characters from.
         * @return {?} The stripped string.
         */
        NativeDateAdapter.prototype._stripDirectionalityCharacters = /**
         * Strip out unicode LTR and RTL characters. Edge and IE insert these into formatted dates while
         * other browsers do not. We remove them to make output consistent and because they interfere with
         * date parsing.
         * @private
         * @param {?} str The string to strip direction characters from.
         * @return {?} The stripped string.
         */
        function (str) {
            return str.replace(/[\u200e\u200f]/g, '');
        };
        /**
         * When converting Date object to string, javascript built-in functions may return wrong
         * results because it applies its internal DST rules. The DST rules around the world change
         * very frequently, and the current valid rule is not always valid in previous years though.
         * We work around this problem building a new Date object which has its internal UTC
         * representation with the local date and time.
         * @param dtf Intl.DateTimeFormat object, containg the desired string format. It must have
         *    timeZone set to 'utc' to work fine.
         * @param date Date from which we want to get the string representation according to dtf
         * @returns A Date object with its UTC representation based on the passed in date info
         */
        /**
         * When converting Date object to string, javascript built-in functions may return wrong
         * results because it applies its internal DST rules. The DST rules around the world change
         * very frequently, and the current valid rule is not always valid in previous years though.
         * We work around this problem building a new Date object which has its internal UTC
         * representation with the local date and time.
         * @private
         * @param {?} dtf Intl.DateTimeFormat object, containg the desired string format. It must have
         *    timeZone set to 'utc' to work fine.
         * @param {?} date Date from which we want to get the string representation according to dtf
         * @return {?} A Date object with its UTC representation based on the passed in date info
         */
        NativeDateAdapter.prototype._format = /**
         * When converting Date object to string, javascript built-in functions may return wrong
         * results because it applies its internal DST rules. The DST rules around the world change
         * very frequently, and the current valid rule is not always valid in previous years though.
         * We work around this problem building a new Date object which has its internal UTC
         * representation with the local date and time.
         * @private
         * @param {?} dtf Intl.DateTimeFormat object, containg the desired string format. It must have
         *    timeZone set to 'utc' to work fine.
         * @param {?} date Date from which we want to get the string representation according to dtf
         * @return {?} A Date object with its UTC representation based on the passed in date info
         */
        function (dtf, date) {
            /** @type {?} */
            var d = new Date(Date.UTC(date.getFullYear(), date.getMonth(), date.getDate(), date.getHours(), date.getMinutes(), date.getSeconds(), date.getMilliseconds()));
            return dtf.format(d);
        };
        NativeDateAdapter.decorators = [
            { type: core.Injectable },
        ];
        /** @nocollapse */
        NativeDateAdapter.ctorParameters = function () { return [
            { type: String, decorators: [{ type: core.Optional }, { type: core.Inject, args: [NT_DATE_LOCALE,] }] },
            { type: platform.Platform }
        ]; };
        return NativeDateAdapter;
    }(DateAdapter));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @license
     * Copyright Google LLC All Rights Reserved.
     *
     * Use of this source code is governed by an MIT-style license that can be
     * found in the LICENSE file at https://angular.io/license
     */
    /** @type {?} */
    var NT_NATIVE_DATE_FORMATS = {
        parse: {
            dateInput: null,
        },
        display: {
            dateInput: { year: 'numeric', month: 'numeric', day: 'numeric' },
            monthYearLabel: { year: 'numeric', month: 'short' },
            monthLabel: { month: 'short' }
        }
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NativeDateModule = /** @class */ (function () {
        function NativeDateModule() {
        }
        NativeDateModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [platform.PlatformModule],
                        providers: [
                            { provide: DateAdapter, useClass: NativeDateAdapter }
                        ],
                    },] },
        ];
        return NativeDateModule;
    }());
    var ɵ0$1 = NT_NATIVE_DATE_FORMATS;
    var NtNativeDateModule = /** @class */ (function () {
        function NtNativeDateModule() {
        }
        NtNativeDateModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [NativeDateModule],
                        providers: [
                            { provide: NT_DATE_FORMATS, useValue: ɵ0$1 }
                        ],
                    },] },
        ];
        return NtNativeDateModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtOptionSelectionChange = /** @class */ (function () {
        function NtOptionSelectionChange(source, isUserInput) {
            if (isUserInput === void 0) { isUserInput = false; }
            this.source = source;
            this.isUserInput = isUserInput;
        }
        return NtOptionSelectionChange;
    }());
    /** @type {?} */
    var NT_OPTION_PARENT_COMPONENT = new core.InjectionToken('nt-option-parent-component');
    var NtOptionComponent = /** @class */ (function () {
        function NtOptionComponent(_element, _changeDetectorRef, _parent) {
            this._element = _element;
            this._changeDetectorRef = _changeDetectorRef;
            this._parent = _parent;
            this._selected = false;
            this._disabled = false;
            this._label = '';
            this._hidden = false;
            this._mostRecentViewValue = '';
            this._isActive = false;
            this.stateChanges = new rxjs.Subject();
            this.selectionChange = new core.EventEmitter();
        }
        Object.defineProperty(NtOptionComponent.prototype, "label", {
            get: /**
             * @return {?}
             */
            function () {
                if (!this._label.trim()) {
                    return (this._element.nativeElement.textContent || '').trim();
                }
                return this._label.trim();
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._label = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtOptionComponent.prototype, "multiple", {
            get: /**
             * @return {?}
             */
            function () { return this._parent && this._parent.multiple; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtOptionComponent.prototype, "value", {
            get: /**
             * @return {?}
             */
            function () { return this._value; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._value = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtOptionComponent.prototype, "disabled", {
            get: /**
             * @return {?}
             */
            function () { return this._disabled; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._disabled = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtOptionComponent.prototype, "hidden", {
            get: /**
             * @return {?}
             */
            function () { return this._hidden; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._hidden = coercion.coerceBooleanProperty(value);
                this._disabled = this._hidden;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtOptionComponent.prototype, "selected", {
            get: /**
             * @return {?}
             */
            function () { return this._selected; },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NtOptionComponent.prototype.ngAfterViewChecked = /**
         * @return {?}
         */
        function () {
            if (this._selected) {
                /** @type {?} */
                var viewValue = this.label;
                if (viewValue !== this._mostRecentViewValue) {
                    this._mostRecentViewValue = viewValue;
                    this.stateChanges.next();
                }
            }
        };
        /**
         * @return {?}
         */
        NtOptionComponent.prototype.focus = /**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var element = this._element.nativeElement;
            if (typeof element.focus === 'function') {
                element.focus();
            }
        };
        /**
         * @return {?}
         */
        NtOptionComponent.prototype.select = /**
         * @return {?}
         */
        function () {
            this._selected = true;
            this._changeDetectorRef.markForCheck();
            this._emitSelectionChangeEvent();
        };
        /**
         * @return {?}
         */
        NtOptionComponent.prototype.deselect = /**
         * @return {?}
         */
        function () {
            this._selected = false;
            this._changeDetectorRef.markForCheck();
            this._emitSelectionChangeEvent();
        };
        /**
         * @return {?}
         */
        NtOptionComponent.prototype.selectViaInteraction = /**
         * @return {?}
         */
        function () {
            if (!this.disabled) {
                this._selected = this.multiple ? !this._selected : true;
                this._emitSelectionChangeEvent(true);
            }
        };
        /**
         * @return {?}
         */
        NtOptionComponent.prototype.setActiveStyles = /**
         * @return {?}
         */
        function () {
            this._isActive = true;
        };
        /**
         * @return {?}
         */
        NtOptionComponent.prototype.setInactiveStyles = /**
         * @return {?}
         */
        function () {
            this._isActive = false;
        };
        /**
         * @return {?}
         */
        NtOptionComponent.prototype.getLabel = /**
         * @return {?}
         */
        function () {
            return this.label;
        };
        /**
         * @return {?}
         */
        NtOptionComponent.prototype.getOffsetTop = /**
         * @return {?}
         */
        function () {
            return this._element.nativeElement.offsetTop;
        };
        /**
         * @return {?}
         */
        NtOptionComponent.prototype.getOffsetHeight = /**
         * @return {?}
         */
        function () {
            return this._element.nativeElement.offsetHeight;
        };
        /**
         * @protected
         * @param {?=} isUserInput
         * @return {?}
         */
        NtOptionComponent.prototype._emitSelectionChangeEvent = /**
         * @protected
         * @param {?=} isUserInput
         * @return {?}
         */
        function (isUserInput) {
            if (isUserInput === void 0) { isUserInput = false; }
            this.selectionChange.emit(new NtOptionSelectionChange(this, isUserInput));
        };
        NtOptionComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-option',
                        template: "<ng-content></ng-content>",
                        encapsulation: core.ViewEncapsulation.None,
                        host: {
                            'class': 'nt-option',
                            '[class.nt-option-selected]': 'selected',
                            '[class.nt-option-disabled]': 'disabled',
                            '[class.nt-option-active]': '_isActive',
                            '[class.nt-option-hidden]': 'hidden',
                            '(click)': 'selectViaInteraction()'
                        }
                    },] },
        ];
        /** @nocollapse */
        NtOptionComponent.ctorParameters = function () { return [
            { type: core.ElementRef },
            { type: core.ChangeDetectorRef },
            { type: undefined, decorators: [{ type: core.Optional }, { type: core.Inject, args: [NT_OPTION_PARENT_COMPONENT,] }] }
        ]; };
        NtOptionComponent.propDecorators = {
            label: [{ type: core.Input }],
            value: [{ type: core.Input }],
            disabled: [{ type: core.Input }],
            selectionChange: [{ type: core.Output }]
        };
        return NtOptionComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtOptionModule = /** @class */ (function () {
        function NtOptionModule() {
        }
        NtOptionModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule],
                        exports: [NtOptionComponent],
                        declarations: [NtOptionComponent]
                    },] },
        ];
        return NtOptionModule;
    }());

    var _a;
    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {string} */
    var NtOverlayPosition = {
        Bottom: 'bottom',
        BottomLeft: 'bottomLeft',
        BottomRight: 'bottomRight',
        Top: 'top',
        TopLeft: 'topLeft',
        TopRight: 'topRight',
        Left: 'left',
        LeftTop: 'leftTop',
        LeftBottom: 'leftBottom',
        Right: 'right',
        RightTop: 'rightTop',
        RightBottom: 'rightBottom',
    };
    /** @enum {string} */
    var NtOverlayOrientation = {
        Vertical: 'vertical',
        Horizontal: 'horizontal',
    };
    /**
     * 定义并返回一个 overlay 窗体定位
     * @param {?} originX 主体的中心x轴，窗体会相对于主体的中心点定位。
     * @param {?} originY 主体的中心y轴，窗体会相对于主体的中心点定位。
     * @param {?} overlayX 窗体的中心x轴。
     * @param {?} overlayY 窗体的中心y轴。
     * @return {?}
     */
    function getConnectionPositionPair(originX, originY, overlayX, overlayY) {
        return (/** @type {?} */ ({ originX: originX, originY: originY, overlayX: overlayX, overlayY: overlayY }));
    }
    /**
     * 获取定位名称拼接字符串
     * @param {?} pair 定位类型。
     * @return {?}
     */
    function getPositionClassName(pair) {
        return pair.originX + "-" + pair.originY + "-" + pair.overlayX + "-" + pair.overlayY;
    }
    /**
     *
     * @param {?} position
     * @return {?}
     */
    function getPositionOrientation(position) {
        return Object.keys(NT_OVERLAY_POSITION_PAIRS).indexOf(position) > 5
            ? NtOverlayOrientation.Horizontal
            : NtOverlayOrientation.Vertical;
    }
    /**
     * Overley 方向定位常量
     */
    var BOTTOM_LEFT = (_a = [
        getConnectionPositionPair('start', 'bottom', 'start', 'top'),
        getConnectionPositionPair('center', 'bottom', 'center', 'top'),
        getConnectionPositionPair('end', 'bottom', 'end', 'top'),
        getConnectionPositionPair('start', 'top', 'start', 'bottom'),
        getConnectionPositionPair('center', 'top', 'center', 'bottom'),
        getConnectionPositionPair('end', 'top', 'end', 'bottom'),
        getConnectionPositionPair('start', 'top', 'end', 'top'),
        getConnectionPositionPair('start', 'center', 'end', 'center'),
        getConnectionPositionPair('start', 'bottom', 'end', 'bottom'),
        getConnectionPositionPair('end', 'top', 'start', 'top'),
        getConnectionPositionPair('end', 'center', 'start', 'center'),
        getConnectionPositionPair('end', 'bottom', 'start', 'bottom')
    ], _a[0]), BOTTOM_CENTER = _a[1], BOTTOM_RIGHT = _a[2], TOP_LEFT = _a[3], TOP_CENTER = _a[4], TOP_RIGHT = _a[5], LEFT_TOP = _a[6], LEFT_CENTER = _a[7], LEFT_BOTTOM = _a[8], RIGHT_TOP = _a[9], RIGHT_CENTER = _a[10], RIGHT_BOTTOM = _a[11];
    /**
     * 定位策略
     * @type {?}
     */
    var NT_OVERLAY_POSITION_PAIRS = {
        bottom: [
            BOTTOM_CENTER, BOTTOM_LEFT, BOTTOM_RIGHT,
            TOP_CENTER, TOP_LEFT, TOP_RIGHT,
            RIGHT_CENTER, RIGHT_TOP, RIGHT_BOTTOM,
            LEFT_CENTER, LEFT_TOP, LEFT_BOTTOM
        ],
        bottomLeft: [
            BOTTOM_LEFT, BOTTOM_CENTER, BOTTOM_RIGHT,
            TOP_LEFT, TOP_CENTER, TOP_RIGHT,
            RIGHT_CENTER, RIGHT_TOP, RIGHT_BOTTOM,
            LEFT_CENTER, LEFT_TOP, LEFT_BOTTOM
        ],
        bottomRight: [
            BOTTOM_RIGHT, BOTTOM_CENTER, BOTTOM_LEFT,
            TOP_RIGHT, TOP_CENTER, TOP_LEFT,
            RIGHT_CENTER, RIGHT_TOP, RIGHT_BOTTOM,
            LEFT_CENTER, LEFT_TOP, LEFT_BOTTOM
        ],
        top: [
            TOP_CENTER, TOP_LEFT, TOP_RIGHT,
            BOTTOM_CENTER, BOTTOM_LEFT, BOTTOM_RIGHT,
            LEFT_CENTER, LEFT_TOP, LEFT_BOTTOM,
            RIGHT_CENTER, RIGHT_TOP, RIGHT_BOTTOM
        ],
        topLeft: [
            TOP_LEFT, TOP_CENTER, TOP_RIGHT,
            BOTTOM_LEFT, BOTTOM_CENTER, BOTTOM_RIGHT,
            LEFT_CENTER, LEFT_TOP, LEFT_BOTTOM,
            RIGHT_CENTER, RIGHT_TOP, RIGHT_BOTTOM
        ],
        topRight: [
            TOP_RIGHT, TOP_CENTER, TOP_LEFT,
            BOTTOM_RIGHT, BOTTOM_CENTER, BOTTOM_LEFT,
            LEFT_CENTER, LEFT_TOP, LEFT_BOTTOM,
            RIGHT_CENTER, RIGHT_TOP, RIGHT_BOTTOM
        ],
        left: [
            LEFT_CENTER, LEFT_TOP, LEFT_BOTTOM,
            TOP_LEFT, TOP_CENTER, TOP_RIGHT,
            BOTTOM_LEFT, BOTTOM_CENTER, BOTTOM_RIGHT,
            RIGHT_CENTER, RIGHT_TOP, RIGHT_BOTTOM
        ],
        leftTop: [
            LEFT_TOP, LEFT_CENTER, LEFT_BOTTOM,
            TOP_LEFT, TOP_CENTER, TOP_RIGHT,
            BOTTOM_LEFT, BOTTOM_CENTER, BOTTOM_RIGHT,
            RIGHT_TOP, RIGHT_CENTER, RIGHT_BOTTOM
        ],
        leftBottom: [
            LEFT_BOTTOM, LEFT_CENTER, LEFT_TOP,
            TOP_LEFT, TOP_CENTER, TOP_RIGHT,
            BOTTOM_LEFT, BOTTOM_CENTER, BOTTOM_RIGHT,
            RIGHT_BOTTOM, RIGHT_CENTER, RIGHT_TOP
        ],
        right: [
            RIGHT_CENTER, RIGHT_TOP, RIGHT_BOTTOM,
            TOP_LEFT, TOP_CENTER, TOP_RIGHT,
            BOTTOM_LEFT, BOTTOM_CENTER, BOTTOM_RIGHT,
            LEFT_CENTER, LEFT_TOP, LEFT_BOTTOM
        ],
        rightTop: [
            RIGHT_TOP, RIGHT_CENTER, RIGHT_BOTTOM,
            TOP_LEFT, TOP_CENTER, TOP_RIGHT,
            BOTTOM_LEFT, BOTTOM_CENTER, BOTTOM_RIGHT,
            LEFT_TOP, LEFT_CENTER, LEFT_BOTTOM
        ],
        rightBottom: [
            RIGHT_BOTTOM, RIGHT_CENTER, RIGHT_TOP,
            TOP_LEFT, TOP_CENTER, TOP_RIGHT,
            BOTTOM_LEFT, BOTTOM_CENTER, BOTTOM_RIGHT,
            LEFT_BOTTOM, LEFT_CENTER, LEFT_TOP
        ],
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtOverlayComponent = /** @class */ (function () {
        function NtOverlayComponent(_renderer) {
            var _this = this;
            this._renderer = _renderer;
            this._destroy = new rxjs.Subject();
            this._isOpen = false;
            this._isMouseIn = false;
            this._position = NtOverlayPosition.BottomLeft;
            this._positionPairs = NT_OVERLAY_POSITION_PAIRS[this._position];
            this._paddingClass = getPositionClassName(this._positionPairs[0]);
            this._arrow = false;
            this._noSpacing = false;
            this._trigger = '';
            this._overlayClass = '';
            this._fixed = false;
            this._closeEvent = new core.EventEmitter();
            this._positionChange = new core.EventEmitter();
            this.afterOpen = new core.EventEmitter();
            this.afterClosed = new core.EventEmitter();
            this.beforeOpen = new core.EventEmitter();
            this.beforeClosed = new core.EventEmitter();
            this.positionChange = new core.EventEmitter();
            this.keydownEvents = new core.EventEmitter();
            this._closeEvent.pipe(operators.takeUntil(this._destroy), operators.debounceTime(100), operators.filter((/**
             * @param {?} _
             * @return {?}
             */
            function (_) { return _this._isMouseIn === false; }))).subscribe((/**
             * @param {?} _
             * @return {?}
             */
            function (_) { return _this.hide(); }));
            this._positionChange.pipe(operators.takeUntil(this._destroy), operators.filter((/**
             * @param {?} position
             * @return {?}
             */
            function (position) { return position !== _this._paddingClass; }))).subscribe((/**
             * @param {?} position
             * @return {?}
             */
            function (position) {
                _this._setContainerStyles(position);
            }));
        }
        Object.defineProperty(NtOverlayComponent.prototype, "isOpen", {
            get: /**
             * @return {?}
             */
            function () { return this._isOpen; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtOverlayComponent.prototype, "isMouseIn", {
            get: /**
             * @return {?}
             */
            function () { return this._isMouseIn; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtOverlayComponent.prototype, "origin", {
            get: /**
             * @return {?}
             */
            function () { return this._origin; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._origin = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtOverlayComponent.prototype, "position", {
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (value) {
                    this._position = value;
                    this._positionPairs = NT_OVERLAY_POSITION_PAIRS[value];
                }
                else {
                    this._position = NtOverlayPosition.BottomLeft;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtOverlayComponent.prototype, "positionPairs", {
            get: /**
             * @return {?}
             */
            function () { return this._positionPairs; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._positionPairs = coercion.coerceArray(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtOverlayComponent.prototype, "paddingClass", {
            get: /**
             * @return {?}
             */
            function () { return this._paddingClass; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtOverlayComponent.prototype, "fixed", {
            get: /**
             * @return {?}
             */
            function () { return this._fixed; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._fixed = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtOverlayComponent.prototype, "arrow", {
            get: /**
             * @return {?}
             */
            function () { return this._arrow; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._arrow = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtOverlayComponent.prototype, "noSpacing", {
            get: /**
             * @return {?}
             */
            function () { return this._noSpacing; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._noSpacing = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtOverlayComponent.prototype, "trigger", {
            get: /**
             * @return {?}
             */
            function () { return this._trigger; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._trigger = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtOverlayComponent.prototype, "overlayClass", {
            get: /**
             * @return {?}
             */
            function () { return this._overlayClass; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._overlayClass = value; },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NtOverlayComponent.prototype.ngAfterViewInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.cdkConnectedOverlay.attach
                .pipe(operators.take(1), operators.switchMap((/**
             * @return {?}
             */
            function () { return _this.cdkConnectedOverlay.overlayRef.keydownEvents(); })), operators.takeUntil(this._destroy)).subscribe((/**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                if (event.keyCode === keycodes.ESCAPE) {
                    _this.hide();
                }
                _this.keydownEvents.next(event);
            }));
        };
        /**
         * @param {?} changes
         * @return {?}
         */
        NtOverlayComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            /** @type {?} */
            var change = changes.position || changes.fixed || changes.positionPairs;
            if (change && !change.firstChange) {
                this._setPosition();
            }
        };
        /**
         * @return {?}
         */
        NtOverlayComponent.prototype.ngAfterContentChecked = /**
         * @return {?}
         */
        function () {
            // this.cdkConnectedOverlay.positionChange.
        };
        /**
         * @return {?}
         */
        NtOverlayComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this._destroy.next();
            this._destroy.complete();
        };
        /**
         * @private
         * @return {?}
         */
        NtOverlayComponent.prototype._setPosition = /**
         * @private
         * @return {?}
         */
        function () {
            this._positionPairs = this.fixed ?
                this._positionPairs.slice(0, 1) :
                this._positionPairs;
            this._paddingClass = getPositionClassName(this._positionPairs[0]);
        };
        /**
         * @return {?}
         */
        NtOverlayComponent.prototype.show = /**
         * @return {?}
         */
        function () {
            this._isOpen = true;
        };
        /**
         * @return {?}
         */
        NtOverlayComponent.prototype.hide = /**
         * @return {?}
         */
        function () {
            this._isOpen = false;
        };
        /**
         * @return {?}
         */
        NtOverlayComponent.prototype.click = /**
         * @return {?}
         */
        function () {
            if (this.trigger === 'click') {
                this.isOpen ? this.hide() : this.show();
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtOverlayComponent.prototype.onOverlayPositionChange = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this._positionChange.next(getPositionClassName(event.connectionPair));
        };
        /**
         * @return {?}
         */
        NtOverlayComponent.prototype.onMouseEnter = /**
         * @return {?}
         */
        function () {
            if (this.trigger === 'hover') {
                this._isMouseIn = true;
                this.show();
            }
        };
        /**
         * @return {?}
         */
        NtOverlayComponent.prototype.onMouseLeave = /**
         * @return {?}
         */
        function () {
            if (this.trigger === 'hover') {
                this._closeEvent.next(this._isMouseIn = false);
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtOverlayComponent.prototype.onAnimationStart = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (event.toState === null) {
                this.beforeOpen.next();
            }
            else if (event.toState === 'void') {
                this.beforeClosed.next();
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtOverlayComponent.prototype.onAnimationDone = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (event.toState === null) {
                this.afterOpen.next();
            }
            else if (event.toState === 'void') {
                this.afterClosed.next();
            }
        };
        /**
         * @private
         * @param {?} position
         * @return {?}
         */
        NtOverlayComponent.prototype._setContainerStyles = /**
         * @private
         * @param {?} position
         * @return {?}
         */
        function (position) {
            /** @type {?} */
            var pane = this.cdkConnectedOverlay.overlayRef.overlayElement.querySelector('.nt-overlay-container');
            this._paddingClass && this._renderer.removeClass(pane, this._paddingClass);
            this._paddingClass = position;
            this._renderer.addClass(pane, this._paddingClass);
        };
        NtOverlayComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-overlay, [nt-overlay]',
                        template: "<ng-template cdk-connected-overlay [cdkConnectedOverlayOpen]=\"isOpen\" [cdkConnectedOverlayHasBackdrop]=\"trigger === 'click'\" [cdkConnectedOverlayPositions]=\"positionPairs\" [cdkConnectedOverlayOrigin]=\"origin\" (positionChange)=\"onOverlayPositionChange($event)\" (backdropClick)=\"hide()\"> <div class=\"nt-overlay-container {{paddingClass}} {{overlayClass}}\" (mouseenter)=\"onMouseEnter()\" (mouseleave)=\"onMouseLeave()\" [class.no-spacing]=\"noSpacing\" [@fade] (@fade.start)=\"onAnimationStart($event)\" (@fade.done)=\"onAnimationDone($event)\"> <div class=\"nt-overlay-shadow\"></div> <div class=\"nt-overlay-arrow\" *ngIf=\"arrow\"></div> <div class=\"nt-overlay-pane\"> <ng-content></ng-content> </div> </div> </ng-template> ",
                        animations: [
                            animations.trigger('fade', [
                                animations.transition('void => *', fadeIn(.15)),
                                animations.transition('* => void', fadeOut(.15))
                            ])
                        ],
                        encapsulation: core.ViewEncapsulation.None,
                    },] },
        ];
        /** @nocollapse */
        NtOverlayComponent.ctorParameters = function () { return [
            { type: core.Renderer2 }
        ]; };
        NtOverlayComponent.propDecorators = {
            origin: [{ type: core.Input }],
            position: [{ type: core.Input }],
            positionPairs: [{ type: core.Input }],
            fixed: [{ type: core.Input }],
            arrow: [{ type: core.Input }],
            noSpacing: [{ type: core.Input }],
            trigger: [{ type: core.Input }],
            overlayClass: [{ type: core.Input }],
            cdkConnectedOverlay: [{ type: core.ViewChild, args: [overlay.CdkConnectedOverlay, { static: true },] }],
            afterOpen: [{ type: core.Output }],
            afterClosed: [{ type: core.Output }],
            beforeOpen: [{ type: core.Output }],
            beforeClosed: [{ type: core.Output }],
            positionChange: [{ type: core.Output }],
            keydownEvents: [{ type: core.Output }]
        };
        return NtOverlayComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtOverlayModule = /** @class */ (function () {
        function NtOverlayModule() {
        }
        NtOverlayModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, overlay.OverlayModule],
                        exports: [NtOverlayComponent],
                        declarations: [NtOverlayComponent],
                    },] },
        ];
        return NtOverlayModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var NtUploadStatus = {
        BEGIN: 0,
        SENDING: 1,
        SUCCESS: 2,
        ERROR: 3,
        UPLOADED: 4,
    };
    NtUploadStatus[NtUploadStatus.BEGIN] = 'BEGIN';
    NtUploadStatus[NtUploadStatus.SENDING] = 'SENDING';
    NtUploadStatus[NtUploadStatus.SUCCESS] = 'SUCCESS';
    NtUploadStatus[NtUploadStatus.ERROR] = 'ERROR';
    NtUploadStatus[NtUploadStatus.UPLOADED] = 'UPLOADED';
    /**
     * @abstract
     * @template T
     */
    var  /**
     * @abstract
     * @template T
     */
    NtUploadFile = /** @class */ (function () {
        function NtUploadFile(name, size, type, link) {
            this.name = name;
            this.size = size;
            this.type = type;
            this.link = link;
            this.status = NtUploadStatus.BEGIN;
        }
        return NtUploadFile;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtFormDataUploadHandler = /** @class */ (function () {
        function NtFormDataUploadHandler(_http) {
            this._http = _http;
        }
        /**
         * @template T
         * @param {?} url
         * @param {?} file
         * @param {?} filename
         * @param {?=} handler
         * @return {?}
         */
        NtFormDataUploadHandler.prototype.upload = /**
         * @template T
         * @param {?} url
         * @param {?} file
         * @param {?} filename
         * @param {?=} handler
         * @return {?}
         */
        function (url, file, filename, handler) {
            var _this = this;
            if (handler === void 0) { handler = {}; }
            /** @type {?} */
            var formData = this._getFormData(file, filename);
            return this._http.request(new http.HttpRequest('POST', url, formData, { reportProgress: true }))
                .pipe(operators.map((/**
             * @param {?} event
             * @return {?}
             */
            function (event) { return _this._progressHandler(event, handler); })), operators.filter((/**
             * @param {?} event
             * @return {?}
             */
            function (event) { return event.type === http.HttpEventType.Response; })), operators.map((/**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                return {
                    status: event.status >= 200 && event.status < 400
                        ? NtUploadStatus.SUCCESS
                        : NtUploadStatus.ERROR,
                    data: event.body
                };
            })), operators.catchError((/**
             * @param {?} error
             * @return {?}
             */
            function (error) { return rxjs.of({
                status: NtUploadStatus.ERROR,
                error: error.statusText
            }); })));
        };
        /**
         * @private
         * @param {?} event
         * @param {?=} handler
         * @return {?}
         */
        NtFormDataUploadHandler.prototype._progressHandler = /**
         * @private
         * @param {?} event
         * @param {?=} handler
         * @return {?}
         */
        function (event, handler) {
            if (handler === void 0) { handler = {}; }
            if (event.type === http.HttpEventType.Sent && handler.begin) {
                handler.begin();
            }
            else if (event.type === http.HttpEventType.UploadProgress && handler.progress) {
                if (event.total && event.total > 0) {
                    handler.progress(Math.round(event.loaded / event.total * 100));
                }
            }
            else if (event.type === http.HttpEventType.Response && handler.done) {
                handler.done();
            }
            return event;
        };
        /**
         * @private
         * @param {?} file
         * @param {?} filename
         * @return {?}
         */
        NtFormDataUploadHandler.prototype._getFormData = /**
         * @private
         * @param {?} file
         * @param {?} filename
         * @return {?}
         */
        function (file, filename) {
            if (filename) {
                /** @type {?} */
                var formData = new FormData();
                formData.append(filename, file);
                return formData;
            }
            return file;
        };
        NtFormDataUploadHandler.decorators = [
            { type: core.Injectable },
        ];
        /** @nocollapse */
        NtFormDataUploadHandler.ctorParameters = function () { return [
            { type: http.HttpClient }
        ]; };
        return NtFormDataUploadHandler;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var NT_UPLOAD_HANDLER = new core.InjectionToken('nt-upload-handler');

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtUploadModule = /** @class */ (function () {
        function NtUploadModule() {
        }
        /**
         * @param {?=} handler
         * @return {?}
         */
        NtUploadModule.forRoot = /**
         * @param {?=} handler
         * @return {?}
         */
        function (handler) {
            return {
                ngModule: NtUploadModule,
                providers: [
                    { provide: NT_UPLOAD_HANDLER, useClass: handler || NtFormDataUploadHandler }
                ]
            };
        };
        NtUploadModule.decorators = [
            { type: core.NgModule },
        ];
        return NtUploadModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.transformAxis = transformAxis;
    exports.translate3d = translate3d;
    exports.DEFAULT_TIMING = DEFAULT_TIMING;
    exports.fade = fade;
    exports.fadeInDirection = fadeInDirection;
    exports.fadeInX = fadeInX;
    exports.fadeInY = fadeInY;
    exports.fadeIn = fadeIn;
    exports.fadeInDown = fadeInDown;
    exports.fadeInUp = fadeInUp;
    exports.fadeInLeft = fadeInLeft;
    exports.fadeInRight = fadeInRight;
    exports.fadeOutDirection = fadeOutDirection;
    exports.fadeOutX = fadeOutX;
    exports.fadeOutY = fadeOutY;
    exports.fadeOut = fadeOut;
    exports.fadeOutDown = fadeOutDown;
    exports.fadeOutUp = fadeOutUp;
    exports.fadeOutLeft = fadeOutLeft;
    exports.fadeOutRight = fadeOutRight;
    exports.slideDirection = slideDirection;
    exports.slideX = slideX;
    exports.slideY = slideY;
    exports.slideInDown = slideInDown;
    exports.slideInUp = slideInUp;
    exports.slideInLeft = slideInLeft;
    exports.slideInRight = slideInRight;
    exports.slideOutUp = slideOutUp;
    exports.slideOutDown = slideOutDown;
    exports.slideOutLeft = slideOutLeft;
    exports.slideOutRight = slideOutRight;
    exports.NT_DATE_LOCALE_FACTORY = NT_DATE_LOCALE_FACTORY;
    exports.NT_DATE_LOCALE = NT_DATE_LOCALE;
    exports.DateAdapter = DateAdapter;
    exports.NT_DATE_FORMATS = NT_DATE_FORMATS;
    exports.NativeDateAdapter = NativeDateAdapter;
    exports.NT_NATIVE_DATE_FORMATS = NT_NATIVE_DATE_FORMATS;
    exports.NativeDateModule = NativeDateModule;
    exports.NtNativeDateModule = NtNativeDateModule;
    exports.NtOptionModule = NtOptionModule;
    exports.NtOptionSelectionChange = NtOptionSelectionChange;
    exports.NT_OPTION_PARENT_COMPONENT = NT_OPTION_PARENT_COMPONENT;
    exports.NtOptionComponent = NtOptionComponent;
    exports.NtOverlayModule = NtOverlayModule;
    exports.NtOverlayComponent = NtOverlayComponent;
    exports.getConnectionPositionPair = getConnectionPositionPair;
    exports.getPositionClassName = getPositionClassName;
    exports.getPositionOrientation = getPositionOrientation;
    exports.NtOverlayPosition = NtOverlayPosition;
    exports.NtOverlayOrientation = NtOverlayOrientation;
    exports.BOTTOM_LEFT = BOTTOM_LEFT;
    exports.BOTTOM_CENTER = BOTTOM_CENTER;
    exports.BOTTOM_RIGHT = BOTTOM_RIGHT;
    exports.TOP_LEFT = TOP_LEFT;
    exports.TOP_CENTER = TOP_CENTER;
    exports.TOP_RIGHT = TOP_RIGHT;
    exports.LEFT_TOP = LEFT_TOP;
    exports.LEFT_CENTER = LEFT_CENTER;
    exports.LEFT_BOTTOM = LEFT_BOTTOM;
    exports.RIGHT_TOP = RIGHT_TOP;
    exports.RIGHT_CENTER = RIGHT_CENTER;
    exports.RIGHT_BOTTOM = RIGHT_BOTTOM;
    exports.NT_OVERLAY_POSITION_PAIRS = NT_OVERLAY_POSITION_PAIRS;
    exports.NtUploadModule = NtUploadModule;
    exports.NT_UPLOAD_HANDLER = NT_UPLOAD_HANDLER;
    exports.NtUploadStatus = NtUploadStatus;
    exports.NtUploadFile = NtUploadFile;
    exports.NtFormDataUploadHandler = NtFormDataUploadHandler;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=core.umd.js.map
