(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('@angular/cdk/coercion'), require('@angular/cdk/observers'), require('@angular/core'), require('@angular/cdk/overlay'), require('@ng-tangram/components/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define(['exports', 'rxjs', '@angular/cdk/coercion', '@angular/cdk/observers', '@angular/core', '@angular/cdk/overlay', '@ng-tangram/components/core', '@angular/common'], factory) :
    (factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.dropdown = {}),global.Rx,global.ng.cdk.coercion,global.ng.cdk.observers,global.ng.core,global.ng.cdk.overlay,global.nt.components.core,global.ng.common));
}(this, (function (exports,rxjs,coercion,observers,core,overlay,core$1,common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var NT_DROPDOWN_PARENT_COMPONENT = new core.InjectionToken('nt-dropdown-parent-component');
    var NtDropdownPaneComponent = /** @class */ (function () {
        function NtDropdownPaneComponent(_contentObserver, _elementRef, _parent) {
            this._contentObserver = _contentObserver;
            this._elementRef = _elementRef;
            this._parent = _parent;
            this._arrow = false;
            this._autosize = false;
            this.size = 'small';
            /**
             * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
             *
             * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
             * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
             * @deprecated > 0.6.0
             */
            this.class = '';
            this._contentChange = new rxjs.Subject();
        }
        Object.defineProperty(NtDropdownPaneComponent.prototype, "autosize", {
            get: /**
             * @return {?}
             */
            function () { return this._autosize; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._autosize = coercion.coerceBooleanProperty(value);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtDropdownPaneComponent.prototype, "arrow", {
            get: /**
             * @return {?}
             */
            function () { return this._arrow; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._arrow = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtDropdownPaneComponent.prototype, "contentChanged", {
            get: /**
             * @return {?}
             */
            function () {
                return this._contentChange.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtDropdownPaneComponent.prototype, "textContent", {
            get: /**
             * @return {?}
             */
            function () {
                return (this._elementRef.nativeElement.textContent || '').trim();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NtDropdownPaneComponent.prototype.ngAfterContentInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this._contentSubscription = this._contentObserver
                .observe(this._elementRef)
                .subscribe((/**
             * @return {?}
             */
            function () { return _this._checkContentChange(); }));
        };
        /**
         * @return {?}
         */
        NtDropdownPaneComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            if (this._contentSubscription) {
                this._contentSubscription.unsubscribe();
            }
        };
        /**
         * @private
         * @return {?}
         */
        NtDropdownPaneComponent.prototype._checkContentChange = /**
         * @private
         * @return {?}
         */
        function () {
            if (this._parent.overlay.isOpen) {
                /** @type {?} */
                var cdkConnectedOverlay = this._parent.overlay.cdkConnectedOverlay;
                if (cdkConnectedOverlay && cdkConnectedOverlay.overlayRef) {
                    cdkConnectedOverlay.overlayRef.updatePosition();
                }
            }
        };
        NtDropdownPaneComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-dropdown-pane, [nt-dropdown-pane]',
                        template: '<ng-content></ng-content>',
                        encapsulation: core.ViewEncapsulation.None,
                        host: {
                            '[class]': '["nt-dropdown-pane", size, class].join(" ")',
                            '[class.autosize]': 'autosize'
                        }
                    },] },
        ];
        /** @nocollapse */
        NtDropdownPaneComponent.ctorParameters = function () { return [
            { type: observers.ContentObserver },
            { type: core.ElementRef },
            { type: undefined, decorators: [{ type: core.Inject, args: [NT_DROPDOWN_PARENT_COMPONENT,] }] }
        ]; };
        NtDropdownPaneComponent.propDecorators = {
            size: [{ type: core.Input }],
            class: [{ type: core.Input }],
            autosize: [{ type: core.Input }],
            arrow: [{ type: core.Input }]
        };
        return NtDropdownPaneComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtDropdownComponent = /** @class */ (function () {
        function NtDropdownComponent(_elementRef) {
            this.position = core$1.NtOverlayPosition.BottomLeft;
            this.trigger = 'hover';
            this.afterOpen = new core.EventEmitter();
            this.afterClosed = new core.EventEmitter();
            this.beforeOpen = new core.EventEmitter();
            this.beforeClosed = new core.EventEmitter();
            this.positionChange = new core.EventEmitter();
            this.origin = new overlay.CdkOverlayOrigin(_elementRef);
        }
        /**
         * @param {?} event
         * @return {?}
         */
        NtDropdownComponent.prototype._afterOpen = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.afterOpen.next(event);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtDropdownComponent.prototype._afterClosed = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.afterClosed.next(event);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtDropdownComponent.prototype._beforeOpen = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.beforeOpen.next(event);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtDropdownComponent.prototype._beforeClosed = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.beforeClosed.next(event);
        };
        /**
         * @param {?} change
         * @return {?}
         */
        NtDropdownComponent.prototype._positionChange = /**
         * @param {?} change
         * @return {?}
         */
        function (change) {
            this.positionChange.next(change);
        };
        NtDropdownComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-dropdown, [nt-dropdown]',
                        template: "<ng-content></ng-content> <nt-overlay [origin]=\"origin\" [position]=\"position\" [trigger]=\"trigger\" [arrow]=\"pane?.arrow\" (afterOpen)=\"_afterOpen($event)\" (afterClosed)=\"_afterClosed($event)\" (beforeOpen)=\"_beforeOpen($event)\" (beforeClosed)=\"_beforeClosed($event)\" (positionChange)=\"_positionChange($event)\"> <ng-content select=\"nt-dropdown-pane\"></ng-content> </nt-overlay> ",
                        encapsulation: core.ViewEncapsulation.None,
                        host: {
                            '(click)': 'overlay.click()',
                            '(mouseenter)': 'overlay.onMouseEnter()',
                            '(mouseleave)': 'overlay.onMouseLeave()'
                        },
                        providers: [
                            { provide: NT_DROPDOWN_PARENT_COMPONENT, useExisting: NtDropdownComponent }
                        ]
                    },] },
        ];
        /** @nocollapse */
        NtDropdownComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        NtDropdownComponent.propDecorators = {
            position: [{ type: core.Input }],
            trigger: [{ type: core.Input }],
            afterOpen: [{ type: core.Output }],
            afterClosed: [{ type: core.Output }],
            beforeOpen: [{ type: core.Output }],
            beforeClosed: [{ type: core.Output }],
            positionChange: [{ type: core.Output }],
            overlay: [{ type: core.ViewChild, args: [core$1.NtOverlayComponent, { static: true },] }],
            pane: [{ type: core.ContentChild, args: [NtDropdownPaneComponent, { static: false },] }]
        };
        return NtDropdownComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtDropdownModule = /** @class */ (function () {
        function NtDropdownModule() {
        }
        NtDropdownModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, observers.ObserversModule, core$1.NtOverlayModule],
                        entryComponents: [NtDropdownComponent],
                        exports: [NtDropdownComponent, NtDropdownPaneComponent],
                        declarations: [NtDropdownComponent, NtDropdownPaneComponent]
                    },] },
        ];
        return NtDropdownModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NtDropdownModule = NtDropdownModule;
    exports.NtDropdownComponent = NtDropdownComponent;
    exports.NT_DROPDOWN_PARENT_COMPONENT = NT_DROPDOWN_PARENT_COMPONENT;
    exports.NtDropdownPaneComponent = NtDropdownPaneComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=dropdown.umd.js.map
