(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('rxjs/operators'), require('@angular/cdk/keycodes'), require('@angular/core'), require('@angular/cdk/portal'), require('@angular/animations'), require('@ng-tangram/components/core'), require('@angular/cdk/overlay'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define(['exports', 'rxjs', 'rxjs/operators', '@angular/cdk/keycodes', '@angular/core', '@angular/cdk/portal', '@angular/animations', '@ng-tangram/components/core', '@angular/cdk/overlay', '@angular/common'], factory) :
    (factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.modal = {}),global.Rx,global.Rx.operators,global.ng.cdk.keycodes,global.ng.core,global.ng.cdk.portal,global.ng.animations,global.nt.components.core,global.ng.cdk.overlay,global.ng.common));
}(this, (function (exports,rxjs,operators,keycodes,core,portal,animations,core$1,overlay,common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtModalConfig = /** @class */ (function () {
        function NtModalConfig() {
            this.top = '80px';
            this.width = '600px';
            this.height = 'auto';
            this.maxWidth = '80vw';
            this.closable = true;
            this.data = {};
            this.panelClass = 'tm-file-preview-modal-panel';
            this.hasBackdrop = true;
            this.backdropClass = 'dark-backdrop';
            this.centerVertically = false;
            this.transparent = false;
        }
        return NtModalConfig;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // Counter for unique modal ids.
    /** @type {?} */
    var uniqueId = 0;
    /**
     * @template T, R
     */
    var  /**
     * @template T, R
     */
    NtModalRef = /** @class */ (function () {
        function NtModalRef(_overlayRef, _containerInstance, location, id) {
            var _this = this;
            if (id === void 0) { id = "nt-modal-" + uniqueId++; }
            this._overlayRef = _overlayRef;
            this._containerInstance = _containerInstance;
            this.id = id;
            this.closable = this._containerInstance.config.closable;
            this._afterOpen = new rxjs.Subject();
            this._afterClosed = new rxjs.Subject();
            this._beforeClose = new rxjs.Subject();
            this._locationChanges = rxjs.Subscription.EMPTY;
            // Emit when opening animation completes
            _containerInstance.animationStateChanged
                .pipe(operators.filter((/**
             * @param {?} event
             * @return {?}
             */
            function (event) { return event.phaseName === 'done' && event.toState === 'enter'; })), operators.take(1))
                .subscribe((/**
             * @return {?}
             */
            function () {
                _this._afterOpen.next();
                _this._afterOpen.complete();
            }));
            // Dispose overlay when closing animation is complete
            _containerInstance.animationStateChanged
                .pipe(operators.filter((/**
             * @param {?} event
             * @return {?}
             */
            function (event) { return event.phaseName === 'done' && event.toState === 'exit'; })), operators.take(1))
                .subscribe((/**
             * @return {?}
             */
            function () {
                _this._overlayRef.dispose();
                _this._locationChanges.unsubscribe();
                _this._afterClosed.next(_this._result);
                _this._afterClosed.complete();
                _this.componentInstance = (/** @type {?} */ (null));
            }));
            _overlayRef.keydownEvents()
                .pipe(operators.filter((/**
             * @param {?} event
             * @return {?}
             */
            function (event) { return event.keyCode === keycodes.ESCAPE && !!_this.closable; })))
                .subscribe((/**
             * @return {?}
             */
            function () { return _this.close(); }));
            if (location) {
                this._locationChanges = location.subscribe((/**
                 * @return {?}
                 */
                function () { return _this.close(); }));
            }
        }
        /**
         * Close the modal.
         * @param modalResult Optional result to return to the modal opener.
         */
        /**
         * Close the modal.
         * @param {?=} modalResult Optional result to return to the modal opener.
         * @return {?}
         */
        NtModalRef.prototype.close = /**
         * Close the modal.
         * @param {?=} modalResult Optional result to return to the modal opener.
         * @return {?}
         */
        function (modalResult) {
            var _this = this;
            this._result = modalResult;
            // Transition the backdrop in parallel to the modal.
            this._containerInstance.animationStateChanged
                .pipe(operators.filter((/**
             * @param {?} event
             * @return {?}
             */
            function (event) { return event.phaseName === 'start'; })), operators.take(1))
                .subscribe((/**
             * @return {?}
             */
            function () {
                _this._beforeClose.next(modalResult);
                _this._beforeClose.complete();
                _this._overlayRef.detachBackdrop();
            }));
            this._containerInstance.exit();
        };
        /**
         * Gets an observable that is notified when the modal is finished opening.
         */
        /**
         * Gets an observable that is notified when the modal is finished opening.
         * @return {?}
         */
        NtModalRef.prototype.afterOpen = /**
         * Gets an observable that is notified when the modal is finished opening.
         * @return {?}
         */
        function () {
            return this._afterOpen.asObservable();
        };
        /**
         * Gets an observable that is notified when the modal is finished closing.
         */
        /**
         * Gets an observable that is notified when the modal is finished closing.
         * @return {?}
         */
        NtModalRef.prototype.afterClosed = /**
         * Gets an observable that is notified when the modal is finished closing.
         * @return {?}
         */
        function () {
            return this._afterClosed.asObservable();
        };
        /**
         * Gets an observable that is notified when the modal has started closing.
         */
        /**
         * Gets an observable that is notified when the modal has started closing.
         * @return {?}
         */
        NtModalRef.prototype.beforeClose = /**
         * Gets an observable that is notified when the modal has started closing.
         * @return {?}
         */
        function () {
            return this._beforeClose.asObservable();
        };
        /**
         * Gets an observable that emits when the overlay's backdrop has been clicked.
         */
        /**
         * Gets an observable that emits when the overlay's backdrop has been clicked.
         * @return {?}
         */
        NtModalRef.prototype.backdropClick = /**
         * Gets an observable that emits when the overlay's backdrop has been clicked.
         * @return {?}
         */
        function () {
            return this._overlayRef.backdropClick();
        };
        /**
         * Gets an observable that emits when keydown events are targeted on the overlay.
         */
        /**
         * Gets an observable that emits when keydown events are targeted on the overlay.
         * @return {?}
         */
        NtModalRef.prototype.keydownEvents = /**
         * Gets an observable that emits when keydown events are targeted on the overlay.
         * @return {?}
         */
        function () {
            return this._overlayRef.keydownEvents();
        };
        /**
         * Updates the modal's width and height.
         * @param width New width of the modal.
         * @param height New height of the modal.
         */
        /**
         * Updates the modal's width and height.
         * @template THIS
         * @this {THIS}
         * @param {?=} width New width of the modal.
         * @param {?=} height New height of the modal.
         * @return {THIS}
         */
        NtModalRef.prototype.updateSize = /**
         * Updates the modal's width and height.
         * @template THIS
         * @this {THIS}
         * @param {?=} width New width of the modal.
         * @param {?=} height New height of the modal.
         * @return {THIS}
         */
        function (width, height) {
            if (width === void 0) { width = 'auto'; }
            if (height === void 0) { height = 'auto'; }
            (/** @type {?} */ (this))._getPositionStrategy().width(width).height(height);
            (/** @type {?} */ (this))._overlayRef.updatePosition();
            return (/** @type {?} */ (this));
        };
        /** Fetches the position strategy object from the overlay ref. */
        /**
         * Fetches the position strategy object from the overlay ref.
         * @private
         * @return {?}
         */
        NtModalRef.prototype._getPositionStrategy = /**
         * Fetches the position strategy object from the overlay ref.
         * @private
         * @return {?}
         */
        function () {
            return (/** @type {?} */ (this._overlayRef.getConfig().positionStrategy));
        };
        return NtModalRef;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @return {?}
     */
    function throwNtModalContentAlreadyAttachedError() {
        throw Error('Attempting to attach modal content after content is already attached');
    }
    var NtModalComponent = /** @class */ (function (_super) {
        __extends(NtModalComponent, _super);
        function NtModalComponent() {
            var _this = _super.call(this) || this;
            _this.state = 'enter';
            _this.animationStateChanged = new core.EventEmitter();
            return _this;
        }
        Object.defineProperty(NtModalComponent.prototype, "config", {
            get: /**
             * @return {?}
             */
            function () { return this._config; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._config = value; },
            enumerable: true,
            configurable: true
        });
        /**
         * @template T
         * @param {?} portal
         * @return {?}
         */
        NtModalComponent.prototype.attachComponentPortal = /**
         * @template T
         * @param {?} portal
         * @return {?}
         */
        function (portal$$1) {
            if (this._portalOutlet.hasAttached()) {
                throwNtModalContentAlreadyAttachedError();
            }
            return this._portalOutlet.attachComponentPortal(portal$$1);
        };
        /**
         * @template C
         * @param {?} portal
         * @return {?}
         */
        NtModalComponent.prototype.attachTemplatePortal = /**
         * @template C
         * @param {?} portal
         * @return {?}
         */
        function (portal$$1) {
            if (this._portalOutlet.hasAttached()) {
                throwNtModalContentAlreadyAttachedError();
            }
            return this._portalOutlet.attachTemplatePortal(portal$$1);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtModalComponent.prototype.onAnimationDone = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.animationStateChanged.emit(event);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtModalComponent.prototype.onAnimationStart = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.animationStateChanged.emit(event);
        };
        /**
         * @return {?}
         */
        NtModalComponent.prototype.exit = /**
         * @return {?}
         */
        function () {
            this.state = 'exit';
        };
        NtModalComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-modal',
                        template: "\n    <ng-template cdkPortalOutlet></ng-template>\n    <button *ngIf=\"config.closable\" (click)=\"exit()\" class=\"close-button\" type=\"button\">\n      <span aria-hidden=\"true\">&times;</span>\n    </button>\n  ",
                        encapsulation: core.ViewEncapsulation.None,
                        animations: [
                            animations.trigger('fade', [
                                animations.transition('void => *', core$1.fadeInY({ a: '-10%', b: 0 }, .2)),
                                animations.transition('* => exit', core$1.fadeOutY({ a: 0, b: '-10%' }, .2))
                            ])
                        ],
                        host: {
                            'class': 'reveal',
                            '[class.reveal-transparent]': '_config.transparent',
                            '[style.width]': '_config.width',
                            '[style.height]': '_config.height',
                            '[@fade]': 'state',
                            '(@fade.start)': 'onAnimationStart($event)',
                            '(@fade.done)': 'onAnimationDone($event)',
                        }
                    },] },
        ];
        /** @nocollapse */
        NtModalComponent.ctorParameters = function () { return []; };
        NtModalComponent.propDecorators = {
            _portalOutlet: [{ type: core.ViewChild, args: [portal.CdkPortalOutlet, { static: true },] }]
        };
        return NtModalComponent;
    }(portal.BasePortalOutlet));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var NT_MODAL_DATA = new core.InjectionToken('nt-modal-data');
    /** @type {?} */
    var NT_MODAL_DEFAULT_CONFIG = new core.InjectionToken('nt-model-default-config');
    var NtModal = /** @class */ (function () {
        function NtModal(_location, _defaultConfig, _overlay, _injector) {
            this._location = _location;
            this._defaultConfig = _defaultConfig;
            this._overlay = _overlay;
            this._injector = _injector;
            this._openModalsAtThisLevel = [];
            this._afterAllClosedAtThisLevel = new rxjs.Subject();
            this._afterOpenAtThisLevel = new rxjs.Subject();
        }
        /**
         * @template T
         * @param {?} content
         * @param {?=} config
         * @return {?}
         */
        NtModal.prototype.open = /**
         * @template T
         * @param {?} content
         * @param {?=} config
         * @return {?}
         */
        function (content, config) {
            var _this = this;
            if (config === void 0) { config = {}; }
            config = __assign({}, this._defaultConfig || new NtModalConfig(), config);
            /** @type {?} */
            var overlayRef = this._createOverlay(config);
            /** @type {?} */
            var modalContainerRef = this._attachModalContainer(overlayRef, config);
            /** @type {?} */
            var modalRef = this._attachModalContent(content, modalContainerRef, overlayRef, config);
            this._openModalsAtThisLevel.push(modalRef);
            modalRef.afterClosed().subscribe((/**
             * @return {?}
             */
            function () { return _this._removeOpenModal(modalRef); }));
            this._afterOpenAtThisLevel.next(modalRef);
            return modalRef;
        };
        /**
         * @private
         * @param {?} config
         * @return {?}
         */
        NtModal.prototype._createOverlay = /**
         * @private
         * @param {?} config
         * @return {?}
         */
        function (config) {
            /** @type {?} */
            var overlayConfig = this._getOverlayConfig(config);
            return this._overlay.create(overlayConfig);
        };
        /**
         * @private
         * @param {?} overlayRef
         * @param {?} config
         * @return {?}
         */
        NtModal.prototype._attachModalContainer = /**
         * @private
         * @param {?} overlayRef
         * @param {?} config
         * @return {?}
         */
        function (overlayRef, config) {
            /** @type {?} */
            var containerPortal = new portal.ComponentPortal(NtModalComponent, null);
            /** @type {?} */
            var containerRef = overlayRef.attach(containerPortal);
            containerRef.instance.config = config;
            return containerRef.instance;
        };
        /**
         * @private
         * @template T
         * @param {?} content
         * @param {?} modalContainer
         * @param {?} overlayRef
         * @param {?} config
         * @return {?}
         */
        NtModal.prototype._attachModalContent = /**
         * @private
         * @template T
         * @param {?} content
         * @param {?} modalContainer
         * @param {?} overlayRef
         * @param {?} config
         * @return {?}
         */
        function (content, modalContainer, overlayRef, config) {
            /** @type {?} */
            var modalRef = new NtModalRef(overlayRef, modalContainer, this._location, config.id);
            if (config.hasBackdrop) {
                overlayRef.backdropClick().subscribe((/**
                 * @return {?}
                 */
                function () {
                    if (modalRef.closable) {
                        modalRef.close();
                    }
                }));
            }
            if (content instanceof core.TemplateRef) {
                modalContainer.attachTemplatePortal(new portal.TemplatePortal(content, (/** @type {?} */ (null)), (/** @type {?} */ ({ $implicit: config.data, modalRef: modalRef }))));
            }
            else {
                /** @type {?} */
                var injector = this._createInjector(config, modalRef, modalContainer);
                /** @type {?} */
                var contentRef = modalContainer.attachComponentPortal(new portal.ComponentPortal(content, undefined, injector));
                modalRef.componentInstance = contentRef.instance;
            }
            return modalRef;
        };
        /**
       * Removes a modal from the array of open modals.
       * @param modalRef modal to be removed.
       */
        /**
         * Removes a modal from the array of open modals.
         * @private
         * @param {?} modalRef modal to be removed.
         * @return {?}
         */
        NtModal.prototype._removeOpenModal = /**
         * Removes a modal from the array of open modals.
         * @private
         * @param {?} modalRef modal to be removed.
         * @return {?}
         */
        function (modalRef) {
            /** @type {?} */
            var index = this._openModalsAtThisLevel.indexOf(modalRef);
            if (index > -1) {
                this._openModalsAtThisLevel.splice(index, 1);
                if (!this._openModalsAtThisLevel.length) {
                    this._afterAllClosedAtThisLevel.next();
                }
            }
        };
        /**
         * @private
         * @template T
         * @param {?} config
         * @param {?} modalRef
         * @param {?} modalContainer
         * @return {?}
         */
        NtModal.prototype._createInjector = /**
         * @private
         * @template T
         * @param {?} config
         * @param {?} modalRef
         * @param {?} modalContainer
         * @return {?}
         */
        function (config, modalRef, modalContainer) {
            /** @type {?} */
            var userInjector = config && config.viewContainerRef && config.viewContainerRef.injector;
            /** @type {?} */
            var injectionTokens = new WeakMap();
            injectionTokens.set(NtModalRef, modalRef);
            injectionTokens.set(NtModalComponent, modalContainer);
            injectionTokens.set(NT_MODAL_DATA, config.data);
            return new portal.PortalInjector(userInjector || this._injector, injectionTokens);
        };
        /**
         * @private
         * @param {?} config
         * @return {?}
         */
        NtModal.prototype._getOverlayConfig = /**
         * @private
         * @param {?} config
         * @return {?}
         */
        function (config) {
            /** @type {?} */
            var positionStrategy = this._overlay.position()
                .global()
                .centerHorizontally();
            /** @type {?} */
            var overlayConfig = new overlay.OverlayConfig({
                hasBackdrop: config.hasBackdrop,
                backdropClass: config.backdropClass,
                panelClass: config.panelClass,
                scrollStrategy: this._overlay.scrollStrategies.block(),
                minWidth: config.minWidth,
                minHeight: config.minHeight,
                maxWidth: config.maxWidth,
                maxHeight: config.maxHeight,
                positionStrategy: config.centerVertically
                    ? positionStrategy.centerVertically()
                    : positionStrategy.top(config.top)
            });
            return overlayConfig;
        };
        NtModal.decorators = [
            { type: core.Injectable },
        ];
        /** @nocollapse */
        NtModal.ctorParameters = function () { return [
            { type: common.Location, decorators: [{ type: core.Optional }] },
            { type: NtModalConfig, decorators: [{ type: core.Optional }, { type: core.Inject, args: [NT_MODAL_DEFAULT_CONFIG,] }] },
            { type: overlay.Overlay },
            { type: core.Injector }
        ]; };
        return NtModal;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtModalBodyComponent = /** @class */ (function () {
        function NtModalBodyComponent() {
        }
        NtModalBodyComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-modal-body',
                        template: "<ng-content></ng-content>",
                        host: {
                            'class': 'nt-modal-body'
                        }
                    },] },
        ];
        return NtModalBodyComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtModalFooterComponent = /** @class */ (function () {
        function NtModalFooterComponent() {
        }
        NtModalFooterComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-modal-footer',
                        template: "<ng-content></ng-content>",
                        host: {
                            'class': 'nt-modal-footer'
                        }
                    },] },
        ];
        return NtModalFooterComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtModalHeaderComponent = /** @class */ (function () {
        function NtModalHeaderComponent() {
        }
        NtModalHeaderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-modal-header',
                        template: "<ng-content></ng-content>",
                        host: {
                            class: 'nt-modal-header'
                        }
                    },] },
        ];
        return NtModalHeaderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtModalModule = /** @class */ (function () {
        function NtModalModule() {
        }
        NtModalModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, portal.PortalModule, overlay.OverlayModule],
                        entryComponents: [NtModalComponent],
                        declarations: [
                            NtModalComponent,
                            NtModalHeaderComponent,
                            NtModalBodyComponent,
                            NtModalFooterComponent
                        ],
                        providers: [NtModal],
                        exports: [
                            NtModalComponent,
                            NtModalHeaderComponent,
                            NtModalBodyComponent,
                            NtModalFooterComponent
                        ]
                    },] },
        ];
        return NtModalModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NtModalModule = NtModalModule;
    exports.NT_MODAL_DATA = NT_MODAL_DATA;
    exports.NT_MODAL_DEFAULT_CONFIG = NT_MODAL_DEFAULT_CONFIG;
    exports.NtModal = NtModal;
    exports.NtModalRef = NtModalRef;
    exports.NtModalConfig = NtModalConfig;
    exports.throwNtModalContentAlreadyAttachedError = throwNtModalContentAlreadyAttachedError;
    exports.NtModalComponent = NtModalComponent;
    exports.NtModalHeaderComponent = NtModalHeaderComponent;
    exports.NtModalBodyComponent = NtModalBodyComponent;
    exports.NtModalFooterComponent = NtModalFooterComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=modal.umd.js.map
