(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/cdk/overlay'), require('@angular/core'), require('@ng-tangram/components/core'), require('@angular/common'), require('@ng-tangram/components/button')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/cdk/overlay', '@angular/core', '@ng-tangram/components/core', '@angular/common', '@ng-tangram/components/button'], factory) :
    (factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.popconfirm = {}),global.ng.cdk.overlay,global.ng.core,global.nt.components.core,global.ng.common,global.nt.components.button));
}(this, (function (exports,overlay,core,core$1,common,button) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtPopConfirmComponent = /** @class */ (function () {
        function NtPopConfirmComponent(_elementRef) {
            this._elementRef = _elementRef;
            this._title = '';
            this.position = core$1.NtOverlayPosition.Top;
            this.confirmText = '确认';
            this.cancelText = '取消';
            this.confirm = new core.EventEmitter();
            this.cancel = new core.EventEmitter();
            this.afterOpen = new core.EventEmitter();
            this.afterClosed = new core.EventEmitter();
            this.beforeOpen = new core.EventEmitter();
            this.beforeClosed = new core.EventEmitter();
            this.positionChange = new core.EventEmitter();
            this.origin = new overlay.CdkOverlayOrigin(this._elementRef);
        }
        Object.defineProperty(NtPopConfirmComponent.prototype, "title", {
            get: /**
             * @return {?}
             */
            function () { return this._title; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._title = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtPopConfirmComponent.prototype, "template", {
            get: /**
             * @return {?}
             */
            function () { return this._template; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._template = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtPopConfirmComponent.prototype, "popconfirm", {
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (value instanceof core.TemplateRef) {
                    this._template = value;
                }
                else {
                    this._title = value;
                    this._template = null;
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} changes
         * @return {?}
         */
        NtPopConfirmComponent.prototype.ngOnChanges = /**
         * @param {?} changes
         * @return {?}
         */
        function (changes) {
            var _this = this;
            /** @type {?} */
            var change = changes.title || changes.template || changes.popover;
            if (change && !change.firstChange) {
                /** 在内容更新之后提示框的位置需要更新，需要延迟执行，因为这时候画面还未渲染 */
                Promise.resolve().then((/**
                 * @return {?}
                 */
                function () {
                    _this.overlay.cdkConnectedOverlay.overlayRef.updatePosition();
                }));
            }
        };
        /**
         * @param {?} isConfirm
         * @return {?}
         */
        NtPopConfirmComponent.prototype._closeOverlay = /**
         * @param {?} isConfirm
         * @return {?}
         */
        function (isConfirm) {
            (isConfirm ? this.confirm : this.cancel).emit();
            this.overlay.hide();
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtPopConfirmComponent.prototype._afterOpen = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.afterOpen.next(event);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtPopConfirmComponent.prototype._afterClosed = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.afterClosed.next(event);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtPopConfirmComponent.prototype._beforeOpen = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.beforeOpen.next(event);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtPopConfirmComponent.prototype._beforeClosed = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.beforeClosed.next(event);
        };
        /**
         * @param {?} change
         * @return {?}
         */
        NtPopConfirmComponent.prototype._positionChange = /**
         * @param {?} change
         * @return {?}
         */
        function (change) {
            this.positionChange.next(change);
        };
        NtPopConfirmComponent.decorators = [
            { type: core.Component, args: [{
                        selector: '[nt-popconfirm]',
                        template: "<ng-content></ng-content> <nt-overlay trigger=\"click\" arrow [origin]=\"origin\" [position]=\"position\" (afterOpen)=\"_afterOpen($event)\" (afterClosed)=\"_afterClosed($event)\" (beforeOpen)=\"_beforeOpen($event)\" (beforeClosed)=\"_beforeClosed($event)\" (positionChange)=\"_positionChange($event)\"> <div class=\"nt-popconfirm\"> <div class=\"nt-popconfirm-title\" *ngIf=\"template\"><ng-container *ngTemplateOutlet=\"template\"></ng-container></div> <div class=\"nt-popconfirm-title\" *ngIf=\"!template\" [innerHtml]=\"title\"></div> <div class=\"nt-popconfirm-action\"> <button nt-button color=\"secondary\" size=\"tiny\" (click)=\"_closeOverlay(false)\">{{cancelText}}</button> <button nt-button size=\"tiny\" (click)=\"_closeOverlay(true)\">{{confirmText}}</button> </div> </div> </nt-overlay> ",
                        encapsulation: core.ViewEncapsulation.None,
                        host: {
                            '(click)': 'overlay.click()'
                        }
                    },] },
        ];
        /** @nocollapse */
        NtPopConfirmComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        NtPopConfirmComponent.propDecorators = {
            title: [{ type: core.Input }],
            template: [{ type: core.Input }],
            popconfirm: [{ type: core.Input, args: ['nt-popconfirm',] }],
            position: [{ type: core.Input }],
            confirmText: [{ type: core.Input }],
            cancelText: [{ type: core.Input }],
            confirm: [{ type: core.Output }],
            cancel: [{ type: core.Output }],
            afterOpen: [{ type: core.Output }],
            afterClosed: [{ type: core.Output }],
            beforeOpen: [{ type: core.Output }],
            beforeClosed: [{ type: core.Output }],
            positionChange: [{ type: core.Output }],
            overlay: [{ type: core.ViewChild, args: [core$1.NtOverlayComponent, { static: true },] }]
        };
        return NtPopConfirmComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtPopConfirmModule = /** @class */ (function () {
        function NtPopConfirmModule() {
        }
        NtPopConfirmModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, core$1.NtOverlayModule, button.NtButtonModule],
                        exports: [NtPopConfirmComponent],
                        declarations: [NtPopConfirmComponent]
                    },] },
        ];
        return NtPopConfirmModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NtPopConfirmModule = NtPopConfirmModule;
    exports.NtPopConfirmComponent = NtPopConfirmComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=popconfirm.umd.js.map
