(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('rxjs'), require('@angular/cdk/observers'), require('@angular/core'), require('@angular/cdk/overlay'), require('@ng-tangram/components/core'), require('@angular/common'), require('@ng-tangram/components/dropdown')) :
    typeof define === 'function' && define.amd ? define(['exports', 'rxjs', '@angular/cdk/observers', '@angular/core', '@angular/cdk/overlay', '@ng-tangram/components/core', '@angular/common', '@ng-tangram/components/dropdown'], factory) :
    (factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.popover = {}),global.Rx,global.ng.cdk.observers,global.ng.core,global.ng.cdk.overlay,global.nt.components.core,global.ng.common,global.nt.components.dropdown));
}(this, (function (exports,rxjs,observers,core,overlay,core$1,common,dropdown) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var NT_POPOVER_PARENT_COMPONENT = new core.InjectionToken('nt-popover-parent-component');
    var NtPopoverPaneComponent = /** @class */ (function () {
        function NtPopoverPaneComponent(_contentObserver, _elementRef, _parent) {
            this._contentObserver = _contentObserver;
            this._elementRef = _elementRef;
            this._parent = _parent;
            this._contentChange = new rxjs.Subject();
        }
        Object.defineProperty(NtPopoverPaneComponent.prototype, "contentChanged", {
            get: /**
             * @return {?}
             */
            function () {
                return this._contentChange.asObservable();
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtPopoverPaneComponent.prototype, "textContent", {
            get: /**
             * @return {?}
             */
            function () {
                return (this._elementRef.nativeElement.textContent || '').trim();
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NtPopoverPaneComponent.prototype.ngAfterContentInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this._contentSubscription = this._contentObserver
                .observe(this._elementRef)
                .subscribe((/**
             * @return {?}
             */
            function () { return _this._checkContentChange(); }));
        };
        /**
         * @return {?}
         */
        NtPopoverPaneComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            if (this._contentSubscription) {
                this._contentSubscription.unsubscribe();
            }
        };
        /**
         * @private
         * @return {?}
         */
        NtPopoverPaneComponent.prototype._checkContentChange = /**
         * @private
         * @return {?}
         */
        function () {
            if (this._parent.overlay.isOpen) {
                /** @type {?} */
                var cdkConnectedOverlay = this._parent.overlay.cdkConnectedOverlay;
                if (cdkConnectedOverlay && cdkConnectedOverlay.overlayRef) {
                    cdkConnectedOverlay.overlayRef.updatePosition();
                }
            }
        };
        NtPopoverPaneComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-popover-pane, [nt-popover-pane]',
                        template: "\n    <ng-content></ng-content>\n  ",
                        encapsulation: core.ViewEncapsulation.None
                    },] },
        ];
        /** @nocollapse */
        NtPopoverPaneComponent.ctorParameters = function () { return [
            { type: observers.ContentObserver },
            { type: core.ElementRef },
            { type: undefined, decorators: [{ type: core.Inject, args: [NT_POPOVER_PARENT_COMPONENT,] }] }
        ]; };
        return NtPopoverPaneComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtPopoverComponent = /** @class */ (function () {
        function NtPopoverComponent(_elementRef) {
            this._elementRef = _elementRef;
            this._title = '';
            this.position = core$1.NtOverlayPosition.Top;
            this.confirm = new core.EventEmitter();
            this.cancel = new core.EventEmitter();
            this.afterOpen = new core.EventEmitter();
            this.afterClosed = new core.EventEmitter();
            this.beforeOpen = new core.EventEmitter();
            this.beforeClosed = new core.EventEmitter();
            this.positionChange = new core.EventEmitter();
            this.origin = new overlay.CdkOverlayOrigin(this._elementRef);
        }
        Object.defineProperty(NtPopoverComponent.prototype, "title", {
            get: /**
             * @return {?}
             */
            function () { return this._title; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._title = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtPopoverComponent.prototype, "template", {
            get: /**
             * @return {?}
             */
            function () { return this._template; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._template = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtPopoverComponent.prototype, "popover", {
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (value instanceof core.TemplateRef) {
                    this._template = value;
                }
                else {
                    this._title = value;
                    this._template = null;
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} event
         * @return {?}
         */
        NtPopoverComponent.prototype._afterOpen = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.afterOpen.next(event);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtPopoverComponent.prototype._afterClosed = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.afterClosed.next(event);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtPopoverComponent.prototype._beforeOpen = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.beforeOpen.next(event);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtPopoverComponent.prototype._beforeClosed = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.beforeClosed.next(event);
        };
        /**
         * @param {?} change
         * @return {?}
         */
        NtPopoverComponent.prototype._positionChange = /**
         * @param {?} change
         * @return {?}
         */
        function (change) {
            this.positionChange.next(change);
        };
        NtPopoverComponent.decorators = [
            { type: core.Component, args: [{
                        selector: '[nt-popover]',
                        template: "<ng-content></ng-content> <nt-overlay trigger=\"click\" arrow [origin]=\"origin\" [position]=\"position\" (afterOpen)=\"_afterOpen($event)\" (afterClosed)=\"_afterClosed($event)\" (beforeOpen)=\"_beforeOpen($event)\" (beforeClosed)=\"_beforeClosed($event)\" (positionChange)=\"_positionChange($event)\"> <div class=\"nt-popover\"> <div class=\"nt-popover-title\" *ngIf=\"template\"><ng-container *ngTemplateOutlet=\"template\"></ng-container></div> <div class=\"nt-popover-title\" *ngIf=\"!template\" [innerHtml]=\"title\"></div> <div class=\"nt-popover-pane\"> <ng-content select=\"nt-popover-pane\"></ng-content> </div> </div> </nt-overlay> ",
                        encapsulation: core.ViewEncapsulation.None,
                        host: {
                            '(click)': 'overlay.click()'
                        },
                        providers: [
                            { provide: NT_POPOVER_PARENT_COMPONENT, useExisting: NtPopoverComponent }
                        ]
                    },] },
        ];
        /** @nocollapse */
        NtPopoverComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        NtPopoverComponent.propDecorators = {
            title: [{ type: core.Input }],
            template: [{ type: core.Input }],
            popover: [{ type: core.Input, args: ['nt-popover',] }],
            position: [{ type: core.Input }],
            confirm: [{ type: core.Output }],
            cancel: [{ type: core.Output }],
            afterOpen: [{ type: core.Output }],
            afterClosed: [{ type: core.Output }],
            beforeOpen: [{ type: core.Output }],
            beforeClosed: [{ type: core.Output }],
            positionChange: [{ type: core.Output }],
            overlay: [{ type: core.ViewChild, args: [core$1.NtOverlayComponent, { static: true },] }]
        };
        return NtPopoverComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtPopoverModule = /** @class */ (function () {
        function NtPopoverModule() {
        }
        NtPopoverModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, observers.ObserversModule, core$1.NtOverlayModule, dropdown.NtDropdownModule],
                        exports: [NtPopoverComponent, NtPopoverPaneComponent],
                        declarations: [NtPopoverComponent, NtPopoverPaneComponent]
                    },] },
        ];
        return NtPopoverModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NtPopoverModule = NtPopoverModule;
    exports.NtPopoverComponent = NtPopoverComponent;
    exports.NT_POPOVER_PARENT_COMPONENT = NT_POPOVER_PARENT_COMPONENT;
    exports.NtPopoverPaneComponent = NtPopoverPaneComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=popover.umd.js.map
