(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/cdk/coercion')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/cdk/coercion'], factory) :
    (factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.progress = {}),global.ng.core,global.ng.cdk.coercion));
}(this, (function (exports,core,coercion) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtProgressCircleComponent = /** @class */ (function () {
        function NtProgressCircleComponent() {
            this._max = 100;
            this._value = 0;
            this._radius = 60;
            this.size = 'medium';
            this.color = '';
            /**
             * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
             *
             * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
             * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
             * @deprecated > 0.6.0
             */
            this.class = '';
        }
        Object.defineProperty(NtProgressCircleComponent.prototype, "dasharray", {
            get: /**
             * @return {?}
             */
            function () {
                return this.radius * 2 * Math.PI;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtProgressCircleComponent.prototype, "width", {
            get: /**
             * @return {?}
             */
            function () { return this.radius * 2 + 20; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtProgressCircleComponent.prototype, "height", {
            get: /**
             * @return {?}
             */
            function () { return this.radius * 2 + 20; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtProgressCircleComponent.prototype, "radius", {
            get: /**
             * @return {?}
             */
            function () { return this._radius; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._radius = coercion.coerceNumberProperty(value, 100); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtProgressCircleComponent.prototype, "max", {
            get: /**
             * @return {?}
             */
            function () { return this._max; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._max = coercion.coerceNumberProperty(value, 100); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtProgressCircleComponent.prototype, "value", {
            get: /**
             * @return {?}
             */
            function () { return this._value; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._value = coercion.coerceNumberProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtProgressCircleComponent.prototype, "percent", {
            get: /**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var percent = this.value / this.max * 100;
                return percent > 100 ? 100 : percent;
            },
            enumerable: true,
            configurable: true
        });
        NtProgressCircleComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-progress-circle',
                        template: "<div class=\"progress-container\"> <svg attr.viewPort=\"0 0 {{width / 2}} {{height / 2}}\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" [attr.width]=\"width\" [attr.height]=\"height\"> <circle [attr.r]=\"radius\" [attr.cx]=\"width / 2\" [attr.cy]=\"height / 2\" fill=\"transparent\" [attr.stroke-dasharray]=\"dasharray\" [attr.stroke-dashoffset]=\"0\"></circle> <circle class=\"progress-meter-circle\" [attr.r]=\"radius\" [attr.cx]=\"width / 2\" [attr.cy]=\"height / 2\" fill=\"transparent\" [attr.stroke-dasharray]=\"dasharray\" [attr.stroke-dashoffset]=\"dasharray - (dasharray / 100 * percent)\"></circle> </svg> <span class=\"progress-inner\"><ng-content></ng-content></span> </div> <!-- <div class=\"nt-progress-circle-inner\"><ng-content></ng-content></div> --> ",
                        host: {
                            '[class]': '["nt-progress-circle", color, size, class].join(" ")'
                        }
                    },] },
        ];
        NtProgressCircleComponent.propDecorators = {
            radius: [{ type: core.Input }],
            max: [{ type: core.Input }],
            value: [{ type: core.Input }],
            size: [{ type: core.Input }],
            color: [{ type: core.Input }],
            class: [{ type: core.Input }]
        };
        return NtProgressCircleComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtProgressComponent = /** @class */ (function () {
        function NtProgressComponent() {
            this._max = 100;
            this._value = 0;
            this.size = 'medium';
            this.color = '';
            /**
             * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
             *
             * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
             * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
             * @deprecated > 0.6.0
             */
            this.class = '';
        }
        Object.defineProperty(NtProgressComponent.prototype, "max", {
            get: /**
             * @return {?}
             */
            function () { return this._max; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._max = coercion.coerceNumberProperty(value, 100); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtProgressComponent.prototype, "value", {
            get: /**
             * @return {?}
             */
            function () { return this._value; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._value = coercion.coerceNumberProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtProgressComponent.prototype, "percent", {
            get: /**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var percent = this.value / this.max * 100;
                return percent > 100 ? 100 : percent;
            },
            enumerable: true,
            configurable: true
        });
        NtProgressComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-progress',
                        template: "<span class=\"progress-meter\" [style.width.%]=\"percent > 100 ? 100 : percent\"> <p class=\"progress-meter-text\"><ng-content></ng-content></p> </span> ",
                        host: {
                            '[class]': '["progress", color, size, class].join(" ")'
                        }
                    },] },
        ];
        NtProgressComponent.propDecorators = {
            max: [{ type: core.Input }],
            value: [{ type: core.Input }],
            size: [{ type: core.Input }],
            color: [{ type: core.Input }],
            class: [{ type: core.Input }]
        };
        return NtProgressComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NtProgressModule = /** @class */ (function () {
        function NtProgressModule() {
        }
        NtProgressModule.decorators = [
            { type: core.NgModule, args: [{
                        exports: [NtProgressComponent, NtProgressCircleComponent],
                        declarations: [NtProgressComponent, NtProgressCircleComponent]
                    },] },
        ];
        return NtProgressModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NtProgressModule = NtProgressModule;
    exports.NtProgressComponent = NtProgressComponent;
    exports.NtProgressCircleComponent = NtProgressCircleComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=progress.umd.js.map
