(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators'), require('@angular/animations'), require('@angular/cdk/a11y'), require('@angular/cdk/coercion'), require('@angular/cdk/collections'), require('@angular/cdk/keycodes'), require('@angular/cdk/overlay'), require('@angular/forms'), require('@ng-tangram/components/core'), require('@ng-tangram/components/forms'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/core', 'rxjs', 'rxjs/operators', '@angular/animations', '@angular/cdk/a11y', '@angular/cdk/coercion', '@angular/cdk/collections', '@angular/cdk/keycodes', '@angular/cdk/overlay', '@angular/forms', '@ng-tangram/components/core', '@ng-tangram/components/forms', '@angular/common'], factory) :
    (factory((global.nt = global.nt || {}, global.nt.components = global.nt.components || {}, global.nt.components.select = {}),global.ng.core,global.Rx,global.Rx.operators,global.ng.animations,global.ng.cdk.a11y,global.ng.cdk.coercion,global.ng.cdk.collections,global.ng.cdk.keycodes,global.ng.cdk.overlay,global.ng.forms,global.nt.components.core,global.nt.components.forms,global.ng.common));
}(this, (function (exports,core,rxjs,operators,animations,a11y,coercion,collections,keycodes,overlay,forms,core$1,forms$1,common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var NT_SELECT_ICONS = new core.InjectionToken('nt-select-icons');

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @return {?}
     */
    function getNtSelectDynamicMultipleError() {
        return Error('Cannot change `multiple` mode of select after initialization.');
    }
    /**
     * @return {?}
     */
    function getNtSelectNonArrayValueError() {
        return Error('Value must be an array in multiple-selection mode.');
    }
    /**
     * @return {?}
     */
    function getNtSelectNonFunctionValueError() {
        return Error('`compareWith` must be a function.');
    }
    var NtSelectChange = /** @class */ (function () {
        function NtSelectChange(source, value) {
            this.source = source;
            this.value = value;
        }
        return NtSelectChange;
    }());
    var NtSelectComponent = /** @class */ (function (_super) {
        __extends(NtSelectComponent, _super);
        function NtSelectComponent(_ngZone, _elementRef, _changeDetectorRef, ngControl, icons) {
            var _this = _super.call(this) || this;
            _this._ngZone = _ngZone;
            _this._elementRef = _elementRef;
            _this._changeDetectorRef = _changeDetectorRef;
            _this.ngControl = ngControl;
            _this.icons = icons;
            _this._destroy = new rxjs.Subject();
            _this._positionPairs = [core$1.BOTTOM_LEFT, core$1.TOP_LEFT];
            _this._compareWith = (/**
             * @param {?} o1
             * @param {?} o2
             * @return {?}
             */
            function (o1, o2) { return o1 === o2; });
            _this._onChange = (/**
             * @return {?}
             */
            function () { });
            _this._onTouched = (/**
             * @return {?}
             */
            function () { });
            _this._focused = false;
            _this._disabled = false;
            _this._required = false;
            _this._state = '';
            _this._multiple = false;
            _this.filterNotFound = 'Not Found';
            _this._placeholder = '';
            _this.afterOpen = new core.EventEmitter();
            _this.afterClosed = new core.EventEmitter();
            _this.beforeOpen = new core.EventEmitter();
            _this.beforeClosed = new core.EventEmitter();
            _this.positionChange = new core.EventEmitter();
            _this.selectionChange = new core.EventEmitter();
            _this.valueChange = new core.EventEmitter();
            _this.optionSelectionChanges = rxjs.defer((/**
             * @return {?}
             */
            function () {
                if (_this.options) {
                    return rxjs.merge.apply(void 0, _this.options.map((/**
                     * @param {?} option
                     * @return {?}
                     */
                    function (option) { return option.selectionChange; })));
                }
                return _this._ngZone.onStable
                    .asObservable()
                    .pipe(operators.take(1), operators.switchMap((/**
                 * @return {?}
                 */
                function () { return _this.optionSelectionChanges; })));
            }));
            _this.origin = new overlay.CdkOverlayOrigin(_this._elementRef);
            if (_this.ngControl) {
                _this.ngControl.valueAccessor = _this;
            }
            return _this;
        }
        Object.defineProperty(NtSelectComponent.prototype, "value", {
            get: /**
             * @return {?}
             */
            function () { return this._value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtSelectComponent.prototype, "triggerValue", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.empty) {
                    return '';
                }
                if (this._multiple) {
                    /** @type {?} */
                    var selectedOptions = this._selectionModel.selected.map((/**
                     * @param {?} option
                     * @return {?}
                     */
                    function (option) { return option.label; }));
                    return selectedOptions.join(', ');
                }
                return this._selectionModel.selected[0].label;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtSelectComponent.prototype, "empty", {
            get: /**
             * @return {?}
             */
            function () { return !this._selectionModel || this._selectionModel.isEmpty(); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtSelectComponent.prototype, "optionEmpty", {
            get: /**
             * @return {?}
             */
            function () {
                return this.options ? this.options.filter((/**
                 * @param {?} option
                 * @return {?}
                 */
                function (option) { return !option.hidden; })).length === 0 : false;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtSelectComponent.prototype, "focused", {
            get: /**
             * @return {?}
             */
            function () { return this._focused; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtSelectComponent.prototype, "disabled", {
            get: /**
             * @return {?}
             */
            function () { return this._disabled; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._disabled = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtSelectComponent.prototype, "required", {
            get: /**
             * @return {?}
             */
            function () { return this._required; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._required = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtSelectComponent.prototype, "state", {
            get: /**
             * @return {?}
             */
            function () { return this._state; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtSelectComponent.prototype, "width", {
            get: /**
             * @return {?}
             */
            function () { return this._width; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtSelectComponent.prototype, "multiple", {
            get: /**
             * @return {?}
             */
            function () { return this._multiple; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._multiple = coercion.coerceBooleanProperty(value); },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtSelectComponent.prototype, "filter", {
            get: /**
             * @return {?}
             */
            function () { return this._filter; },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (typeof value === 'function') {
                    this._filter = value;
                }
                else if (coercion.coerceBooleanProperty(value)) {
                    this._filter = (/**
                     * @param {?} keyword
                     * @param {?} option
                     * @return {?}
                     */
                    function (keyword, option) {
                        /** @type {?} */
                        var regex = new RegExp(keyword.toLowerCase(), 'g');
                        return regex.test(option.label.toLowerCase());
                    });
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtSelectComponent.prototype, "selected", {
            get: /**
             * @return {?}
             */
            function () {
                return this.multiple ? this._selectionModel.selected : this._selectionModel.selected[0];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtSelectComponent.prototype, "placeholder", {
            get: /**
             * @return {?}
             */
            function () {
                if (this.empty) {
                    return this._placeholder;
                }
                return this.filter ? this.triggerValue : this._placeholder;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) { this._placeholder = value; },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(NtSelectComponent.prototype, "compareWith", {
            set: /**
             * @param {?} fn
             * @return {?}
             */
            function (fn) {
                if (typeof fn !== 'function') {
                    throw getNtSelectNonFunctionValueError();
                }
                else {
                    this._compareWith = fn;
                    if (this._selectionModel) {
                        this._initializeSelection();
                    }
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        NtSelectComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this._selectionModel = new collections.SelectionModel(this.multiple, undefined, false);
        };
        /**
         * @return {?}
         */
        NtSelectComponent.prototype.ngAfterContentInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this._initKeyManager();
            this.options.changes.pipe(operators.startWith(null), operators.takeUntil(this._destroy)).subscribe((/**
             * @return {?}
             */
            function () {
                _this._resetOptions();
                _this._initializeSelection();
            }));
        };
        /**
         * @return {?}
         */
        NtSelectComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this._destroy.next();
            this._destroy.complete();
        };
        /**
         * @return {?}
         */
        NtSelectComponent.prototype.onResize = /**
         * @return {?}
         */
        function () {
            this._width = this.inputElement.nativeElement.clientWidth;
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtSelectComponent.prototype.onSearch = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            var _this = this;
            if (this.focused && this.filter && !this.disabled) {
                /** @type {?} */
                var target_1 = event.target;
                this.options.forEach((/**
                 * @param {?} option
                 * @return {?}
                 */
                function (option) { return option.hidden = !_this.filter(target_1.value, option); }));
            }
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtSelectComponent.prototype._beforeOpen = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this._state = 'folded';
            this.onResize();
            this._scrollActiveOptionIntoView();
            this._highlightCorrectOption();
            this.beforeOpen.next(event);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtSelectComponent.prototype._beforeClosed = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this._state = 'closed';
            this._onTouched();
            this.beforeClosed.next(event);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtSelectComponent.prototype._afterOpen = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.afterOpen.next(event);
        };
        /**
         * @param {?} event
         * @return {?}
         */
        NtSelectComponent.prototype._afterClosed = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this._resetFilterResult();
            this.inputElement.nativeElement.blur();
            this.afterClosed.next(event);
        };
        /**
         * @param {?} change
         * @return {?}
         */
        NtSelectComponent.prototype._positionChange = /**
         * @param {?} change
         * @return {?}
         */
        function (change) {
            this.positionChange.next(change);
        };
        /**
         * @return {?}
         */
        NtSelectComponent.prototype.onFocus = /**
         * @return {?}
         */
        function () {
            if (!this.overlay.isOpen && !this._disabled) {
                this.overlay.show();
                this._focused = true;
            }
        };
        /**
         * @return {?}
         */
        NtSelectComponent.prototype.onBlur = /**
         * @return {?}
         */
        function () {
            this._focused = false;
        };
        /**
         * @return {?}
         */
        NtSelectComponent.prototype.focus = /**
         * @return {?}
         */
        function () {
            this.inputElement.nativeElement.focus();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        NtSelectComponent.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (this.options) {
                this._setSelectionByValue(value);
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        NtSelectComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        NtSelectComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._onTouched = fn;
        };
        /**
         * @return {?}
         */
        NtSelectComponent.prototype.clear = /**
         * @return {?}
         */
        function () {
            if (!this.disabled) {
                this._clearSelection();
                this._value = null;
                this._onChange(this.value);
                this.valueChange.next(this.value);
            }
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        NtSelectComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this._disabled = isDisabled;
        };
        /** Handles all keydown events on the select. */
        /**
         * Handles all keydown events on the select.
         * @param {?} event
         * @return {?}
         */
        NtSelectComponent.prototype._handleKeydown = /**
         * Handles all keydown events on the select.
         * @param {?} event
         * @return {?}
         */
        function (event) {
            if (!this.disabled) {
                this.overlay.isOpen ? this._handleOpenKeydown(event) : this._handleClosedKeydown(event);
            }
        };
        /** Handles keyboard events when the selected is open. */
        /**
         * Handles keyboard events when the selected is open.
         * @private
         * @param {?} event
         * @return {?}
         */
        NtSelectComponent.prototype._handleOpenKeydown = /**
         * Handles keyboard events when the selected is open.
         * @private
         * @param {?} event
         * @return {?}
         */
        function (event) {
            /** @type {?} */
            var keyCode = event.keyCode;
            /** @type {?} */
            var isArrowKey = keyCode === keycodes.DOWN_ARROW || keyCode === keycodes.UP_ARROW;
            /** @type {?} */
            var manager = this._keyManager;
            if (keyCode === keycodes.HOME || keyCode === keycodes.END) {
                event.preventDefault();
                keyCode === keycodes.HOME ? manager.setFirstItemActive() : manager.setLastItemActive();
            }
            else if (isArrowKey && event.altKey) {
                event.preventDefault();
                this.overlay.hide();
            }
            else if ((keyCode === keycodes.ENTER || keyCode === keycodes.SPACE) && manager.activeItem) {
                event.preventDefault();
                manager.activeItem.selectViaInteraction();
                if (keyCode === keycodes.ENTER && this.multiple) {
                    this.overlay.hide();
                }
            }
            else {
                /** @type {?} */
                var previouslyFocusedIndex = manager.activeItemIndex;
                manager.onKeydown(event);
                if (this._multiple && isArrowKey && event.shiftKey && manager.activeItem &&
                    manager.activeItemIndex !== previouslyFocusedIndex) {
                    manager.activeItem.selectViaInteraction();
                }
            }
        };
        /**
         * @private
         * @param {?} event
         * @return {?}
         */
        NtSelectComponent.prototype._handleClosedKeydown = /**
         * @private
         * @param {?} event
         * @return {?}
         */
        function (event) {
            /** @type {?} */
            var keyCode = event.keyCode;
            /** @type {?} */
            var isArrowKey = keyCode === keycodes.DOWN_ARROW || keyCode === keycodes.UP_ARROW ||
                keyCode === keycodes.LEFT_ARROW || keyCode === keycodes.RIGHT_ARROW;
            /** @type {?} */
            var isOpenKey = keyCode === keycodes.ENTER || keyCode === keycodes.SPACE;
            // Open the select on ALT + arrow key to match the native <select>
            if (isOpenKey || ((this.multiple || event.altKey) && isArrowKey)) {
                event.preventDefault(); // prevents the page from scrolling down when pressing space
                this.overlay.show();
            }
            else if (!this.multiple) {
                this._keyManager.onKeydown(event);
            }
        };
        /**
         * @private
         * @return {?}
         */
        NtSelectComponent.prototype._resetOptions = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            /** @type {?} */
            var changedOrDestroyed = rxjs.merge(this.options.changes, this._destroy);
            this.optionSelectionChanges
                .pipe(operators.takeUntil(changedOrDestroyed), operators.filter((/**
             * @param {?} event
             * @return {?}
             */
            function (event) { return event.isUserInput; })))
                .subscribe((/**
             * @param {?} event
             * @return {?}
             */
            function (event) {
                _this._onSelect(event.source);
                if (!_this.multiple && _this.overlay.isOpen) {
                    _this.overlay.hide();
                }
            }));
            // Listen to changes in the internal state of the options and react accordingly.
            // Handles cases like the labels of the selected options changing.
            rxjs.merge.apply(void 0, this.options.map((/**
             * @param {?} option
             * @return {?}
             */
            function (option) { return option.stateChanges; }))).pipe(operators.takeUntil(changedOrDestroyed))
                .subscribe((/**
             * @return {?}
             */
            function () {
                _this._changeDetectorRef.markForCheck();
            }));
            this._resetFilterResult();
        };
        /** Sets up a key manager to listen to keyboard events on the overlay panel. */
        /**
         * Sets up a key manager to listen to keyboard events on the overlay panel.
         * @private
         * @return {?}
         */
        NtSelectComponent.prototype._initKeyManager = /**
         * Sets up a key manager to listen to keyboard events on the overlay panel.
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            this._keyManager = new a11y.ActiveDescendantKeyManager(this.options)
                .withTypeAhead()
                .withVerticalOrientation();
            this._keyManager.tabOut.pipe(operators.takeUntil(this._destroy)).subscribe((/**
             * @return {?}
             */
            function () {
                // Restore focus to the trigger before closing. Ensures that the focus
                // position won't be lost if the user got focus into the overlay.
                _this.focus();
                _this.overlay.hide();
                // this.inputElement.nativeElement.blur();
            }));
            this._keyManager.change.pipe(operators.takeUntil(this._destroy)).subscribe((/**
             * @return {?}
             */
            function () {
                if (_this.overlay.isOpen && _this.paneElement) {
                    _this._scrollActiveOptionIntoView();
                }
                else if (!_this.overlay.isOpen && !_this.multiple && _this._keyManager.activeItem) {
                    _this._keyManager.activeItem.selectViaInteraction();
                }
            }));
        };
        /**
         * @private
         * @return {?}
         */
        NtSelectComponent.prototype._resetFilterResult = /**
         * @private
         * @return {?}
         */
        function () {
            this.options.forEach((/**
             * @param {?} option
             * @return {?}
             */
            function (option) { return option.hidden = false; }));
        };
        /**
         * @private
         * @return {?}
         */
        NtSelectComponent.prototype._initializeSelection = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            Promise.resolve().then((/**
             * @return {?}
             */
            function () {
                _this._setSelectionByValue(_this.ngControl ? _this.ngControl.value : _this.value);
            }));
        };
        /**
         * @private
         * @param {?} value
         * @param {?=} isUserInput
         * @return {?}
         */
        NtSelectComponent.prototype._setSelectionByValue = /**
         * @private
         * @param {?} value
         * @param {?=} isUserInput
         * @return {?}
         */
        function (value, isUserInput) {
            var _this = this;
            if (isUserInput === void 0) { isUserInput = false; }
            if (this.multiple && value) {
                if (!Array.isArray(value)) {
                    throw getNtSelectNonArrayValueError();
                }
                this._clearSelection();
                value.forEach((/**
                 * @param {?} currentValue
                 * @return {?}
                 */
                function (currentValue) { return _this._selectValue(currentValue, isUserInput); }));
                this._sortValues();
            }
            else {
                this._clearSelection();
                /** @type {?} */
                var correspondingOption = this._selectValue(value, isUserInput);
                // Shift focus to the active item. Note that we shouldn't do this in multiple
                // mode, because we don't know what option the user interacted with last.
                if (correspondingOption) {
                    this._keyManager.setActiveItem(this.options.toArray().indexOf(correspondingOption));
                }
            }
            this._changeDetectorRef.markForCheck();
        };
        /**
         * @private
         * @param {?} value
         * @param {?=} isUserInput
         * @return {?}
         */
        NtSelectComponent.prototype._selectValue = /**
         * @private
         * @param {?} value
         * @param {?=} isUserInput
         * @return {?}
         */
        function (value, isUserInput) {
            var _this = this;
            if (isUserInput === void 0) { isUserInput = false; }
            /** @type {?} */
            var correspondingOption = this.options.find((/**
             * @param {?} option
             * @return {?}
             */
            function (option) {
                try {
                    return option.value != null && _this._compareWith(option.value, value);
                }
                catch (error) {
                    if (core.isDevMode()) {
                        console.warn(error);
                    }
                    return false;
                }
            }));
            if (correspondingOption) {
                isUserInput ? correspondingOption.selectViaInteraction() : correspondingOption.select();
                this._selectionModel.select(correspondingOption);
            }
            return correspondingOption;
        };
        /**
         * @private
         * @param {?=} fallbackValue
         * @return {?}
         */
        NtSelectComponent.prototype._propagateChanges = /**
         * @private
         * @param {?=} fallbackValue
         * @return {?}
         */
        function (fallbackValue) {
            /** @type {?} */
            var valueToEmit = null;
            if (this.multiple) {
                valueToEmit = ((/** @type {?} */ (this.selected))).map((/**
                 * @param {?} option
                 * @return {?}
                 */
                function (option) { return option.value; }));
            }
            else {
                valueToEmit = this.selected ? ((/** @type {?} */ (this.selected))).value : fallbackValue;
            }
            this._value = valueToEmit;
            this.valueChange.emit(valueToEmit);
            this._onChange(valueToEmit);
            this.selectionChange.emit(new NtSelectChange(this, valueToEmit));
            this._changeDetectorRef.markForCheck();
        };
        /**
         * @private
         * @param {?=} skip
         * @return {?}
         */
        NtSelectComponent.prototype._clearSelection = /**
         * @private
         * @param {?=} skip
         * @return {?}
         */
        function (skip) {
            this._selectionModel.clear();
            this.options.forEach((/**
             * @param {?} option
             * @return {?}
             */
            function (option) {
                if (option !== skip) {
                    option.deselect();
                }
            }));
        };
        /**
         * @private
         * @return {?}
         */
        NtSelectComponent.prototype._sortValues = /**
         * @private
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.multiple) {
                this._selectionModel.clear();
                this.options.forEach((/**
                 * @param {?} option
                 * @return {?}
                 */
                function (option) {
                    if (option.selected) {
                        _this._selectionModel.select(option);
                    }
                }));
            }
        };
        /**
         * @private
         * @param {?} option
         * @return {?}
         */
        NtSelectComponent.prototype._onSelect = /**
         * @private
         * @param {?} option
         * @return {?}
         */
        function (option) {
            /** @type {?} */
            var wasSelected = this._selectionModel.isSelected(option);
            if (this.multiple) {
                this._selectionModel.toggle(option);
                wasSelected ? option.deselect() : option.select();
                this._keyManager.setActiveItem(this.options.toArray().indexOf(option));
                this._sortValues();
            }
            else {
                this._clearSelection(option.value == null ? undefined : option);
                if (option.value == null) {
                    this._propagateChanges(option.value);
                }
                else {
                    this._selectionModel.select(option);
                }
            }
            if (wasSelected !== this._selectionModel.isSelected(option)) {
                this._propagateChanges();
            }
        };
        /**
         * Highlights the selected item. If no option is selected, it will highlight
         * the first item instead.
         */
        /**
         * Highlights the selected item. If no option is selected, it will highlight
         * the first item instead.
         * @private
         * @return {?}
         */
        NtSelectComponent.prototype._highlightCorrectOption = /**
         * Highlights the selected item. If no option is selected, it will highlight
         * the first item instead.
         * @private
         * @return {?}
         */
        function () {
            if (this._keyManager) {
                if (this.empty) {
                    this._keyManager.setFirstItemActive();
                }
                else {
                    /** @type {?} */
                    var selectIndex = this.options.toArray().indexOf(this._selectionModel.selected[0]);
                    this._keyManager.setActiveItem(selectIndex);
                }
            }
        };
        /**
         * @private
         * @return {?}
         */
        NtSelectComponent.prototype._scrollActiveOptionIntoView = /**
         * @private
         * @return {?}
         */
        function () {
            /** @type {?} */
            var activeOption = this._keyManager.activeItem || this.options.first;
            if (!activeOption) {
                return;
            }
            /** @type {?} */
            var panelScrollTop = this.paneElement.nativeElement.scrollTop;
            /** @type {?} */
            var panelScrollBottom = panelScrollTop + this.paneElement.nativeElement.offsetHeight;
            if (panelScrollBottom === 0) {
                this.paneElement.nativeElement.scrollTop = activeOption.getOffsetTop();
            }
            else if (activeOption.getOffsetTop() < panelScrollTop) {
                // 当活动选项超出 panel 的顶部范围时，重新设置 panel 可视区域。
                this.paneElement.nativeElement.scrollTop = activeOption.getOffsetTop();
            }
            else if (activeOption.getOffsetTop() + activeOption.getOffsetHeight() >= panelScrollBottom) {
                // 当活动选项超出 panel 的底部范围时，重新设置 panel 可视区域。
                /** @type {?} */
                var scrollOffset = this.paneElement.nativeElement.offsetHeight - activeOption.getOffsetHeight();
                this.paneElement.nativeElement.scrollTop = activeOption.getOffsetTop() - scrollOffset;
            }
        };
        NtSelectComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'nt-select',
                        template: "<input #inputElement type=\"text\" (focus)=\"onFocus()\" (blur)=\"onBlur()\" (window:resize)=\"onResize()\" (keyup)=\"onSearch($event)\" [readonly]=\"!filter\" [placeholder]=\"placeholder\" [disabled]=\"disabled\" [value]=\"filter && focused ? '' : triggerValue\"> <span class=\"nt-select-caret {{ icons.caret }}\" [@fade] *ngIf=\"!triggerValue || disabled\"></span> <span class=\"nt-select-clear {{ icons.clear }}\" [@fade] *ngIf=\"triggerValue && !disabled\" (click)=\"clear()\"></span> <nt-overlay [origin]=\"origin\" trigger=\"click\" [positionPairs]=\"_positionPairs\" (afterOpen)=\"_afterOpen($event)\" (afterClosed)=\"_afterClosed($event)\" (beforeOpen)=\"_beforeOpen($event)\" (beforeClosed)=\"_beforeClosed($event)\" (positionChange)=\"_positionChange($event)\" (keydownEvents)=\"_handleKeydown($event)\"> <div #paneElement class=\"nt-select-pane\" [class.folded]=\"state === 'folded'\" [style.width.px]=\"width\"> <ng-content select=\"nt-option\"></ng-content> <div class=\"filter-empty\" *ngIf=\"optionEmpty\" (click)=\"overlay.hide()\"> {{ filterNotFound }} </div> </div> </nt-overlay> ",
                        providers: [
                            { provide: core$1.NT_OPTION_PARENT_COMPONENT, useExisting: NtSelectComponent },
                            { provide: forms$1.NtFormFieldControl, useExisting: NtSelectComponent }
                        ],
                        encapsulation: core.ViewEncapsulation.None,
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        animations: [
                            animations.trigger('fade', [
                                animations.transition('* => void', core$1.fadeOut(.15)),
                                animations.transition('void => *', core$1.fadeIn(.15))
                            ])
                        ],
                        host: {
                            'class': 'nt-select',
                            '(resize)': 'onResize()',
                            '[class.focus]': 'overlay.isOpen'
                        }
                    },] },
        ];
        /** @nocollapse */
        NtSelectComponent.ctorParameters = function () { return [
            { type: core.NgZone },
            { type: core.ElementRef },
            { type: core.ChangeDetectorRef },
            { type: forms.NgControl, decorators: [{ type: core.Self }, { type: core.Optional }] },
            { type: undefined, decorators: [{ type: core.Inject, args: [NT_SELECT_ICONS,] }] }
        ]; };
        NtSelectComponent.propDecorators = {
            disabled: [{ type: core.Input }],
            required: [{ type: core.Input }],
            multiple: [{ type: core.Input }],
            filter: [{ type: core.Input }],
            filterNotFound: [{ type: core.Input }],
            placeholder: [{ type: core.Input }],
            inputElement: [{ type: core.ViewChild, args: ['inputElement', { static: true },] }],
            paneElement: [{ type: core.ViewChild, args: ['paneElement', { static: true },] }],
            overlay: [{ type: core.ViewChild, args: [core$1.NtOverlayComponent, { static: true },] }],
            options: [{ type: core.ContentChildren, args: [core$1.NtOptionComponent,] }],
            afterOpen: [{ type: core.Output }],
            afterClosed: [{ type: core.Output }],
            beforeOpen: [{ type: core.Output }],
            beforeClosed: [{ type: core.Output }],
            positionChange: [{ type: core.Output }],
            selectionChange: [{ type: core.Output }],
            valueChange: [{ type: core.Output }],
            compareWith: [{ type: core.Input }]
        };
        return NtSelectComponent;
    }(forms$1.NtFormFieldControl));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var DEFAULT_SELECT_ICONS = {
        caret: 'fa fa-chevron-down',
        clear: 'fa fa-times'
    };
    var ɵ0 = DEFAULT_SELECT_ICONS;
    var NtSelectModule = /** @class */ (function () {
        function NtSelectModule() {
        }
        /**
         * @param {?=} icons
         * @return {?}
         */
        NtSelectModule.forRoot = /**
         * @param {?=} icons
         * @return {?}
         */
        function (icons) {
            if (icons === void 0) { icons = DEFAULT_SELECT_ICONS; }
            return {
                ngModule: NtSelectModule,
                providers: [
                    { provide: NT_SELECT_ICONS, useValue: icons }
                ]
            };
        };
        NtSelectModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [common.CommonModule, core$1.NtOverlayModule, core$1.NtOptionModule],
                        exports: [NtSelectComponent, core$1.NtOptionModule],
                        declarations: [NtSelectComponent],
                        providers: [
                            { provide: NT_SELECT_ICONS, useValue: ɵ0 }
                        ]
                    },] },
        ];
        return NtSelectModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NtSelectModule = NtSelectModule;
    exports.getNtSelectDynamicMultipleError = getNtSelectDynamicMultipleError;
    exports.getNtSelectNonArrayValueError = getNtSelectNonArrayValueError;
    exports.getNtSelectNonFunctionValueError = getNtSelectNonFunctionValueError;
    exports.NtSelectChange = NtSelectChange;
    exports.NtSelectComponent = NtSelectComponent;
    exports.NT_SELECT_ICONS = NT_SELECT_ICONS;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=select.umd.js.map
