import { AnimationEvent } from '@angular/animations';
import { EventEmitter } from '@angular/core';
export declare type NtCalloutColor = 'primary' | 'secondary' | 'success' | 'warning' | 'alert';
export declare type NtCalloutSize = 'small' | 'large' | 'medium';
export declare class NtCalloutComponent {
    title: string;
    color: NtCalloutColor;
    size: NtCalloutSize;
    /**
     * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
     *
     * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
     * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
     * @deprecated > 0.6.0
     */
    class: string;
    private _closed;
    readonly closed: boolean;
    private _closable;
    closable: boolean;
    close: EventEmitter<any>;
    fadeOut: boolean;
    onAnimationDone(event: AnimationEvent): void;
    constructor();
    _close(): void;
}
