import { ConnectionPositionPair, HorizontalConnectionPos, VerticalConnectionPos } from '@angular/cdk/overlay';
export declare enum NtOverlayPosition {
    Bottom = "bottom",
    BottomLeft = "bottomLeft",
    BottomRight = "bottomRight",
    Top = "top",
    TopLeft = "topLeft",
    TopRight = "topRight",
    Left = "left",
    LeftTop = "leftTop",
    LeftBottom = "leftBottom",
    Right = "right",
    RightTop = "rightTop",
    RightBottom = "rightBottom"
}
export declare enum NtOverlayOrientation {
    Vertical = "vertical",
    Horizontal = "horizontal"
}
/**
 * 定义并返回一个 overlay 窗体定位
 * @param originX 主体的中心x轴，窗体会相对于主体的中心点定位。
 * @param originY 主体的中心y轴，窗体会相对于主体的中心点定位。
 * @param overlayX 窗体的中心x轴。
 * @param overlayY 窗体的中心y轴。
 */
export declare function getConnectionPositionPair(originX: HorizontalConnectionPos, originY: VerticalConnectionPos, overlayX: HorizontalConnectionPos, overlayY: VerticalConnectionPos): ConnectionPositionPair;
/**
 * 获取定位名称拼接字符串
 * @param pair 定位类型。
 */
export declare function getPositionClassName(pair: ConnectionPositionPair): string;
/**
 *
 * @param position
 */
export declare function getPositionOrientation(position: string): NtOverlayOrientation;
/**
 * Overley 方向定位常量
 */
export declare const BOTTOM_LEFT: ConnectionPositionPair, BOTTOM_CENTER: ConnectionPositionPair, BOTTOM_RIGHT: ConnectionPositionPair, TOP_LEFT: ConnectionPositionPair, TOP_CENTER: ConnectionPositionPair, TOP_RIGHT: ConnectionPositionPair, LEFT_TOP: ConnectionPositionPair, LEFT_CENTER: ConnectionPositionPair, LEFT_BOTTOM: ConnectionPositionPair, RIGHT_TOP: ConnectionPositionPair, RIGHT_CENTER: ConnectionPositionPair, RIGHT_BOTTOM: ConnectionPositionPair;
/**
 * 定位策略
 */
export declare const NT_OVERLAY_POSITION_PAIRS: {
    bottom: ConnectionPositionPair[];
    bottomLeft: ConnectionPositionPair[];
    bottomRight: ConnectionPositionPair[];
    top: ConnectionPositionPair[];
    topLeft: ConnectionPositionPair[];
    topRight: ConnectionPositionPair[];
    left: ConnectionPositionPair[];
    leftTop: ConnectionPositionPair[];
    leftBottom: ConnectionPositionPair[];
    right: ConnectionPositionPair[];
    rightTop: ConnectionPositionPair[];
    rightBottom: ConnectionPositionPair[];
};
