import { AnimationEvent } from '@angular/animations';
import { CdkConnectedOverlay, CdkOverlayOrigin, ConnectedOverlayPositionChange, ConnectionPositionPair } from '@angular/cdk/overlay';
import { AfterContentChecked, AfterViewInit, EventEmitter, OnChanges, OnDestroy, Renderer2, SimpleChanges } from '@angular/core';
import { NtOverlayPosition } from './overlay-positions';
export declare type NtOverlayTriggerType = '' | 'hover' | 'click';
export declare class NtOverlayComponent implements AfterViewInit, AfterContentChecked, OnChanges, OnDestroy {
    private _renderer;
    private readonly _destroy;
    private _isOpen;
    private _isMouseIn;
    private _origin;
    private _position;
    private _positionPairs;
    private _paddingClass;
    private _arrow;
    private _noSpacing;
    private _trigger;
    private _overlayClass;
    private _fixed;
    private _closeEvent;
    private _positionChange;
    readonly isOpen: boolean;
    readonly isMouseIn: boolean;
    origin: CdkOverlayOrigin;
    position: NtOverlayPosition;
    positionPairs: ConnectionPositionPair[];
    readonly paddingClass: string;
    fixed: boolean;
    arrow: boolean;
    noSpacing: boolean;
    trigger: NtOverlayTriggerType;
    overlayClass: string;
    cdkConnectedOverlay: CdkConnectedOverlay;
    afterOpen: EventEmitter<any>;
    afterClosed: EventEmitter<any>;
    beforeOpen: EventEmitter<any>;
    beforeClosed: EventEmitter<any>;
    positionChange: EventEmitter<ConnectedOverlayPositionChange>;
    keydownEvents: EventEmitter<KeyboardEvent>;
    constructor(_renderer: Renderer2);
    ngAfterViewInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterContentChecked(): void;
    ngOnDestroy(): void;
    private _setPosition;
    show(): void;
    hide(): void;
    click(): void;
    onOverlayPositionChange(event: ConnectedOverlayPositionChange): void;
    onMouseEnter(): void;
    onMouseLeave(): void;
    onAnimationStart(event: AnimationEvent): void;
    onAnimationDone(event: AnimationEvent): void;
    private _setContainerStyles;
}
