import { CdkOverlayOrigin, ConnectedOverlayPositionChange, ConnectionPositionPair } from '@angular/cdk/overlay';
import { ElementRef, EventEmitter } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
import { DateAdapter, NtDateFormats, NtOverlayComponent } from '@ng-tangram/components/core';
import { NtFormFieldControl } from '@ng-tangram/components/forms';
import { NtDatePickerCalendarComponent } from './calendar.component';
import { NtDatePickerIcons } from './datepicker-icons';
export declare class NtDatePickerComponent<D> extends NtFormFieldControl<D> implements ControlValueAccessor {
    private _dateAdapter;
    private _dateFormats;
    ngControl: NgControl;
    icons: NtDatePickerIcons;
    readonly origin: CdkOverlayOrigin;
    private _disabled;
    private _lastValueValid;
    private _readonly;
    private _required;
    private _value;
    private _startAt;
    private _minDate;
    private _maxDate;
    private _focused;
    _positionPairs: ConnectionPositionPair[];
    readonly empty: boolean;
    readonly focused: boolean;
    value: D | null;
    placeholder: string;
    disabled: boolean;
    required: boolean;
    readonly: boolean;
    startAt: D | null;
    minDate: D | null;
    maxDate: D | null;
    dateFilter: (date: D) => boolean;
    afterOpen: EventEmitter<any>;
    afterClosed: EventEmitter<any>;
    beforeOpen: EventEmitter<any>;
    beforeClosed: EventEmitter<any>;
    positionChange: EventEmitter<ConnectedOverlayPositionChange>;
    inputElement: ElementRef;
    overlay: NtOverlayComponent;
    calendar: NtDatePickerCalendarComponent<D>;
    /** Emits when the value changes (either due to user input or programmatic change). */
    private _valueChange;
    private _onChange;
    private _onTouched;
    constructor(_elementRef: ElementRef, _dateAdapter: DateAdapter<D>, _dateFormats: NtDateFormats, ngControl: NgControl, icons: NtDatePickerIcons);
    writeValue(value: D): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    _onInputFocus(): void;
    _afterOpen(event: any): void;
    _afterClosed(event: any): void;
    _beforeOpen(event: any): void;
    _beforeClosed(event: any): void;
    _positionChange(change: ConnectedOverlayPositionChange): void;
    focus(): void;
    select(date: D): void;
    clear(): void;
    setDisabledState(isDisabled: boolean): void;
    /**
     * @param obj The object to check.
     * @returns The given object if it is both a date instance and valid, otherwise null.
     */
    private _getValidDateOrNull;
}
