import { Observable } from 'rxjs';
import { ContentObserver } from '@angular/cdk/observers';
import { AfterContentInit, ElementRef, InjectionToken, OnDestroy } from '@angular/core';
import { NtOverlayComponent } from '@ng-tangram/components/core';
export declare type NtDropdownPaneSize = '' | 'tiny' | 'small' | 'large';
export interface NtDropdownParentComponent {
    overlay: NtOverlayComponent;
}
export declare const NT_DROPDOWN_PARENT_COMPONENT: InjectionToken<NtDropdownParentComponent>;
export declare class NtDropdownPaneComponent implements AfterContentInit, OnDestroy {
    private _contentObserver;
    private _elementRef;
    private _parent;
    private _contentSubscription;
    private _arrow;
    private _autosize;
    size: NtDropdownPaneSize;
    /**
     * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
     *
     * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
     * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
     * @deprecated > 0.6.0
     */
    class: string;
    autosize: boolean;
    arrow: boolean;
    private _contentChange;
    readonly contentChanged: Observable<any>;
    readonly textContent: string;
    constructor(_contentObserver: ContentObserver, _elementRef: ElementRef, _parent: NtDropdownParentComponent);
    ngAfterContentInit(): void;
    ngOnDestroy(): void;
    private _checkContentChange;
}
