import { isPlatformBrowser, CommonModule } from '@angular/common';
import { Component, ElementRef, Inject, Input, PLATFORM_ID, Renderer2, ViewEncapsulation, NgModule } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NtBadgeComponent {
    /**
     * @param {?} platformId
     * @param {?} _elementRef
     * @param {?} _renderer
     */
    constructor(platformId, _elementRef, _renderer) {
        this.platformId = platformId;
        this._elementRef = _elementRef;
        this._renderer = _renderer;
        this._type = 'static';
        this.color = '';
        /**
         * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
         *
         * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
         * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
         * @deprecated > 0.6.0
         */
        this.class = '';
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set type(value) {
        if (value === 'float' || value === 'notify') {
            this._resetPosition();
        }
        else {
            this._clearPosition();
        }
        this._type = value;
    }
    /**
     * @return {?}
     */
    get type() { return this._type; }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this._resetPosition();
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this._clearPosition();
    }
    // 重置容器的 position 属性
    /**
     * @private
     * @return {?}
     */
    _resetPosition() {
        if (isPlatformBrowser(this.platformId)) {
            /** @type {?} */
            const style = window.getComputedStyle(this._elementRef.nativeElement.parentElement);
            if (style.position !== 'absolute' || style.position !== 'absolute') {
                this._originalPosition = style.position;
                this._renderer.setStyle(this._elementRef.nativeElement.parentElement, 'position', 'relative');
            }
        }
    }
    // 清理 position 属性
    /**
     * @private
     * @return {?}
     */
    _clearPosition() {
        if (isPlatformBrowser(this.platformId)) {
            if (this._originalPosition) {
                this._renderer.removeStyle(this._elementRef.nativeElement.parentElement, 'position');
            }
        }
    }
}
NtBadgeComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-badge, [nt-badge]',
                template: `<ng-content></ng-content>`,
                encapsulation: ViewEncapsulation.None,
                host: {
                    '[class]': '["badge", color, class].join(" ")',
                    '[class.badge-float]': 'type === "float"',
                    '[class.badge-notify]': 'type === "notify"'
                }
            },] },
];
/** @nocollapse */
NtBadgeComponent.ctorParameters = () => [
    { type: Object, decorators: [{ type: Inject, args: [PLATFORM_ID,] }] },
    { type: ElementRef },
    { type: Renderer2 }
];
NtBadgeComponent.propDecorators = {
    color: [{ type: Input }],
    class: [{ type: Input }],
    type: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NtBadgeModule {
}
NtBadgeModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                declarations: [NtBadgeComponent],
                exports: [NtBadgeComponent]
            },] },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NtBadgeModule, NtBadgeComponent };
//# sourceMappingURL=badge.js.map
