import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { Component, Input, ViewEncapsulation, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NtButtonGroupComponent {
    constructor() {
        this._expanded = false;
        /**
         * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
         *
         * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
         * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
         * @deprecated > 0.6.0
         */
        this.class = '';
        this.color = '';
        this.size = '';
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set expanded(value) { this._expanded = coerceBooleanProperty(value); }
    /**
     * @return {?}
     */
    get expanded() { return this._expanded; }
}
NtButtonGroupComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-button-group, [nt-button-group]',
                template: `<ng-content></ng-content>`,
                encapsulation: ViewEncapsulation.None,
                host: {
                    '[class]': '["button-group", color, size, class].join(" ")',
                    '[class.expanded]': 'expanded'
                }
            },] },
];
NtButtonGroupComponent.propDecorators = {
    class: [{ type: Input }],
    color: [{ type: Input }],
    size: [{ type: Input }],
    expanded: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NtButtonComponent {
    constructor() {
        this._style = '';
        this._expanded = false;
        /**
         * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
         *
         * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
         * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
         * @deprecated >= 0.6.0
         */
        this.class = '';
        this.color = '';
        this.size = '';
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set button(value) {
        if (this._validStyle(value)) {
            this._style = value;
        }
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set style(value) { this._style = value; }
    /**
     * @return {?}
     */
    get style() { return this._style; }
    /**
     * @param {?} value
     * @return {?}
     */
    set expanded(value) { this._expanded = coerceBooleanProperty(value); }
    /**
     * @return {?}
     */
    get expanded() { return this._expanded; }
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    _validStyle(value) {
        return ['', 'hollow', 'clear'].indexOf(value) > -1;
    }
}
NtButtonComponent.decorators = [
    { type: Component, args: [{
                selector: '[nt-button]',
                template: `<ng-content></ng-content>`,
                encapsulation: ViewEncapsulation.None,
                host: {
                    '[class]': '["button", color, style, size, class].join(" ")',
                    '[class.expanded]': 'expanded'
                }
            },] },
];
NtButtonComponent.propDecorators = {
    class: [{ type: Input }],
    color: [{ type: Input }],
    size: [{ type: Input }],
    button: [{ type: Input, args: ['nt-button',] }],
    style: [{ type: Input }],
    expanded: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NtButtonModule {
}
NtButtonModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                exports: [NtButtonComponent, NtButtonGroupComponent],
                declarations: [NtButtonComponent, NtButtonGroupComponent],
            },] },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NtButtonModule, NtButtonComponent, NtButtonGroupComponent };
//# sourceMappingURL=button.js.map
