import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { Component, ContentChildren, Input, ViewEncapsulation, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NtMenuComponent {
    constructor() {
        this._simple = false;
        this._expanded = false;
        this._nested = false;
        this._align = '';
        /**
         * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
         *
         * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
         * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
         * @deprecated > 0.6.0
         */
        this.class = '';
        this.orientation = '';
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set simple(value) { this._simple = coerceBooleanProperty(value); }
    /**
     * @return {?}
     */
    get simple() { return this._simple; }
    /**
     * @param {?} value
     * @return {?}
     */
    set expanded(value) { this._expanded = coerceBooleanProperty(value); }
    /**
     * @return {?}
     */
    get expanded() { return this._expanded; }
    /**
     * @param {?} value
     * @return {?}
     */
    set nested(value) { this._nested = coerceBooleanProperty(value); }
    /**
     * @return {?}
     */
    get nested() { return this._nested; }
    /**
     * @param {?} value
     * @return {?}
     */
    set align(value) { this._align = value; }
    /**
     * @return {?}
     */
    get align() { return this._align; }
    /**
     * @return {?}
     */
    ngAfterContentInit() {
        this.childMenus.toArray()
            .filter((/**
         * @param {?} menu
         * @return {?}
         */
        menu => menu !== this))
            .forEach((/**
         * @param {?} menu
         * @return {?}
         */
        menu => menu.nested = true));
    }
}
NtMenuComponent.decorators = [
    { type: Component, args: [{
                selector: 'ul[nt-menu], ol[nt-menu]',
                template: '<ng-content></ng-content>',
                encapsulation: ViewEncapsulation.None,
                host: {
                    '[class]': '["menu", align ? "align-" + align : "", orientation, class].join(" ")',
                    '[class.simple]': 'simple',
                    '[class.expanded]': 'expanded',
                    '[class.nested]': 'nested'
                }
            },] },
];
/** @nocollapse */
NtMenuComponent.ctorParameters = () => [];
NtMenuComponent.propDecorators = {
    class: [{ type: Input }],
    simple: [{ type: Input }],
    expanded: [{ type: Input }],
    align: [{ type: Input }],
    orientation: [{ type: Input }],
    childMenus: [{ type: ContentChildren, args: [NtMenuComponent,] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NtMenuModule {
}
NtMenuModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                exports: [NtMenuComponent],
                declarations: [NtMenuComponent]
            },] },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NtMenuModule, NtMenuComponent };
//# sourceMappingURL=menu.js.map
