import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { Attribute, Component, EventEmitter, Input, Optional, Output, Self, ViewEncapsulation, ChangeDetectionStrategy, ChangeDetectorRef, ContentChildren, isDevMode, NgZone, NgModule } from '@angular/core';
import { NgControl } from '@angular/forms';
import { defer, merge, Subject } from 'rxjs';
import { startWith, switchMap, take, takeUntil } from 'rxjs/operators';
import { NtFormFieldControl } from '@ng-tangram/components/forms';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
let uniqueId = 0;
/**
 * @template T
 */
class NtRadioChange {
    /**
     * @param {?} source
     * @param {?} selected
     */
    constructor(source, selected) {
        this.source = source;
        this.selected = selected;
    }
}
/**
 * @template T
 */
class NtRadioComponent {
    /**
     * @param {?} tabIndex
     * @param {?} ngControl
     */
    constructor(tabIndex, ngControl) {
        this.ngControl = ngControl;
        this.id = `nt-radio-${uniqueId++}`;
        this._disabled = false;
        this._readonly = false;
        this._checked = false;
        this._name = this.id;
        this.change = new EventEmitter();
        this._onChange = (/**
         * @return {?}
         */
        () => { });
        this._onTouched = (/**
         * @return {?}
         */
        () => { });
        if (this.ngControl) {
            this.ngControl.valueAccessor = this;
        }
        this.tabIndex = parseInt(tabIndex) || 0;
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set value(value) { this._value = value; }
    /**
     * @return {?}
     */
    get value() { return this._value; }
    /**
     * @param {?} value
     * @return {?}
     */
    set disabled(value) { this._disabled = coerceBooleanProperty(value); }
    /**
     * @return {?}
     */
    get disabled() { return this._disabled; }
    /**
     * @param {?} value
     * @return {?}
     */
    set readonly(value) { this._readonly = coerceBooleanProperty(value); }
    /**
     * @return {?}
     */
    get readonly() { return this._readonly; }
    /**
     * @return {?}
     */
    get checked() { return this._checked; }
    /**
     * @param {?} value
     * @return {?}
     */
    set checked(value) { this._checked = coerceBooleanProperty(value); }
    /**
     * @param {?} value
     * @return {?}
     */
    set name(value) { this._name = value; }
    /**
     * @return {?}
     */
    get name() { return this._name; }
    /**
     * @param {?} value
     * @return {?}
     */
    writeValue(value) {
        this._checked = !!value;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnChange(fn) {
        this._onChange = fn;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    setDisabledState(isDisabled) {
        this.disabled = isDisabled;
    }
    /**
     * @param {?} event
     * @return {?}
     */
    _onInputClick(event) {
        event.stopPropagation();
    }
    /**
     * @param {?} event
     * @return {?}
     */
    _onInputChange(event) {
        event.stopPropagation();
        this._checked = true;
        this._emitChangeEvent();
    }
    /**
     * @private
     * @return {?}
     */
    _emitChangeEvent() {
        /** @type {?} */
        const event = new NtRadioChange(this, this.checked);
        this._onChange(this.checked);
        this._onTouched();
        this.change.emit(event);
    }
}
NtRadioComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-radio',
                encapsulation: ViewEncapsulation.None,
                template: "<label class=\"nt-radio-layout\"> <div class=\"nt-radio-input-container\"> <input class=\"cdk-visually-hidden\" type=\"radio\" [name]=\"name\" [tabIndex]=\"tabIndex\" [disabled]=\"disabled\" [checked]=\"checked\" (change)=\"_onInputChange($event)\" (click)=\"_onInputClick($event)\"> <div class=\"nt-radio-input\"></div> </div> <span class=\"nt-radio-label\"> <ng-content></ng-content> </span> </label> ",
                host: {
                    'class': 'nt-radio',
                    '[class.nt-radio-disabled]': 'disabled'
                }
            },] },
];
/** @nocollapse */
NtRadioComponent.ctorParameters = () => [
    { type: String, decorators: [{ type: Attribute, args: ['tabindex',] }] },
    { type: NgControl, decorators: [{ type: Self }, { type: Optional }] }
];
NtRadioComponent.propDecorators = {
    value: [{ type: Input }],
    disabled: [{ type: Input }],
    readonly: [{ type: Input }],
    checked: [{ type: Input }],
    name: [{ type: Input }],
    change: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @return {?}
 */
function getNtRdioGroupNonFunctionValueError() {
    return Error('`compareWith` must be a function.');
}
/** @type {?} */
let uniqueId$1 = 0;
/**
 * @template T
 */
class NtRadioGroupComponent extends NtFormFieldControl {
    /**
     * @param {?} _ngZone
     * @param {?} _changeDetectorRef
     * @param {?} ngControl
     */
    constructor(_ngZone, _changeDetectorRef, ngControl) {
        super();
        this._ngZone = _ngZone;
        this._changeDetectorRef = _changeDetectorRef;
        this.ngControl = ngControl;
        this.id = `nt-radio-group-${uniqueId$1++}`;
        this._destroy = new Subject();
        this._disabled = false;
        this._readonly = false;
        this._required = false;
        this._name = this.id;
        this._compareWith = (/**
         * @param {?} o1
         * @param {?} o2
         * @return {?}
         */
        (o1, o2) => o1 === o2);
        this.checkedChanges = defer((/**
         * @return {?}
         */
        () => {
            if (this.radios) {
                return merge(...this.radios.map((/**
                 * @param {?} item
                 * @return {?}
                 */
                item => item.change)));
            }
            return this._ngZone.onStable
                .asObservable()
                .pipe(take(1), switchMap((/**
             * @return {?}
             */
            () => this.checkedChanges)));
        }));
        /**
         * Emits when the value changes (either due to user input or programmatic change).
         */
        this._onChange = (/**
         * @return {?}
         */
        () => { });
        this._onTouched = (/**
         * @return {?}
         */
        () => { });
        if (this.ngControl) {
            this.ngControl.valueAccessor = this;
        }
    }
    /**
     * @return {?}
     */
    get value() { return this._value; }
    /**
     * @param {?} value
     * @return {?}
     */
    set disabled(value) { this._disabled = coerceBooleanProperty(value); }
    /**
     * @return {?}
     */
    get disabled() { return this._disabled; }
    /**
     * @return {?}
     */
    get required() { return this._required; }
    /**
     * @param {?} value
     * @return {?}
     */
    set required(value) { this._required = coerceBooleanProperty(value); }
    /**
     * @param {?} value
     * @return {?}
     */
    set readonly(value) { this._readonly = coerceBooleanProperty(value); }
    /**
     * @return {?}
     */
    get readonly() { return this._readonly; }
    /**
     * @return {?}
     */
    get name() { return this._name; }
    /**
     * @param {?} value
     * @return {?}
     */
    set name(value) {
        this._name = value;
        this._updateRadioButtonNames();
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    set compareWith(fn) {
        if (typeof fn !== 'function') {
            throw getNtRdioGroupNonFunctionValueError();
        }
        else {
            this._compareWith = fn;
        }
    }
    /**
     * @return {?}
     */
    ngAfterViewInit() {
        this.radios.changes.pipe(startWith(null), takeUntil(this._destroy)).subscribe((/**
         * @return {?}
         */
        () => {
            this._resetRadios();
            this._initializeChecked();
        }));
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this._destroy.next();
        this._destroy.complete();
    }
    /**
     * @param {?} value
     * @return {?}
     */
    writeValue(value) {
        if (this.radios) {
            this._setCheckedByValue(value);
        }
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnChange(fn) {
        this._onChange = fn;
    }
    /**
     * @param {?} fn
     * @return {?}
     */
    registerOnTouched(fn) {
        this._onTouched = fn;
    }
    /**
     * @return {?}
     */
    focus() {
        if (!this.disabled) {
            this._onTouched();
        }
    }
    /**
     * @private
     * @return {?}
     */
    _initializeChecked() {
        Promise.resolve().then((/**
         * @return {?}
         */
        () => {
            this._updateRadioButtonNames();
            this._setCheckedByValue(this.ngControl ? this.ngControl.value : this.value);
        }));
    }
    /**
     * @private
     * @return {?}
     */
    _resetRadios() {
        /** @type {?} */
        const changedOrDestroyed = merge(this.radios.changes, this._destroy);
        this.checkedChanges.pipe(takeUntil(changedOrDestroyed)).subscribe((/**
         * @param {?} change
         * @return {?}
         */
        change => {
            this._setValues(change.source);
        }));
        merge(...this.radios.map((/**
         * @param {?} item
         * @return {?}
         */
        item => item.change)))
            .pipe(takeUntil(changedOrDestroyed))
            .subscribe((/**
         * @return {?}
         */
        () => {
            this._changeDetectorRef.markForCheck();
        }));
    }
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    _setCheckedByValue(value) {
        this._value = value;
        this.radios.forEach((/**
         * @param {?} item
         * @return {?}
         */
        item => item.checked = false));
        this._checkedValue(value);
        this._changeDetectorRef.markForCheck();
    }
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    _checkedValue(value) {
        /** @type {?} */
        const correspondingItem = this.radios.find((/**
         * @param {?} item
         * @return {?}
         */
        (item) => {
            try {
                return item.value != null && this._compareWith(item.value, value);
            }
            catch (error) {
                if (isDevMode()) {
                    console.warn(error);
                }
                return false;
            }
        }));
        if (correspondingItem) {
            correspondingItem.checked = true;
        }
        return correspondingItem;
    }
    /**
     * @private
     * @param {?} radio
     * @return {?}
     */
    _setValues(radio) {
        this._value = radio.value;
        this._onChange(this._value);
        this._onTouched();
        this._changeDetectorRef.markForCheck();
    }
    /**
     * @private
     * @return {?}
     */
    _updateRadioButtonNames() {
        if (this.radios) {
            this.radios.forEach((/**
             * @param {?} radio
             * @return {?}
             */
            radio => {
                radio.name = this.name;
            }));
        }
    }
}
NtRadioGroupComponent.decorators = [
    { type: Component, args: [{
                selector: 'nt-radio-group',
                template: '<ng-content></ng-content>',
                encapsulation: ViewEncapsulation.None,
                changeDetection: ChangeDetectionStrategy.OnPush,
                providers: [
                    { provide: NtFormFieldControl, useExisting: NtRadioGroupComponent }
                ],
                host: {
                    'class': 'nt-radio-group'
                }
            },] },
];
/** @nocollapse */
NtRadioGroupComponent.ctorParameters = () => [
    { type: NgZone },
    { type: ChangeDetectorRef },
    { type: NgControl, decorators: [{ type: Self }, { type: Optional }] }
];
NtRadioGroupComponent.propDecorators = {
    disabled: [{ type: Input }],
    required: [{ type: Input }],
    readonly: [{ type: Input }],
    name: [{ type: Input }],
    radios: [{ type: ContentChildren, args: [NtRadioComponent,] }],
    compareWith: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NtRadioModule {
}
NtRadioModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                exports: [NtRadioComponent, NtRadioGroupComponent],
                declarations: [NtRadioComponent, NtRadioGroupComponent],
            },] },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NtRadioChange, NtRadioComponent, getNtRdioGroupNonFunctionValueError, NtRadioGroupComponent, NtRadioModule };
//# sourceMappingURL=radio.js.map
