import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { transition, trigger } from '@angular/animations';
import { Component, Input, ViewEncapsulation, ComponentFactoryResolver, Directive, ElementRef, Inject, PLATFORM_ID, Renderer2, ViewContainerRef, NgModule } from '@angular/core';
import { fadeIn, fadeOut } from '@ng-tangram/components/core';
import { isPlatformBrowser, CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NtScrimComponent {
    constructor() {
        this._isOpen = false;
        this.text = '';
    }
    /**
     * @param {?} value
     * @return {?}
     */
    set isOpen(value) { this._isOpen = coerceBooleanProperty(value); }
    /**
     * @return {?}
     */
    get isOpen() { return this._isOpen; }
}
NtScrimComponent.decorators = [
    { type: Component, args: [{
                selector: '[nt-scrim], nt-scrim',
                template: "<div class=\"nt-scrim\" *ngIf=\"isOpen\" [@fade]> <div class=\"nt-scrim-animation\"> <div class=\"nt-scrim-loading\"></div> </div> <h3 class=\"nt-scrim-text\">{{ text }}</h3> </div> ",
                encapsulation: ViewEncapsulation.None,
                animations: [
                    trigger('fade', [
                        transition('void => *', fadeIn(.15)),
                        transition('* => void', fadeOut(.15))
                    ])
                ]
            },] },
];
/** @nocollapse */
NtScrimComponent.ctorParameters = () => [];
NtScrimComponent.propDecorators = {
    text: [{ type: Input }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NtScrimDirective {
    /**
     * @param {?} platformId
     * @param {?} _elementRef
     * @param {?} _renderer
     * @param {?} _componentFactoryResolver
     * @param {?} _viewContainerRef
     */
    constructor(platformId, _elementRef, _renderer, _componentFactoryResolver, _viewContainerRef) {
        this.platformId = platformId;
        this._elementRef = _elementRef;
        this._renderer = _renderer;
        this._componentFactoryResolver = _componentFactoryResolver;
        this._viewContainerRef = _viewContainerRef;
        /** @type {?} */
        const componentFactory = this._componentFactoryResolver.resolveComponentFactory(NtScrimComponent);
        this._componentRef = this._viewContainerRef.createComponent(componentFactory);
        if (isPlatformBrowser(this.platformId)) {
            /** @type {?} */
            const style = window.getComputedStyle(this._elementRef.nativeElement);
            if (style.position !== 'absolute' || style.position !== 'absolute') {
                this._renderer.setStyle(this._elementRef.nativeElement, 'position', 'relative');
            }
            this._renderer.appendChild(this._elementRef.nativeElement, this._componentRef.location.nativeElement);
        }
    }
    // @ContentChild(NtScrimComponent) component: NtScrimComponent;
    /**
     * @param {?} value
     * @return {?}
     */
    set text(value) { this._componentRef.instance.text = value; }
    /**
     * @param {?} value
     * @return {?}
     */
    set scrim(value) { this._componentRef.instance.isOpen = coerceBooleanProperty(value); }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        if (isPlatformBrowser(this.platformId)) {
            this._renderer.removeChild(this._elementRef.nativeElement, this._componentRef.location.nativeElement);
            this._componentRef.destroy();
        }
    }
}
NtScrimDirective.decorators = [
    { type: Directive, args: [{
                selector: '[ntScrim]'
            },] },
];
/** @nocollapse */
NtScrimDirective.ctorParameters = () => [
    { type: Object, decorators: [{ type: Inject, args: [PLATFORM_ID,] }] },
    { type: ElementRef },
    { type: Renderer2 },
    { type: ComponentFactoryResolver },
    { type: ViewContainerRef }
];
NtScrimDirective.propDecorators = {
    text: [{ type: Input, args: ['scrimText',] }],
    scrim: [{ type: Input, args: ['ntScrim',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NtScrimModule {
}
NtScrimModule.decorators = [
    { type: NgModule, args: [{
                imports: [CommonModule],
                entryComponents: [NtScrimComponent],
                exports: [NtScrimComponent, NtScrimDirective],
                declarations: [NtScrimComponent, NtScrimDirective]
            },] },
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NtScrimModule, NtScrimComponent, NtScrimDirective };
//# sourceMappingURL=scrim.js.map
