import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { Component, Input, ViewEncapsulation, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtButtonGroupComponent = /** @class */ (function () {
    function NtButtonGroupComponent() {
        this._expanded = false;
        /**
         * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
         *
         * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
         * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
         * @deprecated > 0.6.0
         */
        this.class = '';
        this.color = '';
        this.size = '';
    }
    Object.defineProperty(NtButtonGroupComponent.prototype, "expanded", {
        get: /**
         * @return {?}
         */
        function () { return this._expanded; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._expanded = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    NtButtonGroupComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-button-group, [nt-button-group]',
                    template: "<ng-content></ng-content>",
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        '[class]': '["button-group", color, size, class].join(" ")',
                        '[class.expanded]': 'expanded'
                    }
                },] },
    ];
    NtButtonGroupComponent.propDecorators = {
        class: [{ type: Input }],
        color: [{ type: Input }],
        size: [{ type: Input }],
        expanded: [{ type: Input }]
    };
    return NtButtonGroupComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtButtonComponent = /** @class */ (function () {
    function NtButtonComponent() {
        this._style = '';
        this._expanded = false;
        /**
         * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
         *
         * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
         * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
         * @deprecated >= 0.6.0
         */
        this.class = '';
        this.color = '';
        this.size = '';
    }
    Object.defineProperty(NtButtonComponent.prototype, "button", {
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (this._validStyle(value)) {
                this._style = value;
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtButtonComponent.prototype, "style", {
        get: /**
         * @return {?}
         */
        function () { return this._style; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._style = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtButtonComponent.prototype, "expanded", {
        get: /**
         * @return {?}
         */
        function () { return this._expanded; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._expanded = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    NtButtonComponent.prototype._validStyle = /**
     * @private
     * @param {?} value
     * @return {?}
     */
    function (value) {
        return ['', 'hollow', 'clear'].indexOf(value) > -1;
    };
    NtButtonComponent.decorators = [
        { type: Component, args: [{
                    selector: '[nt-button]',
                    template: "<ng-content></ng-content>",
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        '[class]': '["button", color, style, size, class].join(" ")',
                        '[class.expanded]': 'expanded'
                    }
                },] },
    ];
    NtButtonComponent.propDecorators = {
        class: [{ type: Input }],
        color: [{ type: Input }],
        size: [{ type: Input }],
        button: [{ type: Input, args: ['nt-button',] }],
        style: [{ type: Input }],
        expanded: [{ type: Input }]
    };
    return NtButtonComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtButtonModule = /** @class */ (function () {
    function NtButtonModule() {
    }
    NtButtonModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    exports: [NtButtonComponent, NtButtonGroupComponent],
                    declarations: [NtButtonComponent, NtButtonGroupComponent],
                },] },
    ];
    return NtButtonModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NtButtonModule, NtButtonComponent, NtButtonGroupComponent };
//# sourceMappingURL=button.js.map
