import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { Attribute, ChangeDetectionStrategy, ChangeDetectorRef, Component, EventEmitter, Input, Optional, Output, Self, ViewEncapsulation, ContentChildren, isDevMode, NgZone, NgModule } from '@angular/core';
import { NgControl } from '@angular/forms';
import { defer, merge, Subject } from 'rxjs';
import { startWith, switchMap, take, takeUntil } from 'rxjs/operators';
import { NtFormFieldControl } from '@ng-tangram/components/forms';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var uniqueId = 0;
var NtCheckboxChange = /** @class */ (function () {
    function NtCheckboxChange(source, checked) {
        this.source = source;
        this.checked = checked;
    }
    return NtCheckboxChange;
}());
var NtCheckboxComponent = /** @class */ (function () {
    function NtCheckboxComponent(_changeDetectorRef, tabIndex, ngControl) {
        this._changeDetectorRef = _changeDetectorRef;
        this.ngControl = ngControl;
        this.id = "nt-checkbox-" + uniqueId++;
        this._disabled = false;
        this._readonly = false;
        this._checked = false;
        this._indeterminate = false;
        this.change = new EventEmitter();
        // TODO: 考虑合并到 change 事件中
        this.indeterminateChange = new EventEmitter();
        this._onChange = (/**
         * @return {?}
         */
        function () { });
        this._onTouched = (/**
         * @return {?}
         */
        function () { });
        if (this.ngControl) {
            this.ngControl.valueAccessor = this;
        }
        this.tabIndex = parseInt(tabIndex) || 0;
    }
    Object.defineProperty(NtCheckboxComponent.prototype, "value", {
        get: /**
         * @return {?}
         */
        function () { return this._value; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._value = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtCheckboxComponent.prototype, "disabled", {
        get: /**
         * @return {?}
         */
        function () { return this._disabled; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value !== this.disabled) {
                this._disabled = coerceBooleanProperty(value);
                this._changeDetectorRef.markForCheck();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtCheckboxComponent.prototype, "readonly", {
        get: /**
         * @return {?}
         */
        function () { return this._readonly; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._readonly = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtCheckboxComponent.prototype, "checked", {
        get: /**
         * @return {?}
         */
        function () { return this._checked; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value !== this.checked) {
                this._checked = coerceBooleanProperty(value);
                this._changeDetectorRef.markForCheck();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtCheckboxComponent.prototype, "indeterminate", {
        get: /**
         * @return {?}
         */
        function () { return this._indeterminate; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            /** @type {?} */
            var changed = value !== this._indeterminate;
            this._indeterminate = value;
            if (changed) {
                this.indeterminateChange.emit(this._indeterminate);
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} value
     * @return {?}
     */
    NtCheckboxComponent.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this._checked = !!value;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NtCheckboxComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this._onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NtCheckboxComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this._onTouched = fn;
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    NtCheckboxComponent.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        this.disabled = isDisabled;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    NtCheckboxComponent.prototype._onInputClick = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        event.stopPropagation();
        if (!this.disabled) {
            this._checked = !this._checked;
            this._onTouched();
            this._emitChangeEvent();
        }
    };
    /**
     * @param {?} event
     * @return {?}
     */
    NtCheckboxComponent.prototype._onInteractionEvent = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        // We always have to stop propagation on the change event.
        // Otherwise the change event, from the input element, will bubble up and
        // emit its event object to the `change` output.
        event.stopPropagation();
    };
    /**
     * @private
     * @return {?}
     */
    NtCheckboxComponent.prototype._emitChangeEvent = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var event = new NtCheckboxChange(this, this.checked);
        this._onChange(this.checked);
        this.change.emit(event);
    };
    NtCheckboxComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-checkbox',
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    template: "<label class=\"nt-checkbox-layout\"> <div class=\"nt-checkbox-input-container\"> <input class=\"cdk-visually-hidden\" type=\"checkbox\" [tabIndex]=\"tabIndex\" [checked]=\"checked\" [disabled]=\"disabled\" [readonly]=\"readonly\" (change)=\"_onInteractionEvent($event)\" (click)=\"_onInputClick($event)\"> <div class=\"nt-checkbox-input nt-form-control\"></div> </div> <span class=\"nt-checkbox-label\"> <ng-content></ng-content> </span> </label> ",
                    host: {
                        'class': 'nt-checkbox',
                        '[class.nt-checkbox-checked]': 'checked',
                        '[class.nt-checkbox-disabled]': 'disabled',
                        '[class.nt-checkbox-indeterminate]': 'indeterminate',
                    }
                },] },
    ];
    /** @nocollapse */
    NtCheckboxComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: String, decorators: [{ type: Attribute, args: ['tabindex',] }] },
        { type: NgControl, decorators: [{ type: Self }, { type: Optional }] }
    ]; };
    NtCheckboxComponent.propDecorators = {
        value: [{ type: Input }],
        disabled: [{ type: Input }],
        readonly: [{ type: Input }],
        checked: [{ type: Input }],
        indeterminate: [{ type: Input }],
        change: [{ type: Output }],
        indeterminateChange: [{ type: Output }]
    };
    return NtCheckboxComponent;
}());

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @return {?}
 */
function getNtCheckboxGroupNonFunctionValueError() {
    return Error('`compareWith` must be a function.');
}
/** @type {?} */
var uniqueId$1 = 0;
/**
 * @template T
 */
var NtCheckboxGroupComponent = /** @class */ (function (_super) {
    __extends(NtCheckboxGroupComponent, _super);
    function NtCheckboxGroupComponent(_ngZone, _changeDetectorRef, ngControl) {
        var _this = _super.call(this) || this;
        _this._ngZone = _ngZone;
        _this._changeDetectorRef = _changeDetectorRef;
        _this.ngControl = ngControl;
        _this.id = "nt-checkbox-group-" + uniqueId$1++;
        _this._destroy = new Subject();
        _this._disabled = false;
        _this._readonly = false;
        _this._required = false;
        _this._compareWith = (/**
         * @param {?} o1
         * @param {?} o2
         * @return {?}
         */
        function (o1, o2) { return o1 === o2; });
        _this.checkedChanges = defer((/**
         * @return {?}
         */
        function () {
            if (_this.checkboxes) {
                return merge.apply(void 0, _this.checkboxes.map((/**
                 * @param {?} item
                 * @return {?}
                 */
                function (item) { return item.change; })));
            }
            return _this._ngZone.onStable
                .asObservable()
                .pipe(take(1), switchMap((/**
             * @return {?}
             */
            function () { return _this.checkedChanges; })));
        }));
        /**
         * Emits when the value changes (either due to user input or programmatic change).
         */
        _this._onChange = (/**
         * @return {?}
         */
        function () { });
        _this._onTouched = (/**
         * @return {?}
         */
        function () { });
        if (_this.ngControl) {
            _this.ngControl.valueAccessor = _this;
        }
        return _this;
    }
    Object.defineProperty(NtCheckboxGroupComponent.prototype, "value", {
        get: /**
         * @return {?}
         */
        function () { return this._value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtCheckboxGroupComponent.prototype, "disabled", {
        get: /**
         * @return {?}
         */
        function () { return this._disabled; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._disabled = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtCheckboxGroupComponent.prototype, "required", {
        get: /**
         * @return {?}
         */
        function () { return this._required; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._required = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtCheckboxGroupComponent.prototype, "readonly", {
        get: /**
         * @return {?}
         */
        function () { return this._readonly; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._readonly = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtCheckboxGroupComponent.prototype, "compareWith", {
        set: /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            if (typeof fn !== 'function') {
                throw getNtCheckboxGroupNonFunctionValueError();
            }
            else {
                this._compareWith = fn;
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NtCheckboxGroupComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.checkboxes.changes.pipe(startWith(null), takeUntil(this._destroy)).subscribe((/**
         * @return {?}
         */
        function () {
            _this._resetCheckboxs();
            _this._initializeChecked();
        }));
    };
    /**
     * @return {?}
     */
    NtCheckboxGroupComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this._destroy.next();
        this._destroy.complete();
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NtCheckboxGroupComponent.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        if (this.checkboxes) {
            this._setCheckedByValue(value);
        }
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NtCheckboxGroupComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this._onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NtCheckboxGroupComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this._onTouched = fn;
    };
    /**
     * @return {?}
     */
    NtCheckboxGroupComponent.prototype.focus = /**
     * @return {?}
     */
    function () {
        if (!this.disabled) {
            this._onTouched();
        }
    };
    /**
     * @private
     * @return {?}
     */
    NtCheckboxGroupComponent.prototype._initializeChecked = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        Promise.resolve().then((/**
         * @return {?}
         */
        function () {
            _this._setCheckedByValue(_this.ngControl ? _this.ngControl.value : _this.value);
        }));
    };
    /**
     * @private
     * @return {?}
     */
    NtCheckboxGroupComponent.prototype._resetCheckboxs = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var changedOrDestroyed = merge(this.checkboxes.changes, this._destroy);
        this.checkedChanges.pipe(takeUntil(changedOrDestroyed)).subscribe((/**
         * @return {?}
         */
        function () {
            _this._setValues();
        }));
        merge.apply(void 0, this.checkboxes.map((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return item.change; }))).pipe(takeUntil(changedOrDestroyed))
            .subscribe((/**
         * @return {?}
         */
        function () {
            _this._changeDetectorRef.markForCheck();
        }));
    };
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    NtCheckboxGroupComponent.prototype._setCheckedByValue = /**
     * @private
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        if (value) {
            this._value = value;
            this.checkboxes.forEach((/**
             * @param {?} item
             * @return {?}
             */
            function (item) { return item.checked = false; }));
            value.forEach((/**
             * @param {?} val
             * @return {?}
             */
            function (val) { return _this._checkedValue(val); }));
            this._changeDetectorRef.markForCheck();
        }
    };
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    NtCheckboxGroupComponent.prototype._checkedValue = /**
     * @private
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        /** @type {?} */
        var correspondingItem = this.checkboxes.find((/**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            try {
                return item.value != null && _this._compareWith(item.value, value);
            }
            catch (error) {
                if (isDevMode()) {
                    console.warn(error);
                }
                return false;
            }
        }));
        if (correspondingItem) {
            correspondingItem.checked = true;
        }
        return correspondingItem;
    };
    /**
     * @private
     * @return {?}
     */
    NtCheckboxGroupComponent.prototype._setValues = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        this._value = [];
        this.checkboxes.forEach((/**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            if (item.checked && !!item.value) {
                _this._value.push(item.value);
            }
        }));
        this._onChange(this._value);
        this._onTouched();
        this._changeDetectorRef.markForCheck();
    };
    NtCheckboxGroupComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-checkbox-group',
                    template: '<ng-content></ng-content>',
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        { provide: NtFormFieldControl, useExisting: NtCheckboxGroupComponent }
                    ],
                    host: {
                        'class': 'nt-checkbox-group'
                    }
                },] },
    ];
    /** @nocollapse */
    NtCheckboxGroupComponent.ctorParameters = function () { return [
        { type: NgZone },
        { type: ChangeDetectorRef },
        { type: NgControl, decorators: [{ type: Self }, { type: Optional }] }
    ]; };
    NtCheckboxGroupComponent.propDecorators = {
        disabled: [{ type: Input }],
        required: [{ type: Input }],
        readonly: [{ type: Input }],
        checkboxes: [{ type: ContentChildren, args: [NtCheckboxComponent,] }],
        compareWith: [{ type: Input }]
    };
    return NtCheckboxGroupComponent;
}(NtFormFieldControl));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtCheckboxModule = /** @class */ (function () {
    function NtCheckboxModule() {
    }
    NtCheckboxModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    exports: [NtCheckboxComponent, NtCheckboxGroupComponent],
                    declarations: [NtCheckboxComponent, NtCheckboxGroupComponent],
                },] },
    ];
    return NtCheckboxModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NtCheckboxChange, NtCheckboxComponent, getNtCheckboxGroupNonFunctionValueError, NtCheckboxGroupComponent, NtCheckboxModule };
//# sourceMappingURL=checkbox.js.map
