import { Subject } from 'rxjs';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { ContentObserver, ObserversModule } from '@angular/cdk/observers';
import { Component, ElementRef, Inject, InjectionToken, Input, ViewEncapsulation, ContentChild, EventEmitter, Output, ViewChild, NgModule } from '@angular/core';
import { CdkOverlayOrigin } from '@angular/cdk/overlay';
import { NtOverlayComponent, NtOverlayPosition, NtOverlayModule } from '@ng-tangram/components/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var NT_DROPDOWN_PARENT_COMPONENT = new InjectionToken('nt-dropdown-parent-component');
var NtDropdownPaneComponent = /** @class */ (function () {
    function NtDropdownPaneComponent(_contentObserver, _elementRef, _parent) {
        this._contentObserver = _contentObserver;
        this._elementRef = _elementRef;
        this._parent = _parent;
        this._arrow = false;
        this._autosize = false;
        this.size = 'small';
        /**
         * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
         *
         * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
         * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
         * @deprecated > 0.6.0
         */
        this.class = '';
        this._contentChange = new Subject();
    }
    Object.defineProperty(NtDropdownPaneComponent.prototype, "autosize", {
        get: /**
         * @return {?}
         */
        function () { return this._autosize; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._autosize = coerceBooleanProperty(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtDropdownPaneComponent.prototype, "arrow", {
        get: /**
         * @return {?}
         */
        function () { return this._arrow; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._arrow = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtDropdownPaneComponent.prototype, "contentChanged", {
        get: /**
         * @return {?}
         */
        function () {
            return this._contentChange.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtDropdownPaneComponent.prototype, "textContent", {
        get: /**
         * @return {?}
         */
        function () {
            return (this._elementRef.nativeElement.textContent || '').trim();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NtDropdownPaneComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this._contentSubscription = this._contentObserver
            .observe(this._elementRef)
            .subscribe((/**
         * @return {?}
         */
        function () { return _this._checkContentChange(); }));
    };
    /**
     * @return {?}
     */
    NtDropdownPaneComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (this._contentSubscription) {
            this._contentSubscription.unsubscribe();
        }
    };
    /**
     * @private
     * @return {?}
     */
    NtDropdownPaneComponent.prototype._checkContentChange = /**
     * @private
     * @return {?}
     */
    function () {
        if (this._parent.overlay.isOpen) {
            /** @type {?} */
            var cdkConnectedOverlay = this._parent.overlay.cdkConnectedOverlay;
            if (cdkConnectedOverlay && cdkConnectedOverlay.overlayRef) {
                cdkConnectedOverlay.overlayRef.updatePosition();
            }
        }
    };
    NtDropdownPaneComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-dropdown-pane, [nt-dropdown-pane]',
                    template: '<ng-content></ng-content>',
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        '[class]': '["nt-dropdown-pane", size, class].join(" ")',
                        '[class.autosize]': 'autosize'
                    }
                },] },
    ];
    /** @nocollapse */
    NtDropdownPaneComponent.ctorParameters = function () { return [
        { type: ContentObserver },
        { type: ElementRef },
        { type: undefined, decorators: [{ type: Inject, args: [NT_DROPDOWN_PARENT_COMPONENT,] }] }
    ]; };
    NtDropdownPaneComponent.propDecorators = {
        size: [{ type: Input }],
        class: [{ type: Input }],
        autosize: [{ type: Input }],
        arrow: [{ type: Input }]
    };
    return NtDropdownPaneComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtDropdownComponent = /** @class */ (function () {
    function NtDropdownComponent(_elementRef) {
        this.position = NtOverlayPosition.BottomLeft;
        this.trigger = 'hover';
        this.afterOpen = new EventEmitter();
        this.afterClosed = new EventEmitter();
        this.beforeOpen = new EventEmitter();
        this.beforeClosed = new EventEmitter();
        this.positionChange = new EventEmitter();
        this.origin = new CdkOverlayOrigin(_elementRef);
    }
    /**
     * @param {?} event
     * @return {?}
     */
    NtDropdownComponent.prototype._afterOpen = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.afterOpen.next(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    NtDropdownComponent.prototype._afterClosed = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.afterClosed.next(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    NtDropdownComponent.prototype._beforeOpen = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.beforeOpen.next(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    NtDropdownComponent.prototype._beforeClosed = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.beforeClosed.next(event);
    };
    /**
     * @param {?} change
     * @return {?}
     */
    NtDropdownComponent.prototype._positionChange = /**
     * @param {?} change
     * @return {?}
     */
    function (change) {
        this.positionChange.next(change);
    };
    NtDropdownComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-dropdown, [nt-dropdown]',
                    template: "<ng-content></ng-content> <nt-overlay [origin]=\"origin\" [position]=\"position\" [trigger]=\"trigger\" [arrow]=\"pane?.arrow\" (afterOpen)=\"_afterOpen($event)\" (afterClosed)=\"_afterClosed($event)\" (beforeOpen)=\"_beforeOpen($event)\" (beforeClosed)=\"_beforeClosed($event)\" (positionChange)=\"_positionChange($event)\"> <ng-content select=\"nt-dropdown-pane\"></ng-content> </nt-overlay> ",
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        '(click)': 'overlay.click()',
                        '(mouseenter)': 'overlay.onMouseEnter()',
                        '(mouseleave)': 'overlay.onMouseLeave()'
                    },
                    providers: [
                        { provide: NT_DROPDOWN_PARENT_COMPONENT, useExisting: NtDropdownComponent }
                    ]
                },] },
    ];
    /** @nocollapse */
    NtDropdownComponent.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    NtDropdownComponent.propDecorators = {
        position: [{ type: Input }],
        trigger: [{ type: Input }],
        afterOpen: [{ type: Output }],
        afterClosed: [{ type: Output }],
        beforeOpen: [{ type: Output }],
        beforeClosed: [{ type: Output }],
        positionChange: [{ type: Output }],
        overlay: [{ type: ViewChild, args: [NtOverlayComponent, { static: true },] }],
        pane: [{ type: ContentChild, args: [NtDropdownPaneComponent, { static: false },] }]
    };
    return NtDropdownComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtDropdownModule = /** @class */ (function () {
    function NtDropdownModule() {
    }
    NtDropdownModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, ObserversModule, NtOverlayModule],
                    entryComponents: [NtDropdownComponent],
                    exports: [NtDropdownComponent, NtDropdownPaneComponent],
                    declarations: [NtDropdownComponent, NtDropdownPaneComponent]
                },] },
    ];
    return NtDropdownModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NtDropdownModule, NtDropdownComponent, NT_DROPDOWN_PARENT_COMPONENT, NtDropdownPaneComponent };
//# sourceMappingURL=dropdown.js.map
