import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { Component, ContentChildren, Input, ViewEncapsulation, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtMenuComponent = /** @class */ (function () {
    function NtMenuComponent() {
        this._simple = false;
        this._expanded = false;
        this._nested = false;
        this._align = '';
        /**
         * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
         *
         * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
         * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
         * @deprecated > 0.6.0
         */
        this.class = '';
        this.orientation = '';
    }
    Object.defineProperty(NtMenuComponent.prototype, "simple", {
        get: /**
         * @return {?}
         */
        function () { return this._simple; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._simple = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtMenuComponent.prototype, "expanded", {
        get: /**
         * @return {?}
         */
        function () { return this._expanded; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._expanded = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtMenuComponent.prototype, "nested", {
        get: /**
         * @return {?}
         */
        function () { return this._nested; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._nested = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtMenuComponent.prototype, "align", {
        get: /**
         * @return {?}
         */
        function () { return this._align; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._align = value; },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NtMenuComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.childMenus.toArray()
            .filter((/**
         * @param {?} menu
         * @return {?}
         */
        function (menu) { return menu !== _this; }))
            .forEach((/**
         * @param {?} menu
         * @return {?}
         */
        function (menu) { return menu.nested = true; }));
    };
    NtMenuComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ul[nt-menu], ol[nt-menu]',
                    template: '<ng-content></ng-content>',
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        '[class]': '["menu", align ? "align-" + align : "", orientation, class].join(" ")',
                        '[class.simple]': 'simple',
                        '[class.expanded]': 'expanded',
                        '[class.nested]': 'nested'
                    }
                },] },
    ];
    /** @nocollapse */
    NtMenuComponent.ctorParameters = function () { return []; };
    NtMenuComponent.propDecorators = {
        class: [{ type: Input }],
        simple: [{ type: Input }],
        expanded: [{ type: Input }],
        align: [{ type: Input }],
        orientation: [{ type: Input }],
        childMenus: [{ type: ContentChildren, args: [NtMenuComponent,] }]
    };
    return NtMenuComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtMenuModule = /** @class */ (function () {
    function NtMenuModule() {
    }
    NtMenuModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    exports: [NtMenuComponent],
                    declarations: [NtMenuComponent]
                },] },
    ];
    return NtMenuModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NtMenuModule, NtMenuComponent };
//# sourceMappingURL=menu.js.map
