import { Subject } from 'rxjs';
import { ContentObserver, ObserversModule } from '@angular/cdk/observers';
import { Component, ElementRef, Inject, InjectionToken, ViewEncapsulation, EventEmitter, Input, Output, TemplateRef, ViewChild, NgModule } from '@angular/core';
import { CdkOverlayOrigin } from '@angular/cdk/overlay';
import { NtOverlayComponent, NtOverlayPosition, NtOverlayModule } from '@ng-tangram/components/core';
import { CommonModule } from '@angular/common';
import { NtDropdownModule } from '@ng-tangram/components/dropdown';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var NT_POPOVER_PARENT_COMPONENT = new InjectionToken('nt-popover-parent-component');
var NtPopoverPaneComponent = /** @class */ (function () {
    function NtPopoverPaneComponent(_contentObserver, _elementRef, _parent) {
        this._contentObserver = _contentObserver;
        this._elementRef = _elementRef;
        this._parent = _parent;
        this._contentChange = new Subject();
    }
    Object.defineProperty(NtPopoverPaneComponent.prototype, "contentChanged", {
        get: /**
         * @return {?}
         */
        function () {
            return this._contentChange.asObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtPopoverPaneComponent.prototype, "textContent", {
        get: /**
         * @return {?}
         */
        function () {
            return (this._elementRef.nativeElement.textContent || '').trim();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NtPopoverPaneComponent.prototype.ngAfterContentInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this._contentSubscription = this._contentObserver
            .observe(this._elementRef)
            .subscribe((/**
         * @return {?}
         */
        function () { return _this._checkContentChange(); }));
    };
    /**
     * @return {?}
     */
    NtPopoverPaneComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (this._contentSubscription) {
            this._contentSubscription.unsubscribe();
        }
    };
    /**
     * @private
     * @return {?}
     */
    NtPopoverPaneComponent.prototype._checkContentChange = /**
     * @private
     * @return {?}
     */
    function () {
        if (this._parent.overlay.isOpen) {
            /** @type {?} */
            var cdkConnectedOverlay = this._parent.overlay.cdkConnectedOverlay;
            if (cdkConnectedOverlay && cdkConnectedOverlay.overlayRef) {
                cdkConnectedOverlay.overlayRef.updatePosition();
            }
        }
    };
    NtPopoverPaneComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-popover-pane, [nt-popover-pane]',
                    template: "\n    <ng-content></ng-content>\n  ",
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    /** @nocollapse */
    NtPopoverPaneComponent.ctorParameters = function () { return [
        { type: ContentObserver },
        { type: ElementRef },
        { type: undefined, decorators: [{ type: Inject, args: [NT_POPOVER_PARENT_COMPONENT,] }] }
    ]; };
    return NtPopoverPaneComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtPopoverComponent = /** @class */ (function () {
    function NtPopoverComponent(_elementRef) {
        this._elementRef = _elementRef;
        this._title = '';
        this.position = NtOverlayPosition.Top;
        this.confirm = new EventEmitter();
        this.cancel = new EventEmitter();
        this.afterOpen = new EventEmitter();
        this.afterClosed = new EventEmitter();
        this.beforeOpen = new EventEmitter();
        this.beforeClosed = new EventEmitter();
        this.positionChange = new EventEmitter();
        this.origin = new CdkOverlayOrigin(this._elementRef);
    }
    Object.defineProperty(NtPopoverComponent.prototype, "title", {
        get: /**
         * @return {?}
         */
        function () { return this._title; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._title = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtPopoverComponent.prototype, "template", {
        get: /**
         * @return {?}
         */
        function () { return this._template; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._template = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtPopoverComponent.prototype, "popover", {
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value instanceof TemplateRef) {
                this._template = value;
            }
            else {
                this._title = value;
                this._template = null;
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} event
     * @return {?}
     */
    NtPopoverComponent.prototype._afterOpen = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.afterOpen.next(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    NtPopoverComponent.prototype._afterClosed = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.afterClosed.next(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    NtPopoverComponent.prototype._beforeOpen = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.beforeOpen.next(event);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    NtPopoverComponent.prototype._beforeClosed = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.beforeClosed.next(event);
    };
    /**
     * @param {?} change
     * @return {?}
     */
    NtPopoverComponent.prototype._positionChange = /**
     * @param {?} change
     * @return {?}
     */
    function (change) {
        this.positionChange.next(change);
    };
    NtPopoverComponent.decorators = [
        { type: Component, args: [{
                    selector: '[nt-popover]',
                    template: "<ng-content></ng-content> <nt-overlay trigger=\"click\" arrow [origin]=\"origin\" [position]=\"position\" (afterOpen)=\"_afterOpen($event)\" (afterClosed)=\"_afterClosed($event)\" (beforeOpen)=\"_beforeOpen($event)\" (beforeClosed)=\"_beforeClosed($event)\" (positionChange)=\"_positionChange($event)\"> <div class=\"nt-popover\"> <div class=\"nt-popover-title\" *ngIf=\"template\"><ng-container *ngTemplateOutlet=\"template\"></ng-container></div> <div class=\"nt-popover-title\" *ngIf=\"!template\" [innerHtml]=\"title\"></div> <div class=\"nt-popover-pane\"> <ng-content select=\"nt-popover-pane\"></ng-content> </div> </div> </nt-overlay> ",
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        '(click)': 'overlay.click()'
                    },
                    providers: [
                        { provide: NT_POPOVER_PARENT_COMPONENT, useExisting: NtPopoverComponent }
                    ]
                },] },
    ];
    /** @nocollapse */
    NtPopoverComponent.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    NtPopoverComponent.propDecorators = {
        title: [{ type: Input }],
        template: [{ type: Input }],
        popover: [{ type: Input, args: ['nt-popover',] }],
        position: [{ type: Input }],
        confirm: [{ type: Output }],
        cancel: [{ type: Output }],
        afterOpen: [{ type: Output }],
        afterClosed: [{ type: Output }],
        beforeOpen: [{ type: Output }],
        beforeClosed: [{ type: Output }],
        positionChange: [{ type: Output }],
        overlay: [{ type: ViewChild, args: [NtOverlayComponent, { static: true },] }]
    };
    return NtPopoverComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtPopoverModule = /** @class */ (function () {
    function NtPopoverModule() {
    }
    NtPopoverModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule, ObserversModule, NtOverlayModule, NtDropdownModule],
                    exports: [NtPopoverComponent, NtPopoverPaneComponent],
                    declarations: [NtPopoverComponent, NtPopoverPaneComponent]
                },] },
    ];
    return NtPopoverModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NtPopoverModule, NtPopoverComponent, NT_POPOVER_PARENT_COMPONENT, NtPopoverPaneComponent };
//# sourceMappingURL=popover.js.map
