import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { Attribute, Component, EventEmitter, Input, Optional, Output, Self, ViewEncapsulation, ChangeDetectionStrategy, ChangeDetectorRef, ContentChildren, isDevMode, NgZone, NgModule } from '@angular/core';
import { NgControl } from '@angular/forms';
import { defer, merge, Subject } from 'rxjs';
import { startWith, switchMap, take, takeUntil } from 'rxjs/operators';
import { NtFormFieldControl } from '@ng-tangram/components/forms';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var uniqueId = 0;
/**
 * @template T
 */
var  /**
 * @template T
 */
NtRadioChange = /** @class */ (function () {
    function NtRadioChange(source, selected) {
        this.source = source;
        this.selected = selected;
    }
    return NtRadioChange;
}());
/**
 * @template T
 */
var NtRadioComponent = /** @class */ (function () {
    function NtRadioComponent(tabIndex, ngControl) {
        this.ngControl = ngControl;
        this.id = "nt-radio-" + uniqueId++;
        this._disabled = false;
        this._readonly = false;
        this._checked = false;
        this._name = this.id;
        this.change = new EventEmitter();
        this._onChange = (/**
         * @return {?}
         */
        function () { });
        this._onTouched = (/**
         * @return {?}
         */
        function () { });
        if (this.ngControl) {
            this.ngControl.valueAccessor = this;
        }
        this.tabIndex = parseInt(tabIndex) || 0;
    }
    Object.defineProperty(NtRadioComponent.prototype, "value", {
        get: /**
         * @return {?}
         */
        function () { return this._value; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._value = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtRadioComponent.prototype, "disabled", {
        get: /**
         * @return {?}
         */
        function () { return this._disabled; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._disabled = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtRadioComponent.prototype, "readonly", {
        get: /**
         * @return {?}
         */
        function () { return this._readonly; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._readonly = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtRadioComponent.prototype, "checked", {
        get: /**
         * @return {?}
         */
        function () { return this._checked; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._checked = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtRadioComponent.prototype, "name", {
        get: /**
         * @return {?}
         */
        function () { return this._name; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._name = value; },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} value
     * @return {?}
     */
    NtRadioComponent.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this._checked = !!value;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NtRadioComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this._onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NtRadioComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this._onTouched = fn;
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    NtRadioComponent.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        this.disabled = isDisabled;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    NtRadioComponent.prototype._onInputClick = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        event.stopPropagation();
    };
    /**
     * @param {?} event
     * @return {?}
     */
    NtRadioComponent.prototype._onInputChange = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        event.stopPropagation();
        this._checked = true;
        this._emitChangeEvent();
    };
    /**
     * @private
     * @return {?}
     */
    NtRadioComponent.prototype._emitChangeEvent = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var event = new NtRadioChange(this, this.checked);
        this._onChange(this.checked);
        this._onTouched();
        this.change.emit(event);
    };
    NtRadioComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-radio',
                    encapsulation: ViewEncapsulation.None,
                    template: "<label class=\"nt-radio-layout\"> <div class=\"nt-radio-input-container\"> <input class=\"cdk-visually-hidden\" type=\"radio\" [name]=\"name\" [tabIndex]=\"tabIndex\" [disabled]=\"disabled\" [checked]=\"checked\" (change)=\"_onInputChange($event)\" (click)=\"_onInputClick($event)\"> <div class=\"nt-radio-input\"></div> </div> <span class=\"nt-radio-label\"> <ng-content></ng-content> </span> </label> ",
                    host: {
                        'class': 'nt-radio',
                        '[class.nt-radio-disabled]': 'disabled'
                    }
                },] },
    ];
    /** @nocollapse */
    NtRadioComponent.ctorParameters = function () { return [
        { type: String, decorators: [{ type: Attribute, args: ['tabindex',] }] },
        { type: NgControl, decorators: [{ type: Self }, { type: Optional }] }
    ]; };
    NtRadioComponent.propDecorators = {
        value: [{ type: Input }],
        disabled: [{ type: Input }],
        readonly: [{ type: Input }],
        checked: [{ type: Input }],
        name: [{ type: Input }],
        change: [{ type: Output }]
    };
    return NtRadioComponent;
}());

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @return {?}
 */
function getNtRdioGroupNonFunctionValueError() {
    return Error('`compareWith` must be a function.');
}
/** @type {?} */
var uniqueId$1 = 0;
/**
 * @template T
 */
var NtRadioGroupComponent = /** @class */ (function (_super) {
    __extends(NtRadioGroupComponent, _super);
    function NtRadioGroupComponent(_ngZone, _changeDetectorRef, ngControl) {
        var _this = _super.call(this) || this;
        _this._ngZone = _ngZone;
        _this._changeDetectorRef = _changeDetectorRef;
        _this.ngControl = ngControl;
        _this.id = "nt-radio-group-" + uniqueId$1++;
        _this._destroy = new Subject();
        _this._disabled = false;
        _this._readonly = false;
        _this._required = false;
        _this._name = _this.id;
        _this._compareWith = (/**
         * @param {?} o1
         * @param {?} o2
         * @return {?}
         */
        function (o1, o2) { return o1 === o2; });
        _this.checkedChanges = defer((/**
         * @return {?}
         */
        function () {
            if (_this.radios) {
                return merge.apply(void 0, _this.radios.map((/**
                 * @param {?} item
                 * @return {?}
                 */
                function (item) { return item.change; })));
            }
            return _this._ngZone.onStable
                .asObservable()
                .pipe(take(1), switchMap((/**
             * @return {?}
             */
            function () { return _this.checkedChanges; })));
        }));
        /**
         * Emits when the value changes (either due to user input or programmatic change).
         */
        _this._onChange = (/**
         * @return {?}
         */
        function () { });
        _this._onTouched = (/**
         * @return {?}
         */
        function () { });
        if (_this.ngControl) {
            _this.ngControl.valueAccessor = _this;
        }
        return _this;
    }
    Object.defineProperty(NtRadioGroupComponent.prototype, "value", {
        get: /**
         * @return {?}
         */
        function () { return this._value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtRadioGroupComponent.prototype, "disabled", {
        get: /**
         * @return {?}
         */
        function () { return this._disabled; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._disabled = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtRadioGroupComponent.prototype, "required", {
        get: /**
         * @return {?}
         */
        function () { return this._required; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._required = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtRadioGroupComponent.prototype, "readonly", {
        get: /**
         * @return {?}
         */
        function () { return this._readonly; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._readonly = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtRadioGroupComponent.prototype, "name", {
        get: /**
         * @return {?}
         */
        function () { return this._name; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._name = value;
            this._updateRadioButtonNames();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtRadioGroupComponent.prototype, "compareWith", {
        set: /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            if (typeof fn !== 'function') {
                throw getNtRdioGroupNonFunctionValueError();
            }
            else {
                this._compareWith = fn;
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NtRadioGroupComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.radios.changes.pipe(startWith(null), takeUntil(this._destroy)).subscribe((/**
         * @return {?}
         */
        function () {
            _this._resetRadios();
            _this._initializeChecked();
        }));
    };
    /**
     * @return {?}
     */
    NtRadioGroupComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this._destroy.next();
        this._destroy.complete();
    };
    /**
     * @param {?} value
     * @return {?}
     */
    NtRadioGroupComponent.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        if (this.radios) {
            this._setCheckedByValue(value);
        }
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NtRadioGroupComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this._onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NtRadioGroupComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this._onTouched = fn;
    };
    /**
     * @return {?}
     */
    NtRadioGroupComponent.prototype.focus = /**
     * @return {?}
     */
    function () {
        if (!this.disabled) {
            this._onTouched();
        }
    };
    /**
     * @private
     * @return {?}
     */
    NtRadioGroupComponent.prototype._initializeChecked = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        Promise.resolve().then((/**
         * @return {?}
         */
        function () {
            _this._updateRadioButtonNames();
            _this._setCheckedByValue(_this.ngControl ? _this.ngControl.value : _this.value);
        }));
    };
    /**
     * @private
     * @return {?}
     */
    NtRadioGroupComponent.prototype._resetRadios = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var changedOrDestroyed = merge(this.radios.changes, this._destroy);
        this.checkedChanges.pipe(takeUntil(changedOrDestroyed)).subscribe((/**
         * @param {?} change
         * @return {?}
         */
        function (change) {
            _this._setValues(change.source);
        }));
        merge.apply(void 0, this.radios.map((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return item.change; }))).pipe(takeUntil(changedOrDestroyed))
            .subscribe((/**
         * @return {?}
         */
        function () {
            _this._changeDetectorRef.markForCheck();
        }));
    };
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    NtRadioGroupComponent.prototype._setCheckedByValue = /**
     * @private
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this._value = value;
        this.radios.forEach((/**
         * @param {?} item
         * @return {?}
         */
        function (item) { return item.checked = false; }));
        this._checkedValue(value);
        this._changeDetectorRef.markForCheck();
    };
    /**
     * @private
     * @param {?} value
     * @return {?}
     */
    NtRadioGroupComponent.prototype._checkedValue = /**
     * @private
     * @param {?} value
     * @return {?}
     */
    function (value) {
        var _this = this;
        /** @type {?} */
        var correspondingItem = this.radios.find((/**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            try {
                return item.value != null && _this._compareWith(item.value, value);
            }
            catch (error) {
                if (isDevMode()) {
                    console.warn(error);
                }
                return false;
            }
        }));
        if (correspondingItem) {
            correspondingItem.checked = true;
        }
        return correspondingItem;
    };
    /**
     * @private
     * @param {?} radio
     * @return {?}
     */
    NtRadioGroupComponent.prototype._setValues = /**
     * @private
     * @param {?} radio
     * @return {?}
     */
    function (radio) {
        this._value = radio.value;
        this._onChange(this._value);
        this._onTouched();
        this._changeDetectorRef.markForCheck();
    };
    /**
     * @private
     * @return {?}
     */
    NtRadioGroupComponent.prototype._updateRadioButtonNames = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.radios) {
            this.radios.forEach((/**
             * @param {?} radio
             * @return {?}
             */
            function (radio) {
                radio.name = _this.name;
            }));
        }
    };
    NtRadioGroupComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-radio-group',
                    template: '<ng-content></ng-content>',
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    providers: [
                        { provide: NtFormFieldControl, useExisting: NtRadioGroupComponent }
                    ],
                    host: {
                        'class': 'nt-radio-group'
                    }
                },] },
    ];
    /** @nocollapse */
    NtRadioGroupComponent.ctorParameters = function () { return [
        { type: NgZone },
        { type: ChangeDetectorRef },
        { type: NgControl, decorators: [{ type: Self }, { type: Optional }] }
    ]; };
    NtRadioGroupComponent.propDecorators = {
        disabled: [{ type: Input }],
        required: [{ type: Input }],
        readonly: [{ type: Input }],
        name: [{ type: Input }],
        radios: [{ type: ContentChildren, args: [NtRadioComponent,] }],
        compareWith: [{ type: Input }]
    };
    return NtRadioGroupComponent;
}(NtFormFieldControl));

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtRadioModule = /** @class */ (function () {
    function NtRadioModule() {
    }
    NtRadioModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    exports: [NtRadioComponent, NtRadioGroupComponent],
                    declarations: [NtRadioComponent, NtRadioGroupComponent],
                },] },
    ];
    return NtRadioModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NtRadioChange, NtRadioComponent, getNtRdioGroupNonFunctionValueError, NtRadioGroupComponent, NtRadioModule };
//# sourceMappingURL=radio.js.map
