import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { transition, trigger } from '@angular/animations';
import { Component, Input, ViewEncapsulation, ComponentFactoryResolver, Directive, ElementRef, Inject, PLATFORM_ID, Renderer2, ViewContainerRef, NgModule } from '@angular/core';
import { fadeIn, fadeOut } from '@ng-tangram/components/core';
import { isPlatformBrowser, CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtScrimComponent = /** @class */ (function () {
    function NtScrimComponent() {
        this._isOpen = false;
        this.text = '';
    }
    Object.defineProperty(NtScrimComponent.prototype, "isOpen", {
        get: /**
         * @return {?}
         */
        function () { return this._isOpen; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._isOpen = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    NtScrimComponent.decorators = [
        { type: Component, args: [{
                    selector: '[nt-scrim], nt-scrim',
                    template: "<div class=\"nt-scrim\" *ngIf=\"isOpen\" [@fade]> <div class=\"nt-scrim-animation\"> <div class=\"nt-scrim-loading\"></div> </div> <h3 class=\"nt-scrim-text\">{{ text }}</h3> </div> ",
                    encapsulation: ViewEncapsulation.None,
                    animations: [
                        trigger('fade', [
                            transition('void => *', fadeIn(.15)),
                            transition('* => void', fadeOut(.15))
                        ])
                    ]
                },] },
    ];
    /** @nocollapse */
    NtScrimComponent.ctorParameters = function () { return []; };
    NtScrimComponent.propDecorators = {
        text: [{ type: Input }]
    };
    return NtScrimComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtScrimDirective = /** @class */ (function () {
    function NtScrimDirective(platformId, _elementRef, _renderer, _componentFactoryResolver, _viewContainerRef) {
        this.platformId = platformId;
        this._elementRef = _elementRef;
        this._renderer = _renderer;
        this._componentFactoryResolver = _componentFactoryResolver;
        this._viewContainerRef = _viewContainerRef;
        /** @type {?} */
        var componentFactory = this._componentFactoryResolver.resolveComponentFactory(NtScrimComponent);
        this._componentRef = this._viewContainerRef.createComponent(componentFactory);
        if (isPlatformBrowser(this.platformId)) {
            /** @type {?} */
            var style = window.getComputedStyle(this._elementRef.nativeElement);
            if (style.position !== 'absolute' || style.position !== 'absolute') {
                this._renderer.setStyle(this._elementRef.nativeElement, 'position', 'relative');
            }
            this._renderer.appendChild(this._elementRef.nativeElement, this._componentRef.location.nativeElement);
        }
    }
    Object.defineProperty(NtScrimDirective.prototype, "text", {
        // @ContentChild(NtScrimComponent) component: NtScrimComponent;
        set: 
        // @ContentChild(NtScrimComponent) component: NtScrimComponent;
        /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._componentRef.instance.text = value; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtScrimDirective.prototype, "scrim", {
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) { this._componentRef.instance.isOpen = coerceBooleanProperty(value); },
        enumerable: true,
        configurable: true
    });
    /**
     * @return {?}
     */
    NtScrimDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (isPlatformBrowser(this.platformId)) {
            this._renderer.removeChild(this._elementRef.nativeElement, this._componentRef.location.nativeElement);
            this._componentRef.destroy();
        }
    };
    NtScrimDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ntScrim]'
                },] },
    ];
    /** @nocollapse */
    NtScrimDirective.ctorParameters = function () { return [
        { type: Object, decorators: [{ type: Inject, args: [PLATFORM_ID,] }] },
        { type: ElementRef },
        { type: Renderer2 },
        { type: ComponentFactoryResolver },
        { type: ViewContainerRef }
    ]; };
    NtScrimDirective.propDecorators = {
        text: [{ type: Input, args: ['scrimText',] }],
        scrim: [{ type: Input, args: ['ntScrim',] }]
    };
    return NtScrimDirective;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtScrimModule = /** @class */ (function () {
    function NtScrimModule() {
    }
    NtScrimModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    entryComponents: [NtScrimComponent],
                    exports: [NtScrimComponent, NtScrimDirective],
                    declarations: [NtScrimComponent, NtScrimDirective]
                },] },
    ];
    return NtScrimModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NtScrimModule, NtScrimComponent, NtScrimDirective };
//# sourceMappingURL=scrim.js.map
