import { ChangeDetectionStrategy, Component, Input, ViewEncapsulation, ChangeDetectorRef, Attribute, Self, Optional, Output, EventEmitter, NgModule } from '@angular/core';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { NgControl } from '@angular/forms';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var uniqueId = 0;
/**
 * @template T
 */
var  /**
 * @template T
 */
NtSwitchChange = /** @class */ (function () {
    function NtSwitchChange(source, checked) {
        this.source = source;
        this.checked = checked;
    }
    return NtSwitchChange;
}());
/**
 * @template T
 */
var NtSwitchComponent = /** @class */ (function () {
    function NtSwitchComponent(_changeDetectorRef, tabIndex, ngControl) {
        this._changeDetectorRef = _changeDetectorRef;
        this.ngControl = ngControl;
        this.id = "nt-switch-" + uniqueId++;
        this._disabled = false;
        this._checked = false;
        this._circle = false;
        this.change = new EventEmitter();
        this._onChange = (/**
         * @return {?}
         */
        function () { });
        this._onTouched = (/**
         * @return {?}
         */
        function () { });
        if (this.ngControl) {
            this.ngControl.valueAccessor = this;
        }
        this.tabIndex = parseInt(tabIndex) || 0;
    }
    Object.defineProperty(NtSwitchComponent.prototype, "disabled", {
        get: /**
         * @return {?}
         */
        function () { return this._disabled; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value !== this.disabled) {
                this._disabled = coerceBooleanProperty(value);
                this._changeDetectorRef.markForCheck();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtSwitchComponent.prototype, "checked", {
        get: /**
         * @return {?}
         */
        function () { return this._checked; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value !== this.checked) {
                this._checked = coerceBooleanProperty(value);
                this._changeDetectorRef.markForCheck();
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NtSwitchComponent.prototype, "circle", {
        get: /**
         * @return {?}
         */
        function () { return this._circle; },
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (value !== this.circle) {
                this._circle = coerceBooleanProperty(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} value
     * @return {?}
     */
    NtSwitchComponent.prototype.writeValue = /**
     * @param {?} value
     * @return {?}
     */
    function (value) {
        this._checked = !!value;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NtSwitchComponent.prototype.registerOnChange = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this._onChange = fn;
    };
    /**
     * @param {?} fn
     * @return {?}
     */
    NtSwitchComponent.prototype.registerOnTouched = /**
     * @param {?} fn
     * @return {?}
     */
    function (fn) {
        this._onTouched = fn;
    };
    /**
     * @param {?} isDisabled
     * @return {?}
     */
    NtSwitchComponent.prototype.setDisabledState = /**
     * @param {?} isDisabled
     * @return {?}
     */
    function (isDisabled) {
        this.disabled = isDisabled;
    };
    /**
     * @param {?} event
     * @return {?}
     */
    NtSwitchComponent.prototype._onInputClick = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        event.stopPropagation();
        if (!this.disabled) {
            this._checked = !this._checked;
            this._onTouched();
            this._emitChangeEvent();
        }
    };
    /**
     * @param {?} event
     * @return {?}
     */
    NtSwitchComponent.prototype._onInteractionEvent = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        // We always have to stop propagation on the change event.
        // Otherwise the change event, from the input element, will bubble up and
        // emit its event object to the `change` output.
        event.stopPropagation();
    };
    /**
     * @private
     * @return {?}
     */
    NtSwitchComponent.prototype._emitChangeEvent = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var event = new NtSwitchChange(this, this.checked);
        this._onChange(this.checked);
        this.change.emit(event);
    };
    NtSwitchComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nt-switch',
                    template: "<input class=\"switch-input\" type=\"checkbox\" [attr.id]=\"id\" [tabIndex]=\"tabIndex\" [checked]=\"checked\" [disabled]=\"disabled\" (change)=\"_onInteractionEvent($event)\" (click)=\"_onInputClick($event)\"> <label class=\"switch-paddle\" [attr.for]=\"id\"></label> ",
                    encapsulation: ViewEncapsulation.None,
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    host: {
                        'class': 'switch nt-switch',
                        '[class.nt-switch-checked]': 'checked',
                        '[class.nt-switch-disabled]': 'disabled',
                        '[class.nt-switch-circle]': 'circle'
                    }
                },] },
    ];
    /** @nocollapse */
    NtSwitchComponent.ctorParameters = function () { return [
        { type: ChangeDetectorRef },
        { type: String, decorators: [{ type: Attribute, args: ['tabindex',] }] },
        { type: NgControl, decorators: [{ type: Self }, { type: Optional }] }
    ]; };
    NtSwitchComponent.propDecorators = {
        disabled: [{ type: Input }],
        checked: [{ type: Input }],
        circle: [{ type: Input }],
        change: [{ type: Output }]
    };
    return NtSwitchComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NtSwitchModule = /** @class */ (function () {
    function NtSwitchModule() {
    }
    NtSwitchModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    exports: [NtSwitchComponent],
                    declarations: [NtSwitchComponent]
                },] },
    ];
    return NtSwitchModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NtSwitchChange, NtSwitchComponent, NtSwitchModule };
//# sourceMappingURL=switch.js.map
