import { Subscription } from 'rxjs';
import { ElementRef, EventEmitter, OnInit } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
import { NtUploadFile, NtUploadHandler } from '@ng-tangram/components/core';
import { NtFormFieldControl } from '@ng-tangram/components/forms';
import { NtFileError } from './file-errors';
import { NtFileIcons } from './file-icons';
export declare class NtFile extends NtUploadFile {
    id: string;
    progress?: number;
    uploader?: Subscription;
}
export declare class NtFileComponent extends NtFormFieldControl<NtFile[]> implements OnInit, ControlValueAccessor {
    ngControl: NgControl;
    private _uploader;
    icons: NtFileIcons;
    private readonly _destroy;
    files: NtFile[];
    private _value;
    readonly value: NtFile[];
    private _disabled;
    disabled: boolean;
    private _required;
    required: boolean;
    private _accept;
    accept: string | Array<string>;
    private _maxSize;
    maxSize: number;
    private _maxFiles;
    maxFiles: number;
    private _autoupload;
    autoupload: boolean;
    url: string;
    name: string;
    fileElement: ElementRef;
    error: EventEmitter<NtFileError>;
    remove: EventEmitter<NtFile>;
    private _onChange;
    private _onTouched;
    constructor(ngControl: NgControl, _uploader: NtUploadHandler, icons: NtFileIcons);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onTriggerClick(): void;
    writeValue(value: NtFile[]): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    _fileChanged(): void;
    removeFile(file: NtFile): void;
    setDisabledState(isDisabled: boolean): void;
    getFileIcon(file: NtFile): any;
    private _fileTypeValid;
    private _fileSizeValid;
    private _onUploadBegin;
    private _onUploadProgress;
    private _onUploadDone;
}
