import { AfterContentInit, QueryList } from '@angular/core';
export declare type NtMenuAlign = '' | 'center' | 'right';
export declare type NtMenuOrientation = '' | 'horizontal' | 'vertical';
export declare class NtMenuComponent implements AfterContentInit {
    private _simple;
    private _expanded;
    private _nested;
    private _align;
    /**
     * 定义此属性是为了避免内部的动态样式 class 和外部设置的值起冲突，所以用此属性接收外部的值并且合并 class 来避免这个问题。
     *
     * TODO: 官方会在 Ivy Renderer 中修复这个问题，预计会在 Angular 9.0。
     * 有关此问题的Issue: https://github.com/angular/angular/issues/7289
     * @deprecated > 0.6.0
     */
    class: string;
    simple: boolean;
    expanded: boolean;
    nested: boolean;
    align: NtMenuAlign;
    orientation: NtMenuOrientation;
    childMenus: QueryList<NtMenuComponent>;
    constructor();
    ngAfterContentInit(): void;
}
