import { Subscription } from 'rxjs';
import { ElementRef, EventEmitter, OnInit, TemplateRef } from '@angular/core';
import { ControlValueAccessor, NgControl } from '@angular/forms';
import { NtUploadFile, NtUploadHandler } from '@ng-tangram/components/core';
import { NtFormFieldControl } from '@ng-tangram/components/forms';
import { NtModal } from '@ng-tangram/components/modal';
import { NtPictureError } from './picture-errors';
import { NtPictureIcons } from './picture-icons';
/**
 * 压缩图片
 */
export declare function zipImage(file: File, option?: any): Promise<any>;
export declare const NT_PICTURE_ACCEPTS: string[];
export declare class NtPicture extends NtUploadFile {
    id: string;
    progress?: number;
    uploader?: Subscription;
    thumbnail: string;
}
export declare class NtPictureComponent extends NtFormFieldControl<NtPicture[]> implements OnInit, ControlValueAccessor {
    private _modal;
    ngControl: NgControl;
    private _uploader;
    icons: NtPictureIcons;
    private readonly _destroy;
    private _accept;
    files: NtPicture[];
    private _value;
    readonly value: NtPicture[];
    private _disabled;
    disabled: boolean;
    private _readonly;
    readonly: boolean;
    private _required;
    required: boolean;
    accept: string | Array<string>;
    private _maxSize;
    maxSize: number;
    private _maxFiles;
    maxFiles: number;
    private _autoupload;
    autoupload: boolean;
    url: string;
    name: string;
    type: '' | 'circle' | 'square';
    fileElement: ElementRef;
    previewTemplate: TemplateRef<any>;
    error: EventEmitter<NtPictureError>;
    remove: EventEmitter<NtPicture>;
    private _onChange;
    private _onTouched;
    constructor(_modal: NtModal, ngControl: NgControl, _uploader: NtUploadHandler, icons: NtPictureIcons);
    ngOnInit(): void;
    ngOnDestroy(): void;
    onTriggerClick(): void;
    writeValue(value: NtPicture[]): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    _fileChanged(): Promise<void>;
    removeFile(file: NtPicture): void;
    preview(file: NtPicture): void;
    setDisabledState(isDisabled: boolean): void;
    private _fileTypeValid;
    private _fileSizeValid;
    private _onUploadBegin;
    private _onUploadProgress;
    private _onUploadDone;
}
