import { CdkCell, CdkCellDef, CdkColumnDef, CdkFooterCell, CdkFooterCellDef, CdkHeaderCell, CdkHeaderCellDef } from '@angular/cdk/table';
import { ElementRef, EventEmitter } from '@angular/core';
export declare enum NtColumnSort {
    ASC = "asc",
    DESC = "desc",
    NONE = ""
}
export declare class NtColumnSortChange {
    isUserInput: boolean;
    column: string;
    sort: string;
    constructor(isUserInput: boolean, column: string, sort: string);
}
/**
 * table 列单元格定义指令
 * @description ntColumnCellDef 将在 > 0.5.x 版本中弃用
 */
export declare class NtCellDefDirective extends CdkCellDef {
}
/**
 * table 头部单元格定义指令
 * @description ntColumnHeaderDef 将在 > 0.5.x 版本中弃用
 */
export declare class NtHeaderCellDefDirective extends CdkHeaderCellDef {
}
/**
 * table 底部单元格定义指令
 * @description ntColumnFooterDef 将在 > 0.5.x 版本中弃用
 */
export declare class NtFooterCellDefDirective extends CdkFooterCellDef {
}
/**
 * table 列定义指令
 */
export declare class NtColumnDirective extends CdkColumnDef {
    private _sortable;
    sort: NtColumnSort;
    ntColumn: string;
    name: string;
    sticky: boolean;
    stickyEnd: boolean;
    sortable: boolean;
    _sortChange: EventEmitter<NtColumnSortChange>;
    /** 排序操作 */
    sorting(isUserInput?: boolean): void;
}
/**
 * table 头部单元格结构指令
 * @description nt-column-header 将在 > 0.5.x 版本中弃用
 * */
export declare class NtHeaderCellDirective extends CdkHeaderCell {
    columnDef: CdkColumnDef;
    constructor(columnDef: CdkColumnDef, elementRef: ElementRef<HTMLElement>);
}
/**
 * table 底部单元格结构指令
 * @description nt-column-footer 将在 > 0.5.x 版本中弃用
 * */
export declare class NtFooterCellDirective extends CdkFooterCell {
    constructor(columnDef: CdkColumnDef, elementRef: ElementRef);
}
/**
 * table 单元格结构指令
 * @description nt-column-cell 将在 > 0.5.x 版本中弃用
 */
export declare class NtCellDirective extends CdkCell {
    constructor(columnDef: CdkColumnDef, elementRef: ElementRef<HTMLElement>);
}
